//------------------------------------------------------
// module  : Function.cc
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "Function.h"

//--------------------------//
//-- Matrice de Caractere --//
//--------------------------//
//----------------------------------------------------------
// alloue de la memoire pour une matrice 2d de caracteres
//----------------------------------------------------------
unsigned char** cmatrix_allocate_2d(int vsize,int hsize)
 {
  unsigned char** matrix;
  unsigned char* imptr;

  matrix=new unsigned char*[vsize];
  imptr=new unsigned char[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de caracteres
//----------------------------------------------------------
void free_cmatrix_2d(unsigned char** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//--------------------------//
//-- Matrice de Double -----//
//--------------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de double
//----------------------------------------------------------
double* dmatrix_allocate_1d(int hsize)
 {
  double* matrix;
  matrix=new double[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de double
//----------------------------------------------------------
double** dmatrix_allocate_2d(int vsize,int hsize)
 {
  double** matrix;
  double *imptr;

  matrix=new double*[vsize];
  imptr=new  double[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de double
//----------------------------------------------------------
double*** dmatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  double*** matrix;

  matrix=new double**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=dmatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//--------------------------//
//-- Matrice de Flottant --//
//--------------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de float
//----------------------------------------------------------
float* fmatrix_allocate_1d(int hsize)
 {
  float* matrix;
  matrix=new float[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de float
//----------------------------------------------------------
float** fmatrix_allocate_2d(int vsize,int hsize)
 {
  float** matrix;
  float *imptr;

  matrix=new float*[vsize];
  imptr=new  float[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de float
//----------------------------------------------------------
float*** fmatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  float*** matrix;

  matrix=new float**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=fmatrix_allocate_2d(vsize,hsize);
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 4d de float
//----------------------------------------------------------
float**** fmatrix_allocate_4d(int fsize,int dsize,int vsize,int hsize)
 {
  float**** matrix;

  matrix=new float***[fsize];

  for(int i=0;i<fsize;i++)
    matrix[i]=fmatrix_allocate_3d(dsize,vsize,hsize);
  return matrix;
 }

//-----------------------//
//-- Matrice d'Entiers --//
//-----------------------//
//---------------------------------------------------------
//  alloue de la memoire pour une matrice 1d de int
//----------------------------------------------------------
int* imatrix_allocate_1d(int hsize)
 {
  int* matrix;
  matrix=new int[hsize]; return matrix; }

//----------------------------------------------------------
//  alloue de la memoire pour une matrice 2d de int
//----------------------------------------------------------
int** imatrix_allocate_2d(int vsize,int hsize)
 {
  int** matrix;
  int*  imptr;

  matrix=new int*[vsize];
  imptr=new  int[(hsize)*(vsize)];
  for(int i=0;i<vsize;i++,imptr+=hsize) matrix[i]=imptr;
  return matrix;
 }

//----------------------------------------------------------
// alloue de la memoire pour une matrice 3d de int
//----------------------------------------------------------
int*** imatrix_allocate_3d(int dsize,int vsize,int hsize)
 {
  int*** matrix;

  matrix=new int**[dsize];

  for(int i=0;i<dsize;i++)
    matrix[i]=imatrix_allocate_2d(vsize,hsize);
  return matrix;
 }


//---------------------------//
//--- Liberation Memoire ----//
//---------------------------//
//----------------------------------------------------------
// libere la memoire de la matrice 1d de double
//----------------------------------------------------------
void free_dmatrix_1d(double* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de double
//----------------------------------------------------------
void free_dmatrix_2d(double** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de double
//----------------------------------------------------------
void free_dmatrix_3d(double*** pmat,int dsize)
{
 for(int i=0;i<dsize;i++)
  {
   delete[] (pmat[i][0]);
   delete[] (pmat[i]);
   }
 delete[] (pmat);
}
//----------------------------------------------------------
// libere la memoire de la matrice 1d de float
//----------------------------------------------------------
void free_fmatrix_1d(float* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de float
//----------------------------------------------------------
void free_fmatrix_2d(float** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de float
//----------------------------------------------------------
void free_fmatrix_3d(float*** pmat,int dsize)
{
 for(int i=0;i<dsize;i++)
  {
   delete[] (pmat[i][0]);
   delete[] (pmat[i]);
   }
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 4d de float
//----------------------------------------------------------
void free_fmatrix_4d(float**** pmat,int fsize,int dsize)
{
 for(int i=0;i<fsize;i++)
  free_fmatrix_3d(pmat[i],dsize);
  
 delete[] (pmat);
}

//----------------------------------------------------------
// libere la memoire de la matrice 1d de int
//----------------------------------------------------------
void free_imatrix_1d(int* pmat)
{ delete[] pmat; }

//----------------------------------------------------------
// libere la memoire de la matrice 2d de int
//----------------------------------------------------------
void free_imatrix_2d(int** pmat)
{ delete[] (pmat[0]);
  delete[] pmat;}

//----------------------------------------------------------
// libere la memoire de la matrice 3d de int
//----------------------------------------------------------
void free_imatrix_3d(int*** pmat,int dsize)
{ for(int i=0;i<dsize;i++)
   {
    delete[] (pmat[i][0]);
    delete[] (pmat[i]);
    }
  delete[] (pmat); }


//-------------//
//-- Gestion --//
//-------------//
/*----------------------------------------------------------*/
/* Recal                                                    */
/*----------------------------------------------------------*/
void Recal(float** mat,int lgth,int wdth)
{
 int i,j;
 float max,min;

 /*Initialisation*/
 max=-1000000.0;
 min=100000000;

 /*Recherche du min*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if (mat[i][j]<min) min=mat[i][j];

 /*plus min*/
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat[i][j]-=min;

 /*Recherche du max*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    if (mat[i][j]>max) max=mat[i][j];

 /*Affichage*/
 printf(" [Min: %.1f -- Max: %.1f]\n",min,max);

 /*Recalibre la matrice*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   mat[i][j]*=(GREY_LEVEL/max);      
}

/*----------------------------------------------------------*/
/* Recal                                                    */
/*----------------------------------------------------------*/
void RecalS(float** mat,int lgth,int wdth)
{
 int i,j;
 float max,min;

 /*Initialisation*/
 max=-1000000.0;
 min=100000000;

 /*Recherche du min*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if (mat[i][j]<min) min=mat[i][j];

 /*plus min*/
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat[i][j]-=min;

 /*Recherche du max*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    if (mat[i][j]>max) max=mat[i][j];

 /*Recalibre la matrice*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   mat[i][j]*=(GREY_LEVEL/max);      
}

/*----------------------------------------------------------*/
/* Recal                                                    */
/*----------------------------------------------------------*/
void RecalS(float*** mat,int dpth,int lgth,int wdth)
{
  int i,j,k;
 float max,min;

 /*Initialisation*/
 max=-1000000.0;
 min=100000000;

 /*Recherche du min*/
  for(k=0;k<dpth;k++)
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if (mat[k][i][j]<min) min=mat[k][i][j];

 /*plus min*/
   for(k=0;k<dpth;k++)
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat[k][i][j]-=min;

 /*Recherche du max*/
  for(k=0;k<dpth;k++)
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    if (mat[k][i][j]>max) max=mat[k][i][j];

 /*Recalibre la matrice*/
 for(k=0;k<dpth;k++)
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   mat[k][i][j]*=(GREY_LEVEL/max);      
}

/*----------------------------------------------------------*/
/*  MaxMin                                                  */
/*----------------------------------------------------------*/
void MaxMin(float** mat,int sz)
{
 
 for(int i=0;i<sz;i++) for(int j=0;j<sz;j++)
   { if (mat[i][j]<0)    mat[i][j]=0.0;
     if (mat[i][j]>255)  mat[i][j]=255.0; }
}

//----------------------------------------------------------
// copy_matrix
//----------------------------------------------------------
void copy_matrix(float** mat1,float** mat2,int lgth,int wdth)
{
 int i,j;

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   mat1[i][j]=mat2[i][j]; 
}

//------------------------------------------------
// retourne un nombre aleatoire entre    
//         zero et un                    
//------------------------------------------------
float randomize2(void)
{ 
  return(genrand());
  //return ((float)rand()/RAND_MAX); 
}

//----------------------------------------------------------
// retourne un nombre aleatoire entre 
//             0 et c (floatant)
//----------------------------------------------------------
float random_flo(float c)
{ 
  return (randomize2()*c); 
}

static unsigned long mt[NN]; /* the array for the state vector  */
static int mti=NN+1; /* mti==N+1 means mt[N] is not initialized */

//----------------------------------------------------------
// sgenrand
//----------------------------------------------------------
/* initializing the array with a NONZERO seed */
void sgenrand(unsigned long seed)
{
  /* setting initial seeds to mt[N] using         */
  /* the generator Line 25 of Table 1 in          */
  /* [KNUTH 1981, The Art of Computer Programming */
  /*    Vol. 2 (2nd Ed.), pp102]                  */
  mt[0]= seed & 0xffffffff;
  for (mti=1; mti<NN; mti++)
    mt[mti] = (69069 * mt[mti-1]) & 0xffffffff;
}

//----------------------------------------------------------
// genrand
//----------------------------------------------------------
/* generating reals */
/* unsigned long */ /* for integer generation */
double genrand()
{
  unsigned long y;
  static unsigned long mag01[2]={0x0, MATRIX_A};
  /* mag01[x] = x * MATRIX_A  for x=0,1 */

  if (mti >= NN) { /* generate N words at one time */
    int kk;

    if (mti == NN+1)   /* if sgenrand() has not been called, */
      sgenrand(4357); /* a default initial seed is used   */

    for (kk=0;kk<NN-MM;kk++) {
      y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
      mt[kk] = mt[kk+MM] ^ (y >> 1) ^ mag01[y & 0x1];
    }
    for (;kk<NN-1;kk++) {
      y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
      mt[kk] = mt[kk+(MM-NN)] ^ (y >> 1) ^ mag01[y & 0x1];
    }
    y = (mt[NN-1]&UPPER_MASK)|(mt[0]&LOWER_MASK);
    mt[NN-1] = mt[MM-1] ^ (y >> 1) ^ mag01[y & 0x1];

    mti = 0;
  }
  
  y = mt[mti++];
  y ^= TEMPERING_SHIFT_U(y);
  y ^= TEMPERING_SHIFT_S(y) & TEMPERING_MASK_B;
  y ^= TEMPERING_SHIFT_T(y) & TEMPERING_MASK_C;
  y ^= TEMPERING_SHIFT_L(y);

  return ( (double)y / (unsigned long)0xffffffff ); /* reals */
  /* return y; */ /* for integer generation */
}

/*-----------------*/
/* FOURIER ND -----*/
/*-----------------*/
/*------------------------------------------------*/
/*  FOURN ----------------------------------------*/
/*------------------------------------------------*/
void fourn(float data[], unsigned long nn[], int ndim, int isign)
{
	int idim;
	unsigned long i1,i2,i3,i2rev,i3rev,ip1,ip2,ip3,ifp1,ifp2;
	unsigned long ibit,k1,k2,n,nprev,nrem,ntot;
	float tempi,tempr;
	double theta,wi,wpi,wpr,wr,wtemp;
        float temp;

	for (ntot=1,idim=1;idim<=ndim;idim++)
		ntot *= nn[idim];
	nprev=1;
	for (idim=ndim;idim>=1;idim--) {
		n=nn[idim];
		nrem=ntot/(n*nprev);
		ip1=nprev << 1;
		ip2=ip1*n;
		ip3=ip2*nrem;
		i2rev=1;
		for (i2=1;i2<=ip2;i2+=ip1) {
			if (i2 < i2rev) {
				for (i1=i2;i1<=i2+ip1-2;i1+=2) {
					for (i3=i1;i3<=ip3;i3+=ip2) {
						i3rev=i2rev+i3-i2;
                                                { temp=data[i3]; data[i3]=data[i3rev]; data[i3rev]=temp; }
						{ temp=data[i3+1]; data[i3+1]=data[i3rev+1]; data[i3rev+1]=temp; }
					}
				}
			}
			ibit=ip2 >> 1;
			while (ibit >= ip1 && i2rev > ibit) {
				i2rev -= ibit;
				ibit >>= 1;
			}
			i2rev += ibit;
		}
		ifp1=ip1;
		while (ifp1 < ip2) {
			ifp2=ifp1 << 1;
			theta=isign*6.28318530717959/(ifp2/ip1);
			wtemp=sin(0.5*theta);
			wpr = -2.0*wtemp*wtemp;
			wpi=sin(theta);
			wr=1.0;
			wi=0.0;
			for (i3=1;i3<=ifp1;i3+=ip1) {
				for (i1=i3;i1<=i3+ip1-2;i1+=2) {
					for (i2=i1;i2<=ip3;i2+=ifp2) {
						k1=i2;
						k2=k1+ifp1;
						tempr=(float)wr*data[k2]-(float)wi*data[k2+1];
						tempi=(float)wr*data[k2+1]+(float)wi*data[k2];
						data[k2]=data[k1]-tempr;
						data[k2+1]=data[k1+1]-tempi;
						data[k1] += tempr;
						data[k1+1] += tempi;
					}
				}
				wr=(wtemp=wr)*wpr-wi*wpi+wr;
				wi=wi*wpr+wtemp*wpi+wi;
			}
			ifp1=ifp2;
		}
		nprev *= n;
	}
}

/*-----------------*/
/* FOURIER 3D -----*/
/*-----------------*/
//------------------------------------------------//
//  FOURN                                         //
//                                                //
// long nn[dimz]dimy[][dimx]                      //
//        z,y,x puissance de 2                    //
//                                                //
//           +1 direct                            //
//           -1 inverse                           //
//                                                //
//------------------------------------------------//
void fourn2(float*** dtr,float*** dti,int nn[],int ndim,int isign)
{
        int i,j,k;
        int cpt;

	int idim;
	unsigned long i1,i2,i3,i2rev,i3rev,ip1,ip2,ip3,ifp1,ifp2;
	unsigned long ibit,k1,k2,n,nprev,nrem,ntot;
	float tempi,tempr;
	double theta,wi,wpi,wpr,wr,wtemp;
        float temp;
        
        float* data;

        //Preparation
        //-----------
        data=fmatrix_allocate_1d((2*(nn[1]*nn[2]*nn[3]))+1); 
        for(k=0;k<((2*(nn[1]*nn[2]*nn[3]))+1 );k++) data[k]=0.0;
         
        cpt=1;
	for(k=0;k<nn[1];k++)
           for(i=0;i<nn[2];i++)
             for(j=0;j<nn[3];j++)
	        { data[cpt++]=dtr[k][i][j];
		  data[cpt++]=dti[k][i][j]; }

        //-----------------------------------
	//  -> ALGO FFT ND
        //-----------------------------------
	for (ntot=1,idim=1;idim<=ndim;idim++)
		ntot *= nn[idim];
	nprev=1;
	for (idim=ndim;idim>=1;idim--) {
		n=nn[idim];
		nrem=ntot/(n*nprev);
		ip1=nprev << 1;
		ip2=ip1*n;
		ip3=ip2*nrem;
		i2rev=1;
		for (i2=1;i2<=ip2;i2+=ip1) {
			if (i2 < i2rev) {
				for (i1=i2;i1<=i2+ip1-2;i1+=2) {
					for (i3=i1;i3<=ip3;i3+=ip2) {
						i3rev=i2rev+i3-i2;
                                                { temp=data[i3]; data[i3]=data[i3rev]; data[i3rev]=temp; }
						{ temp=data[i3+1]; data[i3+1]=data[i3rev+1]; data[i3rev+1]=temp; }
					}
				}
			}
			ibit=ip2 >> 1;
			while (ibit >= ip1 && i2rev > ibit) {
				i2rev -= ibit;
				ibit >>= 1;
			}
			i2rev += ibit;
		}
		ifp1=ip1;
		while (ifp1 < ip2) {
			ifp2=ifp1 << 1;
			theta=isign*6.28318530717959/(ifp2/ip1);
			wtemp=sin(0.5*theta);
			wpr = -2.0*wtemp*wtemp;
			wpi=sin(theta);
			wr=1.0;
			wi=0.0;
			for (i3=1;i3<=ifp1;i3+=ip1) {
				for (i1=i3;i1<=i3+ip1-2;i1+=2) {
					for (i2=i1;i2<=ip3;i2+=ifp2) {
						k1=i2;
						k2=k1+ifp1;
						tempr=(float)wr*data[k2]-(float)wi*data[k2+1];
						tempi=(float)wr*data[k2+1]+(float)wi*data[k2];
						data[k2]=data[k1]-tempr;
						data[k2+1]=data[k1+1]-tempi;
						data[k1] += tempr;
						data[k1+1] += tempi;
					}
				}
				wr=(wtemp=wr)*wpr-wi*wpi+wr;
				wi=wi*wpr+wtemp*wpi+wi;
			}
			ifp1=ifp2;
		}
		nprev *= n;
	}


    //Recuperation
    //------------
    cpt=1;
    for(k=0;k<nn[1];k++)
       for(i=0;i<nn[2];i++)
          for(j=0;j<nn[3];j++)
	     { dtr[k][i][j]=data[cpt++];
	       dti[k][i][j]=data[cpt++]; }
  
    free_fmatrix_1d(data);
}


/*-----------------*/
/* FOURIER 2D -----*/
/*-----------------*/
/*----------------------------------------------------------*/
/* FFTDD                                                    */
/*----------------------------------------------------------*/
void FFTDD(float** mtxR,float** mtxI,int lgth, int wdth)
{
 int i,j;
 int posx,posy;

 float* data;
 float* ImgFreqR;
 float* ImgFreqI;
 unsigned long* nn;

 /*allocation memoire*/
 data=(float*)malloc(sizeof(float)*(2*wdth*lgth)+1);
 ImgFreqR=(float*)malloc(sizeof(float)*(wdth*lgth));
 ImgFreqI=(float*)malloc(sizeof(float)*(wdth*lgth));
 nn=(unsigned long*)malloc(sizeof(unsigned long)*(FFT2D+1)); 

 /*Remplissage de nn*/
 nn[1]=lgth; nn[2]=wdth;

 /*Remplissage de data*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
   { data[2*(i*lgth+j)+1]=mtxR[i][j];
     data[2*(i*lgth+j)+2]=mtxI[i][j]; }

 /*FFTDD*/
 fourn(data,nn,FFT2D,FFT);

 /*Remplissage*/
 for(i=0;i<(wdth*lgth);i++)
  { ImgFreqR[i]=data[(2*i)+1];
    ImgFreqI[i]=data[(2*i)+2];  }

 /*Conversion en Matrice*/
 for(i=0;i<(wdth*lgth);i++)
  { posy=(int)(i/wdth);
    posx=(int)(i%wdth);

    mtxR[posy][posx]=ImgFreqR[i]/(wdth*lgth);  
    mtxI[posy][posx]=ImgFreqI[i]/(wdth*lgth); }

 /*Liberation memoire*/
 free(data);
 free(ImgFreqR);
 free(ImgFreqI);
 free(nn);
}


/*----------------------------------------------------------*/
/* IFFTDD                                                   */
/*----------------------------------------------------------*/
void IFFTDD(float** mtxR,float**  mtxI,int lgth,int wdth)
{
 int i,j;
 int posx,posy;

 float* data;
 float* ImgFreqR;
 float* ImgFreqI;
 unsigned long* nn;

 /*allocation memoire*/
 data=(float*)malloc(sizeof(float)*(2*wdth*lgth)+1);
 ImgFreqR=(float*)malloc(sizeof(float)*(wdth*lgth));
 ImgFreqI=(float*)malloc(sizeof(float)*(wdth*lgth));
 nn=(unsigned long*)malloc(sizeof(unsigned long)*(FFT2D+1));

 /*Remplissage de nn*/
 nn[1]=lgth; nn[2]=wdth;

 /*Remplissage de data*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
   { data[2*(i*lgth+j)+1]=mtxR[i][j];
     data[2*(i*lgth+j)+2]=mtxI[i][j]; }

 /*FFTDD*/
 fourn(data,nn,FFT2D,IFFT);

 /*Remplissage*/
 for(i=0;i<(wdth*lgth);i++)
  { ImgFreqR[i]=data[(2*i)+1];
    ImgFreqI[i]=data[(2*i)+2]; }

 /*Conversion en Matrice*/
 for(i=0;i<(wdth*lgth);i++)
  { posy=(int)(i/wdth);
    posx=(int)(i%wdth);

   mtxR[posy][posx]=ImgFreqR[i];  
   mtxI[posy][posx]=ImgFreqI[i]; }

 /*Liberation memoire*/
 free(data);
 free(ImgFreqR);
 free(ImgFreqI);
 free(nn);
}

/*-----------------*/
/* FOURIER 1D -----*/
/*-----------------*/
/*------------------------------------------------*/
/*  FOUR1 ----------------------------------------*/
/*------------------------------------------------*/
void four1(float data[], unsigned long nn, int isign)
{
	unsigned long n,mmax,m,j,istep,i;
	double wtemp,wr,wpr,wpi,wi,theta;
	float tempr,tempi;
        float temp;

	n=nn << 1;
	j=1;
	for (i=1;i<n;i+=2) {
		if (j > i) {
		        { temp=data[j]; data[j]=data[i]; data[i]=temp;}
			{ temp=data[j+1]; data[j+1]=data[i+1]; data[i+1]=temp;}
		}
		m=n >> 1;
		while (m >= 2 && j > m) {
			j -= m;
			m >>= 1;
		}
		j += m;
	}
	mmax=2;
	while (n > mmax) {
		istep=mmax << 1;
		theta=isign*(6.28318530717959/mmax);
		wtemp=sin(0.5*theta);
		wpr = -2.0*wtemp*wtemp;
		wpi=sin(theta);
		wr=1.0;
		wi=0.0;
		for (m=1;m<mmax;m+=2) {
			for (i=m;i<=n;i+=istep) {
				j=i+mmax;
				tempr=wr*data[j]-wi*data[j+1];
				tempi=wr*data[j+1]+wi*data[j];
				data[j]=data[i]-tempr;
				data[j+1]=data[i+1]-tempi;
				data[i] += tempr;
				data[i+1] += tempi;
			}
			wr=(wtemp=wr)*wpr-wi*wpi+wr;
			wi=wi*wpr+wtemp*wpi+wi;
		}
		mmax=istep;
	}
}

/*----------------------------------------------------------*/
/* FFT1D                                                    */
/*----------------------------------------------------------*/
void FFT1D(float* vctR,float* vctI,int wdth)
{
 int i;

 float* data;
 unsigned long nn;

 /*allocation memoire*/
 data=(float*)malloc(sizeof(float)*(2*wdth)+1);

 /*Remplissage de nn*/
 nn=wdth;

 /*Remplissage de data*/
 for(i=0;i<wdth;i++) 
   { data[(2*i)+1]=vctR[i];
     data[(2*i)+2]=vctI[i]; }

 /*FFT1D*/
 four1(data,nn,FFT);

 /*Recuperation des donnes*/
 for(i=0;i<wdth;i++)
  { vctR[i]=data[(2*i)+1];
    vctI[i]=data[(2*i)+2];  }

 /*Recalage*/
 for(i=0;i<wdth;i++)
  { vctR[i]/=(wdth);
    vctI[i]/=(wdth);  }

 /*Liberation memoire*/
 free(data);
}

/*----------------------------------------------------------*/
/* IFFT1D                                                    */
/*----------------------------------------------------------*/
void IFFT1D(float* vctR,float* vctI,int wdth)
{
 int i;

 float* data;
 unsigned long nn;

 /*allocation memoire*/
 data=(float*)malloc(sizeof(float)*(2*wdth)+1);

 /*Remplissage de nn*/
 nn=wdth;

 /*Remplissage de data*/
 for(i=0;i<wdth;i++) 
   { data[(2*i)+1]=vctR[i];
     data[(2*i)+2]=vctI[i]; }

 /*FFT1D*/
 four1(data,nn,IFFT);

 /*Recuperation des donnes*/
 for(i=0;i<wdth;i++)
  { vctR[i]=data[(2*i)+1];
    vctI[i]=data[(2*i)+2];  }

 /*Liberation memoire*/
 free(data);
}

/*----------------------------------------------------------*/
/* ReMkeVct                                                 */
/*----------------------------------------------------------*/
void ReMkeVct(float* Vct,int wdth)
{
 int j;
 int cj;
 float*  Vct_tmp;

 /*Initialisation*/
 cj=(int)(wdth/2);

 /*Allocation memoire*/
 Vct_tmp=fmatrix_allocate_1d(wdth);

 /*Recadrage*/
 for(j=0;j<cj;j++) Vct_tmp[cj+j]=Vct[j];

 for(j=cj;j<wdth;j++) Vct_tmp[j-cj]=Vct[j];

 /*Transfert*/
 for(j=0;j<wdth;j++) Vct[j]=Vct_tmp[j];

 /*desallocation memoire*/
 free(Vct_tmp);
}

/*----------------------------------------------------------*/
/* Module d'un vecteur                                      */
/*----------------------------------------------------------*/
void ModVct(float* VctM,float* VctR,float* VctI,int wdth)
{
 int j;

 /*Calcul du module*/
 for(j=0;j<wdth;j++)
 VctM[j]=sqrt((VctR[j]*VctR[j])+(VctI[j]*VctI[j]));
}


/*----------------------------------------------------------*/
/* Module de la matrice                                     */
/*----------------------------------------------------------*/
void Mod(float** matM,float** matR,float** matI,int lgth,int wdth)
{
 int i,j;

 /*Calcul du module*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
 matM[i][j]=sqrt((matR[i][j]*matR[i][j])+(matI[i][j]*matI[i][j]));
}



/*----------------------------------------------------------*/
/* ReMkeImg                                                 */
/*----------------------------------------------------------*/
void ReMkeImg(float** mat,int lgth,int wdth)
{
 int i,j;
 int ci,cj;
 float** mattmp;

 /*Initialisation*/
 ci=(int)(lgth/2);
 cj=(int)(wdth/2);

 /*Allocation memoire*/
 mattmp=fmatrix_allocate_2d(lgth,wdth);

 /*Recadrage*/
 for(i=0;i<ci;i++) for(j=0;j<cj;j++)
 mattmp[ci+i][cj+j]=mat[i][j];

 for(i=ci;i<lgth;i++) for(j=cj;j<wdth;j++)
 mattmp[i-ci][j-cj]=mat[i][j];

 for(i=0;i<ci;i++) for(j=cj;j<wdth;j++)
 mattmp[ci+i][j-cj]=mat[i][j];

 for(i=ci;i<lgth;i++) for(j=0;j<cj;j++)
 mattmp[i-ci][cj+j]=mat[i][j];

 /*Transfert*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
  mat[i][j]=mattmp[i][j];

 /*desallocation memoire*/
 free_fmatrix_2d(mattmp);
}


/*----------------------------------------------------------*/
/* Inverse le sens d'une matrice                            */
/*----------------------------------------------------------*/
void InverseSense2(float** mat,int lgth,int wdth)
{
 int i,j;
 float** mattmp;

 /*Allocation memoire*/
 mattmp=fmatrix_allocate_2d(lgth,wdth);

 /*Transfert*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mattmp[i][wdth-j-1]=mat[j][i];

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat[i][j]=mattmp[i][j];

 /*desallocation memoire*/
 free_fmatrix_2d(mattmp);
}


/*----------------------------------------------------------*/
/* Mult                                                     */
/*----------------------------------------------------------*/
void Mult(float** mat,float coef,int lgth,int wdth)
{
 int i,j;

 /*multiplication*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    { mat[i][j]*=coef;
      if (mat[i][j]>GREY_LEVEL) mat[i][j]=GREY_LEVEL; }
}


/*----------------------------------------------------------*/
/* Recal                                                    */
/*----------------------------------------------------------*/
void Recal3(float** mat,int lgth,int wdth)
{
 int i,j;
 float max,min;

 /*Initialisation*/
 max=0.0;
 min=100000000;

 /*Recherche du min*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if (mat[i][j]<min) min=mat[i][j];

 /*plus min*/
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat[i][j]-=min;

 /*Recherche du max*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    if (mat[i][j]>max) max=mat[i][j];

 /*Recalibre la matrice*/
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
   mat[i][j]*=(255.0/max);      
}



/*----------------------------------------------------------*/
/* Info                                                 */
/*----------------------------------------------------------*/
void Info(float** mat,int lgth,int wdth)
{
 int i,j;
 float max,min;

 /*Initialisation*/
 max=0.0;
 min=100000000;

 /*Recherche du min*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    if (mat[i][j]<min) min=mat[i][j];

 /*plus min*/
   for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    mat[i][j]-=min;

 /*Recherche du max*/
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
    if (mat[i][j]>max) max=mat[i][j];

 /*Recalibre la matrice*/
  printf("     >> Min=%f  >> Max=%f",min,max);     
}

//----------------------------------------------------------
//  ZeroSquareMat                  
//----------------------------------------------------------                
void ZeroSquareMat(float** mt,int sz)
{
 int i,j;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) mt[i][j]=0.0;
}

//----------------------------------------------------------
// CopySquareMatrix                 
//----------------------------------------------------------                
void CopySquareMatrix(float** mtin,float** mtout,int sz)
{
 int i,j;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) mtout[i][j]=mtin[i][j];
}

//----------------------------------------------------------
// CopyNonSquareMatrix                 
//----------------------------------------------------------                
void CopyNonSquareMatrix(float** mtin,float** mtout,int lgth,int wdth)
{
 int i,j;

 //Boucle
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mtout[i][j]=mtin[i][j];
}



//----------------------------------------------------------*/
// RecalMoySquareMat                                                  
//----------------------------------------------------------*/
void RecalMoySquareMat(float** matin,float** matout,int sz)
{
 int i,j;
 float moyin,moyout;

 /*Recherche des deux moyennes*/
 moyin=moyout=0.0;
 for(i=0;i<sz;i++)  for(j=0;j<sz;j++)
   { moyin+=matin[i][j];
     moyout+=matout[i][j];}

 /*Recalage*/
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)
    { matin[i][j]*=(moyout/moyin);
      if (matin[i][j]>255.0) matin[i][j]=255.0;
      if (matin[i][j]<0.0) matin[i][j]=0.0; }

  /*Nouvelle Moyenne*/
  moyin=0.0;
  for(i=0;i<sz;i++) for(j=0;j<sz;j++) moyin+=matin[i][j];
  moyin/=(sz*sz);
  printf("\n         [Moy(RecalMoyMat)=%.2f]",moyin);
}

//----------------------------------------------------------*/
// RecalMoy                                                
//----------------------------------------------------------*/
void RecalMoySquareMat(float** matin,float moyout,int sz)
{
 int i,j;
 float moyin;

 /*Recherche des deux moyennes*/
 moyin=0.0;
 for(i=0;i<sz;i++)  for(j=0;j<sz;j++) moyin+=matin[i][j];
 moyin/=(sz*sz);
     
 /*Recalage*/
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) 
     { matin[i][j]*=(moyout/moyin);
       if (matin[i][j]>255.0) matin[i][j]=255.0;
       if (matin[i][j]<0.0) matin[i][j]=0.0; 
     }

  /*Nouvelle Moyenne*/
  moyin=0.0;
  for(i=0;i<sz;i++) for(j=0;j<sz;j++) moyin+=matin[i][j];
  moyin/=(sz*sz);
  printf("\n         [Moy(RecalMoyfloat)=%.2f]",moyin);
}


//----------------------------------------------------------*/
// MinMaxSquareMat                                                 
//----------------------------------------------------------*/
void MinMaxSquareMat(float** mt,int sz,int mn,int mx)
{
 int i,j;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) 
   { if (mt[i][j]>mx)  mx=(int)mt[i][j];
      if (mt[i][j]<mn)  mn=(int)mt[i][j];
    }
}

//----------------------------------------------------------*/
// Direct Fourier Transform                                               
//----------------------------------------------------------*/
void DFT(float* x1,float* y1,int m,int dir)
{
   long i,k;
   double arg;
   float cosarg,sinarg;
   double* x2;
   double* y2;

   x2 = (double*)malloc(m*sizeof(double));
   y2 = (double*)malloc(m*sizeof(double));
   if (x2 == NULL || y2 == NULL) exit(-1);

   for (i=0;i<m;i++) {
      x2[i] = 0.0;
      y2[i] = 0.0;
      arg = - dir * 2.0 * 3.141592654 * (double)i / (double)m;
      for (k=0;k<m;k++) {
         cosarg = cos(k * arg);
         sinarg = sin(k * arg);
         x2[i] += (x1[k] * cosarg - y1[k] * sinarg);
         y2[i] += (x1[k] * sinarg + y1[k] * cosarg);
      }
   }

   // Copy the data back 
   if (dir == 1) {
      for (i=0;i<m;i++) {
         x1[i] = x2[i] / (float)m;
         y1[i] = y2[i] / (float)m;
      }
   } else {
      for (i=0;i<m;i++) {
         x1[i] = x2[i];
         y1[i] = y2[i];
      }
   }

   free(x2);
   free(y2);
}

//----------------------------------------------------------*/
//  IsPowerOfTwo                                      
//----------------------------------------------------------*/
bool IsPowerOfTwo(int p_nX)
{
 if( p_nX < 2 ) return false;
 if( p_nX & (p_nX-1) ) return false;
 return true;
}

//----------------------------------------------------------//
//----------------------------------------------------------//
//----------------------------------------------------------//
//----------------------------------------------------------//
// Direct Fourier Transform 2D                                            
//----------------------------------------------------------//
void DFT(float** x1,float** y1,int lgth,int wdth,int dir)
{
 int k,l;
 float* x2;
 float* y2;

 //AlocMemory
 x2=(float*)malloc(lgth*sizeof(float));
 y2=(float*)malloc(lgth*sizeof(float));
   
 //ALGO
 if (dir==1)
    {
     //>1
     for(k=0;k<lgth;k++)  DFT(x1[k],y1[k],wdth,dir);

     //>2
     for(k=0;k<wdth;k++) 
        { 
         for(l=0;l<lgth;l++) 
	    { x2[l]=x1[l][k];
              y2[l]=y1[l][k]; }

         DFT(x2,y2,lgth,dir);

         for(l=0;l<lgth;l++) 
	    { x1[l][k]=x2[l];
              y1[l][k]=y2[l]; }   
         }
    }

 if (dir==-1)
    {
     //>2
     for(k=0;k<wdth;k++) 
        { 
         for(l=0;l<lgth;l++) 
	    { x2[l]=x1[l][k];
              y2[l]=y1[l][k]; }

         DFT(x2,y2,lgth,dir);

         for(l=0;l<lgth;l++) 
	    { x1[l][k]=x2[l];
              y1[l][k]=y2[l]; }     
         }

      //>1  
     for(k=0;k<lgth;k++)  DFT(x1[k],y1[k],wdth,dir);
    }

 //Libere
 free(x2);
 free(y2);
}

//----------------------------------------------------------//
//----------------------------------------------------------//
//----------------------------------------------------------//
//----------------------------------------------------------//
// GaussianFilterImgNS                                          
//----------------------------------------------------------//
void GaussianFilterImgNS(float** mat,int lgth,int wdth,float sigx,float sigy)
{
 int i,j;
 float dist;
 float distx,disty;
 float** Imag;

 //Allocation&Init
 Imag=fmatrix_allocate_2d(lgth,wdth);
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) Imag[i][j]=0.0;

 //--------
 //Filtrage
 //--------

 //DFT--------------------
 DFT(mat,Imag,lgth,wdth,1);
 ReMkeImg(mat,lgth,wdth);
 ReMkeImg(Imag,lgth,wdth);

 //Filtre Gausien
 if (1) 
 for(i=-(lgth/2);i<(lgth/2);i++) for(j=-(wdth/2);j<(wdth/2);j++)
   {  distx=j;
      disty=i;
      mat[i+(lgth/2)][j+(wdth/2)]*=exp(-SQUARE(distx)/CARRE(sigx))*exp(-SQUARE(disty)/CARRE(sigy));
      Imag[i+(lgth/2)][j+(wdth/2)]*=exp(-SQUARE(distx)/CARRE(sigx))*exp(-SQUARE(disty)/CARRE(sigy)); }

 //Filtre Butterworth
 if (0)
 for(i=-(lgth/2);i<(lgth/2);i++) for(j=-(wdth/2);j<(wdth/2);j++)
    { dist=sqrt((i*i)+(j*j));
      mat[i+(lgth/2)][j+(wdth/2)]*=1.0/(1.0+pow((dist/(sigx)),2*sigy));
      Imag[i+(lgth/2)][j+(wdth/2)]*=1.0/(1.0+pow((dist/(sigx)),2*sigy)); }

 //Filtre PasseBas ideal
 if (0)
 for(i=-(lgth/2);i<(lgth/2);i++) for(j=-(lgth/2);j<(wdth/2);j++)
    { dist=sqrt((i*i)+(j*j));
      if (dist>sigx)
	{ mat[i+(lgth/2)][j+(wdth/2)]=0.0;
   	  Imag[i+(lgth/2)][j+(wdth/2)]=0.0; } }


 //IDFT-----------------
 ReMkeImg(mat,lgth,wdth);
 ReMkeImg(Imag,lgth,wdth); 
 DFT(mat,Imag,lgth,wdth,-1);
 
 //Liberation
 free_fmatrix_2d(Imag);
}

/* -------------------------------------------------------------------------
 * This is an ANSI C library for multi-stream random number generation.  
 * The use of this library is recommended as a replacement for the ANSI C 
 * rand() and srand() functions, particularly in simulation applications 
 * where the statistical 'goodness' of the random number generator is 
 * important.  The library supplies 256 streams of random numbers; use 
 * SelectStream(s) to switch between streams indexed s = 0,1,...,255.
 *
 * The streams must be initialized.  The recommended way to do this is by
 * using the function PlantSeeds(x) with the value of x used to initialize 
 * the default stream and all other streams initialized automatically with
 * values dependent on the value of x.  The following convention is used 
 * to initialize the default stream:
 *    if x > 0 then x is the state
 *    if x < 0 then the state is obtained from the system clock
 *    if x = 0 then the state is to be supplied interactively.
 *
 * The generator used in this library is a so-called 'Lehmer random number
 * generator' which returns a pseudo-random number uniformly distributed
 * 0.0 and 1.0.  The period is (m - 1) where m = 2,147,483,647 and the
 * smallest and largest possible values are (1 / m) and 1 - (1 / m)
 * respectively.  For more details see:
 * 
 *       "Random Number Generators: Good Ones Are Hard To Find"
 *                   Steve Park and Keith Miller
 *              Communications of the ACM, October 1988
 *
 * Name            : rngs.c  (Random Number Generation - Multiple Streams)
 * Authors         : Steve Park & Dave Geyer
 * Language        : ANSI C
 * Latest Revision : 09-22-98
 * ------------------------------------------------------------------------- 
 */

#define MODULUS    2147483647 /* DON'T CHANGE THIS VALUE                  */
#define MULTIPLIER 48271      /* DON'T CHANGE THIS VALUE                  */
#define CHECK      399268537  /* DON'T CHANGE THIS VALUE                  */
#define STREAMS    256        /* # of streams, DON'T CHANGE THIS VALUE    */
#define A256       22925      /* jump multiplier, DON'T CHANGE THIS VALUE */
#define DEFAULT    123456789  /* initial seed, use 0 < DEFAULT < MODULUS  */
      
static long seed[STREAMS] = {DEFAULT};  /* current state of each stream   */
static int  stream        = 0;          /* stream index, 0 is the default */
static int  initialized   = 0;          /* test for stream initialization */


   void PlantSeeds(long x)
/* ---------------------------------------------------------------------
 * Use this function to set the state of all the random number generator 
 * streams by "planting" a sequence of states (seeds), one per stream, 
 * with all states dictated by the state of the default stream. 
 * The sequence of planted states is separated one from the next by 
 * 8,367,782 calls to Random().
 * ---------------------------------------------------------------------
 */
{
  const long Q = MODULUS / A256;
  const long R = MODULUS % A256;
        int  j;
        int  s;

  initialized = 1;
  s = stream;                            /* remember the current stream */
  SelectStream(0);                       /* change to stream 0          */
  PutSeed(x);                            /* set seed[0]                 */
  stream = s;                            /* reset the current stream    */
  for (j = 1; j < STREAMS; j++) {
    x = A256 * (seed[j - 1] % Q) - R * (seed[j - 1] / Q);
    if (x > 0)
      seed[j] = x;
    else
      seed[j] = x + MODULUS;
   }
}


   void PutSeed(long x)
/* ---------------------------------------------------------------
 * Use this function to set the state of the current random number 
 * generator stream according to the following conventions:
 *    if x > 0 then x is the state (unless too large)
 *    if x < 0 then the state is obtained from the system clock
 *    if x = 0 then the state is to be supplied interactively
 * ---------------------------------------------------------------
 */
{
  int tpsc;
  char ok = 0;

  if (x > 0)
    x = x % MODULUS;                       /* correct if x is too large  */
  if (x < 0)                                 
    x = ((unsigned long) time((time_t *) NULL)) % MODULUS;              
  if (x == 0)                                
    while (!ok) {
      printf("\nEnter a positive integer seed (9 digits or less) >> ");
      tpsc=scanf("%ld", &x);
      ok = (0 < x) && (x < MODULUS);
      if (!ok)
        printf("\nInput out of range ... try again\n");
    }
  seed[stream] = x;
}


   void GetSeed(long *x)
/* ---------------------------------------------------------------
 * Use this function to get the state of the current random number 
 * generator stream.                                                   
 * ---------------------------------------------------------------
 */
{
  *x = seed[stream];
}


   void SelectStream(int index)
/* ------------------------------------------------------------------
 * Use this function to set the current random number generator
 * stream -- that stream from which the next random number will come.
 * ------------------------------------------------------------------
 */
{
  stream = ((unsigned int) index) % STREAMS;
  if ((initialized == 0) && (stream != 0))   /* protect against        */
    PlantSeeds(DEFAULT);                     /* un-initialized streams */
}



/*------------------------------------------------*/
/* DISTRIBUTIONS ---------------------------------*/
/*------------------------------------------------*/

   double Random(void)
/* ----------------------------------------------------------------
 * Random returns a pseudo-random real number uniformly distributed 
 * between 0.0 and 1.0. 
 * ----------------------------------------------------------------
 */
{
  const long Q = MODULUS / MULTIPLIER;
  const long R = MODULUS % MULTIPLIER;
        long t;

  t = MULTIPLIER * (seed[stream] % Q) - R * (seed[stream] / Q);
  if (t > 0) 
    seed[stream] = t;
  else 
    seed[stream] = t + MODULUS;
  return ((double) seed[stream] / MODULUS);
}


   long Poisson(double m)
/* ================================================== 
 * Returns a Poisson distributed non-negative integer. 
 * NOTE: use m > 0
 * ==================================================
 */
{ 
  double t = 0.0;
  long   x = 0;

  while (t < m) {
    t += Exponential(1.0);
    x++;
  }
  return (x - 1);
}



   double Exponential(double m)
/* =========================================================
 * Returns an exponentially distributed positive real number. 
 * NOTE: use m > 0.0
 * =========================================================
  */
 {
   return (-m * log(1.0 - Random()));
 }

//--------------------------------------------------------------
// chargement de l'image img2
//
//   data::Matrix3d(LENGTH_SPECT,NBSLC_SPECT,WIDTH_SPECT)
//                 (128,90,128)
//
//      depth:NBSLC_SPECT length:LENGTH_SPECT  width:WIDTH_SPECT
// 
//--------------------------------------------------------------
void load_imageimg2(char* path,float*** data,float*** dataimg,int depth,int length,int width)
{
  int i,j,k;
  //unsigned char var;
  short var;
  float tmp;
  int   nbval;
  int   temp;
  float min,max;
  float nbcounts;
  float nbcountsmax;
  float nbcountstot;
  int   indx_nbcounts;
  FILE* inputFile;

  //Ouverture
  printf("\n       > Ouverture de %s",path);

  //Ouverture
  inputFile=fopen(path, "r");
  if(inputFile==NULL)
    { printf("\n      > Can't Open File, Error %s \n",path);
      exit(-1); }

  //Recherche Min/Max
  min=100000; max=-100000;
  nbval=0;
  for(i=0;i<depth;i++)
    for(j=0;j<length;j++)
      for(k=0;k<width;k++)
	{ if (!feof(inputFile)) 
            { nbval++;
              temp=fread(&var,2*sizeof(unsigned char),1,inputFile);
              data[j][i][k]=var;
	      if(min>var) min=var;
	      if(max<var) max=var; } }

  printf("  (> [%d <%.1f :: %.1f>] vals)",nbval,min,max);
  fclose(inputFile);
  inputFile=fopen(path, "r");

  if(inputFile==NULL)
    { printf("\n-- Can't Open File, Error %s --\n",path);
      exit(-1); }

  //Chargement
  for(i=0;i<depth;i++)
    for(j=0;j<length;j++)
      for(k=0;k<width;k++)
	{ if (!feof(inputFile)) 
            { nbval++;
              temp=fread(&var,2*sizeof(unsigned char),1,inputFile);
	      tmp=(((float)var-min)/(max-min))*255.0;
              if (tmp>255) tmp=255.0;
	      dataimg[j][i][k]=tmp; } }

  //Recherche Min/Max  
  min=100000; max=-100000;
  nbval=0;
  for(i=0;i<depth;i++)
    for(j=0;j<length;j++)
      for(k=0;k<width;k++)
	{ nbval++;
	  tmp=dataimg[j][i][k];
	  if(min>tmp) min=tmp;
	  if(max<tmp) max=tmp;  }

  //Nb coups/slice
  nbcountstot=0.0;
  nbcountsmax=0.0;
  indx_nbcounts=0;
  for(j=0;j<length;j++)
    { 
     nbcounts=0.0;
     for(k=0;k<width;k++) for(i=0;i<depth;i++) nbcounts+=dataimg[j][i][k];
     nbcountstot+=nbcounts;
     if (nbcounts>nbcountsmax) { nbcountsmax=nbcounts; indx_nbcounts=j; }
    } 
  printf("\n            >[NbCounts3D = %.0f]",nbcountstot);
  printf("\n            >[NbCounts2DMax = %.0f > Slice [%d]]",nbcountsmax,indx_nbcounts);

  //Affichage
   printf("\n           (> [%d <%.1f :: %.1f>] vals)",nbval,min,max); 

  //Fermeture du fichier
  fclose(inputFile);
}

//--------------------------------------------------------------
// chargement de l'image img2b
//
//   data::Matrix3d(LENGTH_SPECT,NBSLC_SPECT,WIDTH_SPECT)
//                 (224,45,224)
//
//      depth:NBSLC_SPECT length:LENGTH_SPECT  width:WIDTH_SPECT
// 
//--------------------------------------------------------------
void load_imageimg2b(char* path,float*** data,float*** dataimg,int depth,int length,int width)
{
  int i,j,k;
  int m,n;
  short var;
  float tmp;
  float vart;
  int   nbval;
  int   temp;
  float min,max;
  float nbcounts;
  float nbcountsmax;
  float nbcountstot;
  int   indx_nbcounts;
  FILE* inputFile;

  //Reservation memoire [224*45*224]
  float*** dtmp=fmatrix_allocate_3d(224,45,224);

  //Ouverture
  printf("\n       > Ouverture de %s",path);
  inputFile=fopen(path, "r");
  if(inputFile==NULL)
    { printf("\n      > Can't Open File, Error %s \n",path);
      exit(-1); }

  //Recherche Min/Max et chargement dans dtmp[224*45*224]
  min=100000; max=-100000;
  nbval=0;
  for(i=0;i<45;i++)
    for(j=0;j<224;j++)
      for(k=0;k<224;k++)
	{  if (!feof(inputFile)) 
            { nbval++;
              temp=fread(&var,2*sizeof(unsigned char),1,inputFile);
              dtmp[j][i][k]=var;
	      if(min>var) min=var;
	      if(max<var) max=var; } }

  printf("  (> [%d <%.1f :: %.1f>] vals)",nbval,min,max);
  fclose(inputFile);

  //Recalage
  for(i=0;i<45;i++) for(j=0;j<224;j++) for(k=0;k<224;k++)
     { vart=dtmp[j][i][k];
       tmp=(((float)vart-min)/(max-min))*255.0;
       if (tmp>255) tmp=255.0;
       dtmp[j][i][k]=tmp; } 

  //Sauvegarde SiniInit
  if (1) save_image("SinoSpectBruteInit.pgm",dtmp,45,224,224);

  //Chargement dans data data[128*45*128]
  for(i=0;i<45;i++)
    for(j=0;j<224;j++)
      for(k=0;k<224;k++)
	 { m=j-48;  n=k-48;
           if ((m>=0)&&(n>=0)&&(m<128)&&(n<128)) data[m][i][n]=dtmp[j][i][k]; }

  //Chargement dans dataimg[128*45*128]
  for(i=0;i<45;i++)
    for(j=0;j<224;j++)
      for(k=0;k<224;k++)
	{  m=j-48;  n=k-48;
           if ((m>=0)&&(n>=0)&&(m<128)&&(n<128)) dataimg[m][i][n]=dtmp[j][i][k]; }

  //Recherche Min/Max  
  min=100000; max=-100000;
  nbval=0;
  for(i=0;i<45;i++)
    for(j=0;j<128;j++)
      for(k=0;k<128;k++)
	{ nbval++;
	  tmp=dataimg[j][i][k];
	  if(min>tmp) min=tmp;
	  if(max<tmp) max=tmp;  }

  //Nb coups/slice
  nbcountstot=0.0;
  nbcountsmax=0.0;
  indx_nbcounts=0;
  for(j=0;j<length;j++)
    { 
     nbcounts=0.0;
     for(k=0;k<width;k++) for(i=0;i<45;i++) nbcounts+=dataimg[j][i][k];
     nbcountstot+=nbcounts;
     if (nbcounts>nbcountsmax) { nbcountsmax=nbcounts; indx_nbcounts=j; }
    } 
  printf("\n            >[NbCounts3D = %.0f]",nbcountstot);
  printf("\n            >[NbCounts2DMax = %.0f > Slice [%d]]",nbcountsmax,indx_nbcounts);

  //Affichage
  printf("\n           (> [%d <%.1f :: %.1f>] vals)",nbval,min,max); 

  //Liberation Memoire
  free_fmatrix_3d(dtmp,45);
}

//------------//
// SAUVEGARDE //
//------------//
//----------------------------------------------------------
// Sauvegarde de l'image img
//
//   data::Matrix3d(LENGTH_SPECT,  NBSLC_SPECT,  WIDTH_SPECT)
//                 (128,           90,           128)
//                  length         depth         width
// 
//----------------------------------------------------------
void save_image(char* path,float*** data,int depth,int length,int width)
{
  int i,j,k;
  FILE* outputFile;
  char tmp;

  //Ouverture
  outputFile=fopen(path, "w");
  if(outputFile==NULL)
    { printf("\n      > Can't Open File, Error %s \n",path);
      exit(-1); }

  //Ecriture Entete
  fprintf(outputFile,"P5");
  fprintf(outputFile,"\n# IMG Module");
  fprintf(outputFile,"\n%d %d",width*length,depth);
  fprintf(outputFile,"\n255\n");

  //Ecriture
    for(k=0;k<depth;k++)
      for(i=0;i<length;i++)
      for(j=0;j<width;j++)
	  {
	   tmp=(char)data[i][k][j];
           fprintf(outputFile,"%c",tmp);
          }

  //Fermeture du fichier
  fclose(outputFile);
}

//----------------------------------------------------------
// Sauvegarde de l'image 
//
//----------------------------------------------------------
void save_image2(char* path,float*** data,int depth,int length,int width)
{
  int i,j,k;
  FILE* outputFile;
  char tmp;

  //Ouverture
  outputFile=fopen(path, "w");
  if(outputFile==NULL)
    { printf("\n      > Can't Open File, Error %s \n",path);
      exit(-1); }

  //Ecriture Entete
  fprintf(outputFile,"P5");
  fprintf(outputFile,"\n# IMG Module");
  fprintf(outputFile,"\n%d %d",width*depth,length);
  fprintf(outputFile,"\n255\n");

  //Ecriture
   for(i=0;i<length;i++)
     for(k=0;k<depth;k++)
       for(j=0;j<width;j++)
	  {
	   tmp=(char)data[k][i][j];
           fprintf(outputFile,"%c",tmp);
          }

  //Fermeture du fichier
  fclose(outputFile);
}

//--------------//
// UTILITAIRES //
//-------------//
//----------------------------------------------------------
// ByteSwap((unsigned char *) &x,sizeof(x))
// ByteSwap5(x)
//----------------------------------------------------------
void ByteSwap(unsigned char* b, int n)
{
 int i;
 int j;
 int temp;

 //Init
 i = 0;
 j = n-1;

 while (i<j) { SWAP(b[i], b[j]); i++, j--; }
}

//--------------//
// UTILITAIRES //
//-------------//
//----------------------------------------------------------
// chargement de l'image 
//
//----------------------------------------------------------
void load_imageSUNS(char* path,float** data,int length,int width,int ech)
{
  int i,j;
  short var;
  int   nbval;
  int   temp;
  float min,max;
  float sum;
  FILE* inputFile;
  FILE* outputFile;

  //Ouverture
  printf("\n       > Ouverture de %s",path);

  //Ouverture
  inputFile=fopen(path, "r");
  if(inputFile==NULL)
    { printf("\n      > Can't Open File, Error %s \n",path);
      exit(-1); }

  outputFile=fopen("OutputTransmissionScan.raw", "w");
  if(outputFile==NULL)
    { printf("\n      > Can't Open File, Error %s \n",path);
      exit(-1); }

  //Recherche Min/Max
  min=100000; max=-100000;
  nbval=0;
  sum=0.0;
    for(i=0;i<ech*length;i++)
      for(j=0;j<width;j++)
        { 
         if (!feof(inputFile))
	  {
            if (((i%ech)!=0))
	        { temp=fread(&var,sizeof(char),1,inputFile);
		  temp=fread(&var,sizeof(char),1,inputFile); }

            else
                { nbval++;
                  temp=fread(&var,sizeof(char),1,inputFile);
                  data[(int)(i/ech)][j]=var;
                  temp=fread(&var,sizeof(char),1,inputFile);
                  data[(int)(i/ech)][j]=var; 
                  sum+=var; 
                  if(min>var) min=var;
                  if(max<var) max=var; } 
           }   
	}

  printf("  (> [%d <%.1f::%.1f>] vals  Sum=%.1f)",nbval,min,max,sum);
  fclose(inputFile);
  fclose(outputFile);
}

//----------------------------------------------------------
// chargement de l'image 
//
//----------------------------------------------------------
void load_imageSUNS2(char* path,float** data,int length,int width,int ech)
{
  int i,j;
  float var;
  int   nbval;
  int   temp;
  float min,max;
  float sum;
  FILE* inputFile;
  FILE* outputFile;

  //Ouverture
  printf("\n       > Ouverture de %s",path);

  //Ouverture
  inputFile=fopen(path, "r");
  if(inputFile==NULL)
    { printf("\n      > Can't Open File, Error %s \n",path);
      exit(-1); }

  outputFile=fopen("OutputBlankScan.raw", "w");
  if(outputFile==NULL)
    { printf("\n      > Can't Open File, Error %s \n",path);
      exit(-1); }

  //Recherche Min/Max
  min=100000; max=-100000;
  nbval=0;
  sum=0.0;
    for(i=0;i<ech*length;i++)
      for(j=0;j<width;j++)
        { 
         if (!feof(inputFile))
            { 
             if (((i%ech)!=0)) temp=fread(&var,sizeof(float),1,inputFile);
	     else
	        { nbval++;
	          temp=fread(&var,sizeof(float),1,inputFile);
	          ByteSwap5(var);
                  data[(int)(i/ech)][j]=var; 
                  sum+=var; 
                  if(min>var) min=var;
                  if(max<var) max=var; } 
	    }
          }

  printf("  (> [%d <%.3f::%.3f>] vals  Sum=%.2f)",nbval,min,max,sum);
  fclose(inputFile);
  fclose(outputFile);
}

//--------------------//
//-- LOAD/SAVE/FILE --//
//--------------------//
//----------------------------------------------------------
// Get Length and Width
//----------------------------------------------------------
void GetLengthWidth(char* path,int* length,int* width)
{
 unsigned char var;
 int   temp;
 char* tempc;
 char stringTmp1[100];
 char stringTmp2[100];
 int ta1,ta2;
 FILE *fic;

  //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL)
    { printf("\n- Grave erreur a l'ouverture de %s -\n",path);
      exit(-1); }

  //recuperation de l'entete
  tempc=fgets(stringTmp1,100,fic);
  for(;;) { temp=fread(&var,1,1,fic); if (var==35) tempc=fgets(stringTmp2,100,fic);
            else break; }
  fseek(fic,-1,SEEK_CUR);
  temp=fscanf(fic,"%d %d",&ta1,&ta2);
   
  //enregistrement
  (*length)=ta2; 
  (*width)=ta1;

  //fermeture du fichier
  fclose(fic);
}

//----------------------------------------------------------
// Chargement de l'image de nom <name> (en pgm)             
//----------------------------------------------------------
void load_image_pgm(char* path,int** img,int lgth,int wdth)
 {
  int i,j;
  int temp;
  char* tempc;
  unsigned char var;
  char header[100];
  char* ptr;
  int ta1,ta2,ta3;
  FILE *fic;

  //enregistrement du chemin;
   if (strstr(path,".pgm")==NULL) strcat(path,".pgm");

   //ouverture du fichier
  fic=fopen(path,"r");
  if (fic==NULL) 
   { printf("\n ->> Grave erreur a l'ouverture de %s -\n",path);
     exit(-1); }

  tempc=fgets(header,100,fic);
  if ( (header[0]!=80) ||    /* 'P' */
       (header[1]!=53) ) {   /* '5' */
       fprintf(stderr,"Image %s is not PGM.\n",path);
       exit(1); }

  tempc=fgets(header,100,fic);
  while(header[0]=='#') tempc=fgets(header,100,fic);
 
  ta1=strtol(header,&ptr,0);
  ta2=atoi(ptr);
  tempc=fgets(header,100,fic);
  ta3=strtol(header,&ptr,0);
   
  //chargement dans la matrice
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  
    { temp=(int)fread(&var,1,1,fic);
      img[i][j]=(int)var; }

  //fermeture du fichier
  fclose(fic);
 }


//----------------------------------------------------------
// Sauvegarde de l'image de nom <name> au format pgm                        
//----------------------------------------------------------                
void SaveImagePgm(char* bruit,char* name,float** mat,int lgth,int wdth)
{
 int i,j;
 char buff[300];
 FILE* fic;

  //--extension--
  strcpy(buff,bruit);
  strcat(buff,name);
  strcat(buff,".pgm");

  //--ouverture fichier--
  fic=fopen(buff,"wb");
    if (fic==NULL) 
        { printf("Probleme dans la sauvegarde de %s",buff); 
          exit(-1); }
  printf("\n Sauvegarde de %s au format pgm\n",buff);

  //--sauvegarde de l'entete--
  fprintf(fic,"P5");
  fprintf(fic,"\n# IMG Module");
  fprintf(fic,"\n%d %d",wdth,lgth);
  fprintf(fic,"\n255\n");

  //--enregistrement--
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
	fprintf(fic,"%c",(char)mat[i][j]);
   
  //--fermeture fichier--
   fclose(fic); 
}



