//------------------------------------------------------
// module  : Function.h
// auteur  : Mignotte Max
// date    :
// version : 1.0
// langage : C++
// labo    : DIRO
// note    :
//------------------------------------------------------
// 

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <new>

//------------------------------------------------
// CONSTANTES & DEFINITIONS ----------------------
//------------------------------------------------
#define PI  3.14159
#define GREY_LEVEL 255

#define NB_BITS    8
#define BIT_CHAR   256
#define GREY_LEVEL 255

#define MAXIMUM(x,y) ((x) > (y) ? (x) : (y))
#define SIGN(a,b)    ((b) >= 0.0 ? fabs(a): -fabs(a))
#define MAX(a,b)     (((a)>(b))?(a):(b))
#define MIN(a,b)     (((a)>(b))?(b):(a))
#define SQUARE(a)    ((a)*(a))
#define CARRE(X)     ((X)*(X))
#define ByteSwap5(x) ByteSwap((unsigned char *) &x,sizeof(x))

#define NN 624
#define MM 397
#define MATRIX_A 0x9908b0df   
#define UPPER_MASK 0x80000000 
#define LOWER_MASK 0x7fffffff 

#define TEMPERING_MASK_B 0x9d2c5680
#define TEMPERING_MASK_C 0xefc60000
#define TEMPERING_SHIFT_U(y)  (y >> 11)
#define TEMPERING_SHIFT_S(y)  (y << 7)
#define TEMPERING_SHIFT_T(y)  (y << 15)
#define TEMPERING_SHIFT_L(y)  (y >> 18)

#define FFT   1
#define IFFT -1
#define FFT2D 2

#define SWAP(a,b) temp=(a);(a)=(b);(b)=temp;

//------------------------------------------------
// STRUCTS & UNIONS ------------------------------
//------------------------------------------------
/* struct LongDouble */
/* { unsigned char mant[8];    */
/*   unsigned int exp;   }; */

/* union Real */
/* { struct LongDouble sld; */
/*   long double ld; }; */

//------------------------------------------------
// PROTOTYPE -------------------------------------
//------------------------------------------------
unsigned char**  cmatrix_allocate_2d(int,int);
void             free_cmatrix_2d(unsigned char**);

double*    dmatrix_allocate_1d(int);
double**   dmatrix_allocate_2d(int,int);
double***  dmatrix_allocate_3d(int,int,int);

float*    fmatrix_allocate_1d(int);
float**   fmatrix_allocate_2d(int,int);
float***  fmatrix_allocate_3d(int,int,int);
float**** fmatrix_allocate_4d(int,int,int,int);

int*      imatrix_allocate_1d(int);
int**     imatrix_allocate_2d(int,int);
int***    imatrix_allocate_3d(int,int,int);

void  free_dmatrix_1d(double*);
void  free_dmatrix_2d(double**);
void  free_dmatrix_3d(double***,int);

void  free_fmatrix_1d(float*);
void  free_fmatrix_2d(float**);
void  free_fmatrix_3d(float***,int);
void  free_fmatrix_4d(float****,int,int);

void  free_imatrix_1d(int*);
void  free_imatrix_2d(int**);
void  free_imatrix_3d(int***,int);

void  Recal(float**,int,int);
void  RecalS(float**,int,int); 
void  RecalS(float***,int,int,int); 
void  MaxMin(float**,int);
void  copy_matrix(float**,float**,int,int); 

float  randomize2(void);
float  random_flo(float c);
void   sgenrand(unsigned long seed);
double genrand();

void    fourn(float*,unsigned long*,int,int);
void    fourn2(float***,float***,int*,int,int);
void    FFTDD(float**,float**,int,int);
void    IFFTDD(float**,float**,int,int);
void    four1(float*,unsigned long,int);
void    FFT1D(float*,float*,int);
void    IFFT1D(float*,float*,int);
void    ReMkeVct(float*,int);
void    ModVct(float*,float*,float*,int);
void    Mod(float**,float**,float**,int,int);
void    ReMkeImg(float**,int,int);
void    InverseSense2(float**,int,int);
void    Mult(float**,float,int,int);
void    Recal3(float**,int,int); 
void    Info(float**,int,int);
void    ZeroSquareMat(float**,int);
void    CopySquareMatrix(float**,float**,int);
void    CopyNonSquareMatrix(float**,float**,int,int);
void    RecalMoySquareMat(float**,float**,int);
void    RecalMoySquareMat(float**,float,int); 
void    MinMaxSquareMat(float**,int,int,int);
void    DFT(float*,float*,int,int);
void    DFT(float**,float**,int,int,int);
bool    IsPowerOfTwo(int);
void    GaussianFilterImgNS(float**,int,int,float,float);

void   PlantSeeds(long);
void   PutSeed(long);
void   GetSeed(long*);
void   SelectStream(int);

double Random(void);
long   Poisson(double);
double Uniform(double, double);
double Exponential(double);

void   load_imageimg2(char*,float***,float***,int,int,int);
void   load_imageimg2b(char*,float***,float***,int,int,int);

void   save_image(char*,float***,int,int,int);
void   save_image2(char*,float***,int,int,int);

void   load_imageSUNS(char*,float**,int,int,int);
void   load_imageSUNS2(char*,float**,int,int,int);
void   ByteSwap(unsigned char*,int);

//--->Load/Save File
void GetLengthWidth(char*,int*,int*);
void load_image_pgm(char*,int**,int,int);
void SaveImagePgm(char*,char*,float**,int,int);
