//---------------------------------------------------
// module  : Haar.h                         
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                 
//---------------------------------------------------
// 

#ifndef HAAR_H
#define HAAR_H

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include <stdio.h>

#include "Function.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define BIGNUMBER 100000000

//------------------------------------------------
// CLASSE HAAR -----------------------------------
//------------------------------------------------
class Haar 
{
 //-- Donnees --
 //-------------
 public:

 //Matrices
 float**  mat;
 float**  mat_dec;
 float**  mat_rec;
 float**  mat_decvisu;

 //Vecteur
 float*  vect;
 float*  vect_dec;
 float*  vect_rec;
 float*  vect_tmp;

 //Donnee
 int   FlagComment;
 int   width,length;
 int   Size,size;
 int   NbLevels;
 float Sigma2Noise;
 float Tau;

 //---------------
 //UDWT ----------
 //--------------
 float**  mat_udwt;
 float**  mat_udwt_dec;
 float**  mat_udwt_rec;

 float*   vect_udwt;
 float*   vect_udwt_dec;
 float*   vect_udwt_rec; 
 float*   vect_udwt_tmp;
 float*   vect_udwt_tmp2;
 float*   vect_udwt_tmp3;
 float*   vect_iudwt;
 float*   vect_iudwt_tmp;
 float*   vect_iudwt_tmp2;
 float*   vect_iudwt_tmp3;  
 float**  tabvect_iudwt;
 int      nlev_udwt;
     
 //-- Methodes --
 //--------------
 public:
  Haar(int,int);
  ~Haar();

  //Decomposition
  void DecomposeHaar2D(int);
  void DecomposeInvHaar2D();

  //Utile
  void Haar1D(float*,int);
  void HaarInv1D(float*,int);
  void RecalImgDec(float**);

  //Debug
  void AfficheVect(float*,int);

  //-------------------
  //-----UDWT----------
  //-------------------
  void UDWT_2D(int);
  void IUDWT_2D();
  void UDWT_1D_(float*,int);
  void IUDWT_1D_(float*,int);

  //Denoising
  void FilteringUDWT16x16_(float**,int,float,float,int,int);
  void FilteringUDWT(float**,float,float,int);

  //Utile---------------
  void Haar1D_(float*,int);
  void HaarInv1D_(float*,int);
  void Decal(float*,int);
  void Recal(float*,int);
  void Copy(float*,float*,int);
  void Average(float*,float*,float*,int);
};

#endif 
