//---------------------------------------------------
// module  : Tomograph.h                         
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                 
//---------------------------------------------------
// 

#ifndef TOMOGRAPH_H
#define TOMOGRAPH_H

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include <stdio.h>

#include "Function.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------

//------------------------------------------------
// CLASSE TOMOGRAPH  -----------------------------
//------------------------------------------------
class Tomograph 
{
  //-- Donnees --
  //-------------
  public:

   //Matrices
   float**    mat_img;
   float**    mat_tmp1;

   float**    mat_radon;
   float**    mat_radon_visu;

   float**    mat_radonRFFT;
   float**    mat_radonIFFT;
   float**    mat_radonMFFT;
   
   int width,length;
   int size;

   int width_radon,length_radon;
   int nbslices;

   //Donnee
   float MoyImg;

   //Vecteurs
   float*  VctR;
   float*  VctI;
   float*  VctM;

 protected:
        
  //-- Methodes --
  //--------------
  public:
    Tomograph(int,int,int);
    ~Tomograph();

    void SimulateTomograph(int**);
    void ReComputeFFT();

    //Utile 
    void rotation(float**,float**,int,int,float);
    void ComputeMoyImg();
    void Addition();
   
  //-------------------------------------------------
  //--- Fonctions Amies  ----------------------------
  //-------------------------------------------------
  friend unsigned char** cmatrix_allocate_2d(int,int);
  friend void            free_cmatrix_2d(unsigned char**);

  friend float*    fmatrix_allocate_1d(int);
  friend float**   fmatrix_allocate_2d(int,int);
  friend float***  fmatrix_allocate_3d(int,int,int);
  friend float**** fmatrix_allocate_4d(int,int,int);

  friend int*    imatrix_allocate_1d(int);
  friend int**   imatrix_allocate_2d(int,int);
  friend int***  imatrix_allocate_3d(int,int,int);
  friend int**** imatrix_allocate_4d(int,int,int,int);

  friend void free_fmatrix_1d(float*);
  friend void free_fmatrix_2d(float**);
  friend void free_fmatrix_3d(float***,int);
  friend void free_fmatrix_4d(float****,int,int);

  friend void free_imatrix_1d(int*);
  friend void free_imatrix_2d(int**);
  friend void free_imatrix_3d(int***,int);
  friend void free_imatrix_4d(int****,int,int);        
};

#endif 
