//---------------------------------------------------
// module  : f_FilteredRetroProjection.cc                         
// auteur  : Max Mignotte                           
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "FilteredRetroProjection.h"

//------------------------------------------------
// METHODES DE LA CLASSE FILTEREDRETROPROJECTION -
//------------------------------------------------
//----------------------------------------------------------
// Constructeur de la classe FilteredRetroProjection 
//----------------------------------------------------------
FilteredRetroProjection::FilteredRetroProjection(int lgth,int wdth,int nbsl) 
{ 
 int i,j;

 //Init. Parametres
 width=wdth; 
 length=lgth;
 size=length;
 nbslices=nbsl;
 width_radon=width;
 length_radon=nbslices;

 //Verification
 if (width!=length)
    { printf("\n Image non carree");
      exit(-1); }
 
 //Allocation memoire Matrix
 mat_img=fmatrix_allocate_2d(length,width);
 mat_tmp1=fmatrix_allocate_2d(length,width);
 mat_reconst=fmatrix_allocate_2d(length,width);

 Mat1=fmatrix_allocate_2d(length,width);
 Mat2=fmatrix_allocate_2d(length,width);
 Mat3=fmatrix_allocate_2d(length,width);

 mat_radon=fmatrix_allocate_2d(length_radon,width_radon);
 mat_radon_visu=fmatrix_allocate_2d(length_radon,width_radon);

 mat_radonRFFT=fmatrix_allocate_2d(length_radon,width_radon);
 mat_radonIFFT=fmatrix_allocate_2d(length_radon,width_radon);
 mat_radonMFFT=fmatrix_allocate_2d(length_radon,width_radon);
 mat_radonRFFTFiltered=fmatrix_allocate_2d(length_radon,width_radon);
 mat_radonIFFTFiltered=fmatrix_allocate_2d(length_radon,width_radon);
 mat_radonMFFTFiltered=fmatrix_allocate_2d(length_radon,width_radon);

 MPR=fmatrix_allocate_2d(length_radon,width_radon);
 MPI=fmatrix_allocate_2d(length_radon,width_radon);
 MPM=fmatrix_allocate_2d(length_radon,width_radon);
 
 //Allocation memoire Vector
 VctR=fmatrix_allocate_1d(width);
 VctI=fmatrix_allocate_1d(width);
 VctM=fmatrix_allocate_1d(width);

 //Init Boucle
 for(i=0;i<length;i++) for(j=0;j<width;j++) 
    mat_img[i][j]=0.0;

 //Init
 FlagWithoutRecalMoy=0;
 FlagWithoutRecalMoy2=0;
 FlagWithoutRecal=0; 
 MoyImg=0.0;
 Filtrage=0;
 Alpha=1.0;
}

//----------------------------------------------------------
// Destructeur de la classe FilteredRetroProjection
//----------------------------------------------------------
FilteredRetroProjection::~FilteredRetroProjection()
{ 
 //Liberation memoire Mtrix
 free_fmatrix_2d(mat_img);
 free_fmatrix_2d(mat_tmp1);
 free_fmatrix_2d(mat_reconst);
 free_fmatrix_2d(Mat1);
 free_fmatrix_2d(Mat2);
 free_fmatrix_2d(Mat3);
 free_fmatrix_2d(mat_radon);
 free_fmatrix_2d(mat_radon_visu);
 free_fmatrix_2d(mat_radonRFFT);
 free_fmatrix_2d(mat_radonIFFT);
 free_fmatrix_2d(mat_radonMFFT);
 free_fmatrix_2d(mat_radonRFFTFiltered);
 free_fmatrix_2d(mat_radonIFFTFiltered);
 free_fmatrix_2d(mat_radonMFFTFiltered);  
 free_fmatrix_2d(MPR);
 free_fmatrix_2d(MPI);
 free_fmatrix_2d(MPM); 

 //Liberation memoire Vector
 free(VctR);
 free(VctI);
 free(VctM); 
}

//-----------//
//--OPTIONS--//
//-----------//
//----------------------------------------------------------
// Options
//----------------------------------------------------------
void FilteredRetroProjection::Options(float** mt)
{
 int i,j;

 //Load Image 
 printf("\n       > Chargement Image");
 for(i=0;i<length;i++)  for(j=0;j<width;j++)  mat_img[i][j]=mt[i][j];
}

//---------------------//
//-- FONCTION CLIENT --//
//---------------------//
//----------------------------------------------------------
// Reconstruction
//----------------------------------------------------------
void FilteredRetroProjection::Reconstruction(float** mtradonrfft,float** mtradonifft)
{
 int i,j,r,t;
 int theta;
 float rotat;
 float fact;
 float Fnyquist;
 float fmin,fmax;
 float moyenne;

  //Initialisation
 for(i=0;i<length_radon;i++) for(j=0;j<width_radon;j++)
    { mat_radon[i][j]=0.0;
      mat_radon_visu[i][j]=0.0;
      mat_radonRFFT[i][j]=0.0;
      mat_radonIFFT[i][j]=0.0;
      mat_radonMFFT[i][j]=0.0; }

 for(i=0;i<width;i++) 
    { VctR[i]=0.0;
      VctI[i]=0.0; 
      VctM[i]=0.0; }

 //Presentation
 printf("\n\n");
 printf("\n     ----------------------------------------");
 printf("\n      RECONSTRUCTION RETRO-PROJECTION FILTRE ");
 printf("\n     ----------------------------------------");
 printf("\n       > Nb.Slices : [%d]",nbslices); 
 printf("\n       > Moy Img (Esti/TF-Radon) : [%.2f]\n",MoyImg); 
  
 //Load FFT Transf Radon
 for(i=0;i<length_radon;i++)  for(j=0;j<width_radon;j++)
    { mat_radonRFFT[i][j]= mtradonrfft[i][j];
      mat_radonIFFT[i][j]= mtradonifft[i][j]; }

 //Filtrage FFT de Transf Radon 
 if (Filtrage==0)
    {
     printf("\n       > Filtrage FFT de Transf Radon avec Rampe");
     for(theta=0;theta<nbslices;theta++)
        {
         for(r=0;r<width;r++) 
	    {
	     mat_radonRFFTFiltered[theta][r]=mat_radonRFFT[theta][r]*fabs(r-width/2);
	     mat_radonIFFTFiltered[theta][r]=mat_radonIFFT[theta][r]*fabs(r-width/2);
	     mat_radonMFFTFiltered[theta][r]=mat_radonMFFT[theta][r]*fabs(r-width/2);
	    }
        }
    }

  if (Filtrage==1)
     {
      printf("\n         [width:%d]",width);
      printf("\n       > Filtrage FFT de Transf Radon avec RaisedCosineRolloff [%.2f]",Alpha);
      Fnyquist=0.5;
      fmax=MIN(Alpha*Fnyquist,Fnyquist);
      fmin=-fmax;
      printf("\n            (Frequence F[min-max] [%.2f::%.2f] sur [-0.5::0.5])",fmin,fmax);
      fmax=(width/2)+(fmax*width);
      fmin=(width/2)+(fmin*width);
      Fnyquist=Fnyquist*width;
      printf("\n            (Frequence F[min-max] [%.0f::%.0f] [Fnyquist: %.0f])",fmin,fmax,Fnyquist);
      printf("\n         ");

      for(theta=0;theta<nbslices;theta++)
         {
          for(r=(int)fmin;r<(int)fmax;r++) 
	     {
	      fact=(0.5+0.5*cos((PI*fabs(r-width/2))/(Alpha*Fnyquist)));
              if (theta==0) if ((r%10)==0) printf("[%.1f]",fact);

	      mat_radonRFFTFiltered[theta][r]=mat_radonRFFT[theta][r]*fabs(r-width/2)*(fact);
	      mat_radonIFFTFiltered[theta][r]=mat_radonIFFT[theta][r]*fabs(r-width/2)*(fact);
	      mat_radonMFFTFiltered[theta][r]=mat_radonMFFT[theta][r]*fabs(r-width/2)*(fact);
	    }
        }
      }


  //FFT-1 de la fonction filtree 
  printf("\n       > FFT-1 du signal filtre");
  for(theta=0;theta<nbslices;theta++)
     {
      for(t=0;t<width;t++) 
	 {
	  VctR[t]=mat_radonRFFTFiltered[theta][t]; 
	  VctI[t]=mat_radonIFFTFiltered[theta][t];
	 }

       ReMkeVct(VctR,width);
       ReMkeVct(VctI,width);

       //-TFD------------------------------------------- 
       if (IsPowerOfTwo(width))  IFFT1D(VctR,VctI,width);
       if (!IsPowerOfTwo(width)) DFT(VctR,VctI,width,-1); 
       //-----------------------------------------------
  
       ReMkeVct(VctR,width);
       ReMkeVct(VctI,width);
       ModVct(VctM,VctR,VctI,width); 

       for (r=0;r<width;r++) 
	 {
	  MPR[theta][r]=VctR[r];
	  MPI[theta][r]=VctI[r];
	  MPM[theta][r]=VctM[r];
	 }
     }

   //Init
   for(i=0;i<length;i++) for(j=0;j<width;j++) 
     mat_reconst[i][j]=0.0;

   //Retroprojection
   printf("\n       > Retroprojection");
   fflush(stdout);
   for(theta=0;theta<nbslices;theta++)
      {
       for(i=0;i<length;i++) for(j=0;j<width;j++)
	 Mat2[i][j]=MPR[theta][i];

       rotat=theta*PI/nbslices;
       rotation(Mat3,Mat2,length,width,rotat);

       for(i=0;i<length;i++) for(j=0;j<width;j++)
	 mat_reconst[i][j]+=Mat3[i][j];
     }

  //Info
  moyenne=0.0;
  for(i=0;i<length;i++) for(j=0;j<width;j++) moyenne+= mat_img[i][j];

  if (moyenne)
     { moyenne/=(length*width);
       printf("\n       > MoyenneImgReelle=[%.2f]",moyenne); }

  //PourVisu
  if (FlagWithoutRecal)     Recal(mat_reconst,length,width);
  if (FlagWithoutRecalMoy)  RecalMoySquareMat(mat_reconst,mat_img,size);
  if (FlagWithoutRecalMoy2) RecalMoySquareMat(mat_reconst,MoyImg,size);
}

//-----------//
//-- UTILE --//
//-----------//
//----------------------------------------------------------
// Rotation mat1 -> mat2
//----------------------------------------------------------
void FilteredRetroProjection::rotation(float** mat2,float** mat1,int lgth,int wdth,float angle)
{
 int i, j, x, y;
 float xprime, yprime, tmp1, tmp2;

 //Rotation
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     {
      xprime=cos(angle)*(i-lgth/2)+sin(angle)*(j-wdth/2)+lgth/2;
      yprime=-sin(angle)*(i-lgth/2)+cos(angle)*(j-wdth/2)+wdth/2;
      x=(int) floor(xprime);
      y=(int) floor(yprime);
      if ((x>=0)&&(x<lgth-1)&&(y>=0)&&(y<wdth-1))
         {
         tmp1=mat1[x][y]+(xprime-x)*(mat1[x+1][y]-mat1[x][y]);
         tmp2=mat1[x][y+1]+(xprime-x)*(mat1[x+1][y+1]-mat1[x][y+1]);
         mat2[i][j]=tmp1+(yprime-y)*(tmp2-tmp1);
         }
     else mat2[i][j]=0.0;
    }
}









 
