//---------------------------------------------------
// module  : f_ICD.cc                         
// auteur  : Max Mignotte                           
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "ICD.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define DEBUG 0
#define MAXIM(a,b)   (((a)>(b))?(a):(b))

//------------------------------------------------
// METHODES DE LA CLASSE ICD ---------------------
//------------------------------------------------
//----------------------------------------------------------
// Constructeur de la classe ICD
//----------------------------------------------------------
ICD::ICD(int lgth,int wdth,int nbsl,int iit) 
{ 
 int i,j,k;

 //Init.Parametres
 width=wdth; 
 length=lgth;
 size=length;
 nbslices=nbsl;
 width_radon=width;
 length_radon=nbslices;
 width_proj=length*width;
 length_proj=width*nbslices;
 init=iit;

 //Verification
 if (width!=length)
    { printf("\n       >>> Image non carree");
     //exit(-1); 
    }

 if (size>=256)
    { printf("\n        >>> Trop Grand. Essayer sur lenna128");
     //exit(-1); 
    }

 printf("         ([%d][%d][%d])",length,width,nbslices);
 fflush(stdout);
 
 //Allocation memoire Matrix
 mat_img=fmatrix_allocate_2d(length,width);
 mat_reconst=fmatrix_allocate_2d(length,width);
 mat_reconstBestMAP=fmatrix_allocate_2d(length,width);
 mat_reconstBestMAPTest=fmatrix_allocate_2d(length,width);
 mat_reconst_prec=fmatrix_allocate_2d(length,width); 
 mat_initreconst=fmatrix_allocate_2d(length,width);
 mat_initreconstsave=fmatrix_allocate_2d(length,width);
 mat_tmp1=fmatrix_allocate_2d(length,width);
 mat_tmp2=fmatrix_allocate_2d(length,width);
 mat_tmp3=fmatrix_allocate_2d(length,width);
 mat_tmp4=fmatrix_allocate_2d(length,width);
 mat_radon=fmatrix_allocate_2d(length_radon,width_radon);
 mat_radonWithoutNoise=fmatrix_allocate_2d(length_radon,width_radon);
 mat_radonProj=fmatrix_allocate_2d(length_radon,width_radon);
 mat_radonProjWithoutNoise=fmatrix_allocate_2d(length_radon,width_radon);
 mat_radonNoise=fmatrix_allocate_2d(length_radon,width_radon); 
 mat_radon_visu=fmatrix_allocate_2d(length_radon,width_radon);
 mat_radonProj_visu=fmatrix_allocate_2d(length_radon,width_radon);
 mat_radonEsti=fmatrix_allocate_2d(length_radon,width_radon);
 mat_radonEsti_visu=fmatrix_allocate_2d(length_radon,width_radon);

 if ((length*width*nbslices)<2000000) Project=fmatrix_allocate_2d(length_proj,width_proj); 
 VectImg=fmatrix_allocate_1d(width_proj);
 VectImgF=fmatrix_allocate_1d(width_proj);
 
 Vecty=fmatrix_allocate_1d(length_proj); 
 VectNoise=fmatrix_allocate_1d(length_proj);
 VectyWithoutNoise=fmatrix_allocate_1d(length_proj); 

 VectProj=fmatrix_allocate_1d(length_proj); 
 VectProjError=fmatrix_allocate_1d(length_proj); 
 DiagVariance=fmatrix_allocate_1d(length_proj);

 //Algorithme ICD-2-3
 Median=fmatrix_allocate_2d(length,width); 

 //Algorithme ICD-4
 Bx=fmatrix_allocate_2d(length,width);
 By=fmatrix_allocate_2d(length,width);
 Bd1=fmatrix_allocate_2d(length,width);
 Bd2=fmatrix_allocate_2d(length,width);

 //Atlas & SPECT Sinogramme
 SinoRealSPECT=fmatrix_allocate_3d(length,nbslices,width);
 SinoRealSPECT2=fmatrix_allocate_3d(length,nbslices,width);
 SinoRealSPECT2Raw=fmatrix_allocate_2d(nbslices,width);
 ImgSinoRealSPECT=fmatrix_allocate_3d(length,nbslices,width);
 ImgSinoRealSPECT2=fmatrix_allocate_3d(length,nbslices,width);
 CoupeProjSPECT=fmatrix_allocate_3d(nbslices+38,length,width);    
 CoupeProjSPECTImag=fmatrix_allocate_3d(nbslices+38,length,width);  
 ImgCoupeProjSPECT=fmatrix_allocate_3d(nbslices+38,length,width); 

 //TableauMesure
 TabSnr=fmatrix_allocate_1d(DIXMILLE);

 //TabHistogramme
 VectHist=fmatrix_allocate_1d(NBGREYLEVELSMAX);

 //Flag
 flag_ShortProject=0;
 flag_RealSPECT=0;
 flag_Sym=0;

 //Init Matrix
 for(k=0;k<(nbslices+38);k++)
 for(i=0;i<length;i++)
 for(j=0;j<width;j++)
    { CoupeProjSPECT[k][i][j]=0.0;
      CoupeProjSPECTImag[k][i][j]=0.0;
      ImgCoupeProjSPECT[k][i][j]=0.0; }
 
 
 //Init Values
 ScalePhantom=1.0;
 WidthBlur=0;
 SigmaBlur=0.0;
 BestMAP_SNRTest=0.0;
 SliceNumber=SLC_SPECT;
}

//----------------------------------------------------------
// Destructeur de la classe ICD
//----------------------------------------------------------
ICD::~ICD()
{ 
 //Liberation memoire Mtrix
 if (mat_img)                free_fmatrix_2d(mat_img);
 if (mat_reconst)            free_fmatrix_2d(mat_reconst);
 if (mat_reconstBestMAP)     free_fmatrix_2d(mat_reconstBestMAP); 
 if (mat_reconstBestMAPTest) free_fmatrix_2d(mat_reconstBestMAPTest); 
 if (mat_reconst_prec)       free_fmatrix_2d(mat_reconst_prec);
 if (mat_initreconst)        free_fmatrix_2d(mat_initreconst);
 if (mat_initreconstsave)    free_fmatrix_2d(mat_initreconstsave);  
 if (mat_tmp1)               free_fmatrix_2d(mat_tmp1);
 if (mat_tmp2)               free_fmatrix_2d(mat_tmp2);
 if (mat_tmp3)               free_fmatrix_2d(mat_tmp3); 
 if (mat_tmp4)               free_fmatrix_2d(mat_tmp4);
 if (mat_radon)              free_fmatrix_2d(mat_radon);
 if (mat_radonWithoutNoise)  free_fmatrix_2d(mat_radonWithoutNoise);
 if (mat_radonProj)          free_fmatrix_2d(mat_radonProj);
 if (mat_radonProjWithoutNoise) free_fmatrix_2d(mat_radonProjWithoutNoise);
 if (mat_radon_visu)     free_fmatrix_2d(mat_radon_visu);
 if (mat_radonProj_visu) free_fmatrix_2d(mat_radonProj_visu);
 if (mat_radonNoise)     free_fmatrix_2d(mat_radonNoise);
 if (mat_radonEsti)      free_fmatrix_2d(mat_radonEsti);
 if (mat_radonEsti_visu) free_fmatrix_2d(mat_radonEsti_visu);

 if (Project) free_fmatrix_2d(Project); 
 if (VectImg) free_fmatrix_1d(VectImg);
 if (VectImg) free_fmatrix_1d(VectImgF);

 if (Vecty)             free_fmatrix_1d(Vecty);
 if (VectNoise)         free_fmatrix_1d(VectNoise);
 if (VectyWithoutNoise) free_fmatrix_1d(VectyWithoutNoise);
 
 if (VectProj)          free_fmatrix_1d(VectProj);
 if (VectProjError)     free_fmatrix_1d(VectProjError);
 if (DiagVariance)      free_fmatrix_1d(DiagVariance); 

 //ICD-2-3
 if (Median) free_fmatrix_2d(Median); 

 //ICD-4
 if (Bx)  free_fmatrix_2d(Bx); 
 if (By)  free_fmatrix_2d(By); 
 if (Bd1) free_fmatrix_2d(Bd1);
 if (Bd2) free_fmatrix_2d(Bd2);

 //Atlas
 if (SinoRealSPECT)       free_fmatrix_3d(SinoRealSPECT,NBSLC_SPECT);
 if (SinoRealSPECT2)      free_fmatrix_3d(SinoRealSPECT2,NBSLC_SPECT);
 if (SinoRealSPECT2Raw)   free_fmatrix_2d(SinoRealSPECT2Raw);
 if (ImgSinoRealSPECT)    free_fmatrix_3d(SinoRealSPECT,NBSLC_SPECT);
 if (ImgSinoRealSPECT2)   free_fmatrix_3d(SinoRealSPECT2,NBSLC_SPECT);
 if (CoupeProjSPECT)      free_fmatrix_3d(CoupeProjSPECT,NBSLC_SPECT);
 if (CoupeProjSPECTImag)  free_fmatrix_3d(CoupeProjSPECTImag,NBSLC_SPECT);
 if (ImgCoupeProjSPECT)   free_fmatrix_3d(ImgCoupeProjSPECT,NBSLC_SPECT);

 //Libere Tableau Mesure
 if (TabSnr)  free_fmatrix_1d(TabSnr);

 //Libere Tableau Histo
 if (VectHist) free_fmatrix_1d(VectHist);

 //Libere Objet
 if (dct)       delete dct;
 if (udwt)      delete udwt;
}

//------------------------------------------------------------------------------------//
//--------------------------------- FONCTIONS CLIENT ---------------------------------//
//------------------------------------------------------------------------------------//
//---------------------
//---------------
//-- SYNTHETIQUE
//---------------
//---------------------
//----------------------------------------------------------
// Reconstruction
//----------------------------------------------------------
void ICD::Reconstruction(Tomograph* tomo)
{
 int i,j;


 //Recup Moyenne Img
 MoyImg=(*tomo).MoyImg;
 printf("\n       > MoyImg (Esti/TF-radon) [%.2f]",MoyImg);

 //WithouNoise
 for(i=0;i<length_radon;i++)  for(j=0;j<width_radon;j++) 
    mat_radonWithoutNoise[i][j]=(*tomo).mat_radon[i][j];

 //Blur
 if (SigmaBlur) AddBlurOnMatrix((*tomo).mat_radon,length_radon,width_radon,SigmaBlur);

 //ScaleReduction
 if (ScaleReduc!=1.0) 
    { printf("\n       > Reduction [%.1f]",ScaleReduc);
      for(i=0;i<length_radon;i++)  for(j=0;j<width_radon;j++) 
      (*tomo).mat_radon[i][j]=(int)(((*tomo).mat_radon[i][j])/(ScaleReduc)); }

 //Bruit 
  if (varnoise)  printf("\n       >>>>>>> BRUIT DE POISSON");
  for(i=0;i<length_radon;i++)  for(j=0;j<width_radon;j++) 
         { 
          if (varnoise) (*tomo).mat_radon[i][j]=Poisson((int)(*tomo).mat_radon[i][j]); 
          if (ScaleReduc!=1.0) (*tomo).mat_radon[i][j]*=ScaleReduc;
          if (varnoise)  mat_radonNoise[i][j]=((*tomo).mat_radon[i][j]-mat_radonWithoutNoise[i][j]);  
          mat_radon[i][j]= (*tomo).mat_radon[i][j];
          mat_radon_visu[i][j]= (*tomo).mat_radon_visu[i][j];
         }
      
  if (varnoise) ComputePoissonNoise(mat_radonNoise,length_radon,width_radon);   
  if (varnoise) ComputeRSBNoise(mat_radonWithoutNoise,mat_radonNoise,length_radon,width_radon); 
  if (varnoise) (*tomo).ReComputeFFT(); 
    
 //Initialisation FBP (Filtered Back Projection)
 //--------------------------------------------
 if (init==INIT_FBP)
    { FilteredRetroProjection retrproj(length,width,nbslices);
      retrproj.Options(mat_img);
      retrproj.MoyImg=MoyImg;
      retrproj.FlagWithoutRecal=1; 
      retrproj.Reconstruction((*tomo).mat_radonRFFT,(*tomo).mat_radonIFFT);
      CopySquareMatrix(retrproj.mat_reconst,mat_initreconst,size); 
      printf("\n       > Initialisation FBP"); }

  //Init Cst
  //--------
  if (init==INIT_CST) 
     { for(i=0;i<length;i++)  for(j=0;j<width;j++) mat_initreconst[i][j]=(NbGreyLevels/2);
       printf("\n       > Initialisation CST"); }

  //---------------
  //Initialisation
  //---------------
  //Init Measure
  Best_SNR=0.0;
  Stop_SNR=0.0;
  Best_iter=0;
  convmap=BIG_NUMBER;
  convimg=BIG_NUMBER;

  //Info sur Phantom
  InfoPhantom(mat_img,size);

  //Init Reconst
  CopySquareMatrix(mat_initreconst,mat_reconst,size);

  //Calcul Matrix P  
  printf("\n\n    ------------------------");
  printf("\n     CALCUL MATRIX PROJECT");
  printf("\n    ------------------------");
  ComputeVarianceProjection();

  //ComputeDirectlyShortProjectMatrix();

  ComputeProjectMatrix();
  ComputeRadonMatrix();
  printf("            [Error: %f %%]\n",ComputeError(mat_radonWithoutNoise,mat_radonProj,length_radon,width_radon));
  ComputeNewShortProjectMatrix();  
    
  //Ajout du Blur et Bruit
  AddPoissonNoiseToVectyFromTomo();
  
  //Calcul Mat_reconst en Vct
  printf("\n       > Calcul Matrice Init.Reconst. > Vct");
  ConvertMatVct(mat_reconst,VectImgF,length,width);

  //Calcul Projection Error
  if (!flag_ShortProject) ComputeProjectionError();           //--NSR---
  if (flag_ShortProject)  ComputeNewShortProjectionError();   // e=p-Proj.f  Avec p=Vecty[i]=RealSinogBruite  
  printf("\n       Methode > %d",Method);
  fflush(stdout);

   //DCT-UDWT
   if ((SubMethod==10)||(SubMethod>=13))
      { dct=new DCT(length,width); (*dct).FlagSilent=1; }

   if (SubMethod==11) udwt=new Haar(16,16);
   if (SubMethod==12) udwt=new Haar(length,width);

  //---------------
  //Choix ---------
  //---------------
  if (Method==-13) PE_EM();

 
 //SNR_Stop = SNR
 Stop_SNR=SNR;

 //SNR [mat_reconst]
 printf("\n Resultat Reconstruction");
 printf("\n -----------------------");
 printf("\n MMSE = %.7f    SNR = %.2f dB  [%.2f][%d iters]",MMSE,SNR,Best_SNR,Best_iter);
 printf("\n BEST MAP-SNR = [%.2f dB]  BEST MAP-MMSE = [%.6f]  [[%d iters]]",BestMAP_SNR,BestMAP_MMSE,BestMAP_iter);

 //Parametre Resultat-Sauvegarde
 printf("\n\n Extension Sauvegarde");
 printf("\n -------------------");
 FillResReconstruction();
 strcpy(Name_Sauve,Name_Img);
 strcat(Name_Sauve,Par_Recons);
 printf("\n  > %s \n\n",Name_Sauve);

 //Info
 printf("\n\n ");

 //Affiche Tableau ISNR
 if (flag_tab) 
    { printf("\n\n Fichier ISNR");
      printf("\n ------------");
      AfficheTabSnr(TabSnr); }

 //Matrice Radon
 ComputeNewShortRadonMatrix(mat_radonEsti,mat_reconst); 
 CopyNonSquareMatrix(mat_radonEsti,mat_radonEsti_visu,length_radon,width_radon);
 Recal(mat_radonEsti_visu,length_radon,width_radon);

 //Recalage
 Recal(mat_reconst,length,width);
 Recal(mat_reconstBestMAP,length,width);
 Recal(mat_initreconst,length,width);
 
 //Sauvegarde
 if (flag_save) Save_picture_pgm("",Name_Sauve,"",mat_reconstBestMAP,width,length);
 fflush(stdout);
 
 //Info
 printf("\n\n Statistiques");
 printf("\n ------------\n"); 
 printf("     [Error: %f %%]\n",ComputeError(mat_radonWithoutNoise,mat_radonProj,length_radon,width_radon));
 printf("     [Error: %f %%]\n",ComputeError2(mat_radonEsti,mat_radonProj,length_radon,width_radon));
}

//-------------------------------------------------------------
//-------------------------------------------------------
//-- REAL SPECT SOUCY
//-------------------------------------------------------
//-------------------------------------------------------------
//----------------------------------------------------------
// Reconstruction ImgRealSPECT
//----------------------------------------------------------
void ICD::ReconstructionRealSPECT(Tomograph* tomo)
{
 int i,j,k;
 

 //Transf. SinoRealSPECT2[SLC_SPECT] > (*tomo).mat_radon
 printf("       > Transfert Radon [%d : %d]",nbslices,width);

 if (!flag_tab)
 for(i=0;i<nbslices;i++) for(j=0;j<width;j++)
    (*tomo).mat_radon[i][j]=SinoRealSPECT2[SliceNumber][i][j];
 
 if (flag_tab)
 for(k=0;k<nbslices;k++) for(i=0;i<length;i++) 
   (*tomo).mat_radon[k][i]=SinoRealSPECT2[i][k][SliceNumber];

 //Transf. ImgSinoRealSPECT2[SLC_SPECT] > (*tomo).mat_radon_visu
 if (!flag_tab)
 for(i=0;i<nbslices;i++) for(j=0;j<width;j++)
    (*tomo).mat_radon_visu[i][j]=ImgSinoRealSPECT2[SliceNumber][i][j];

 if (flag_tab)
 for(k=0;k<nbslices;k++) for(i=0;i<length;i++) 
    (*tomo).mat_radon_visu[k][i]=ImgSinoRealSPECT2[i][k][SliceNumber];

 //MODIF-------------------------------------------------------
 //      [pour Addition sinogramme apres FPB]
 //------------------------------------------------------------
 if (0)
    {
     (*tomo).Addition();
     nbslices=(int)((float)nbslices/2.0);
     printf("\n       >Nouveau Nombre de Slices >>>> [%d] ",nbslices);
     printf("\n");
    }
 //----------------------------------------------------------- 

 //Sauvegarde
 Save_picture_pgm("","SinoSpectTranche","",(*tomo).mat_radon_visu,width,nbslices); 
 CopyNonSquareMatrix((*tomo).mat_radon_visu,mat_radon_visu,length_radon,width_radon);

 //Recup Moyenne Img
 (*tomo).ComputeMoyImg();
 MoyImg=(*tomo).MoyImg;
 printf("\n       > MoyImg (Esti/TF-radon) [%.2f]",MoyImg);
 fflush(stdout);

 //PreCalcul FFT
 (*tomo).ReComputeFFT(); 

    
 //Initialisation FBP (Filtered Back Projection)
 //--------------------------------------------
 if (init==INIT_FBP)
    { FilteredRetroProjection retrproj(length,width,nbslices);
      retrproj.MoyImg=MoyImg;
      retrproj.FlagWithoutRecal=1; 
      if (flag_Spect != 3) retrproj.Filtrage=1; 
      if (flag_Spect == 3) retrproj.Filtrage=0; 
      retrproj.Alpha=rcf_factor;
      retrproj.Reconstruction((*tomo).mat_radonRFFT,(*tomo).mat_radonIFFT);
      CopySquareMatrix(retrproj.mat_reconst,mat_initreconst,size);
      CopySquareMatrix(mat_initreconst,mat_reconst,size); 
      printf("\n       > Initialisation FBP"); 
      Save_picture_pgm("","FBP","",mat_initreconst,width,length); }
     

  //Init Cst
  //--------
  if (init==INIT_CST) 
     { for(i=0;i<length;i++)  for(j=0;j<width;j++) mat_initreconst[i][j]=(NbGreyLevels/2);
       CopySquareMatrix(mat_initreconst,mat_reconst,size);
       printf("\n       > Initialisation CST"); }

  //---------------
  //Initialisation
  //---------------
  //Init Measure
  Best_SNR=0.0;
  Stop_SNR=0.0;
  Best_iter=0;
  convmap=BIG_NUMBER;
  convimg=BIG_NUMBER;

  //Calcul Matrix Projection
  //------------------------ 
  printf("\n\n    -----------------------");
  printf("\n     CALCUL MATRIX PROJECT");
  printf("\n    -----------------------");
  
  ComputeVarianceProjection();         
  ComputeProjectMatrix();                 //>Compute Project [width*nbslices,length*width]
  ComputeNewShortProjectMatrix();         //>Compute ShortProject/ShortProject2 from Project
  ConvertMatVct(mat_reconst,VectImgF,length,width);

  //-----------------------------------------------------
  //Recalage de SinoRealSPECT2[SLC_SPECT] sur mat_reconst
  //-----------------------------------------------------
  printf("\n       > Recalage Sinogramme");
  fflush(stdout);
  LSCorrectionInitSPECTImg();           
  for(i=0;i<nbslices;i++) for(j=0;j<width;j++)
     SinoRealSPECT2[SliceNumber][i][j]*=FactAtten*1.0;     
  
  //SinoRealSPECT2[SLC_SPECT] en Vecty[]
  printf("       > Calcul SinoSPECT > Vct");
  ConvertMatVct(SinoRealSPECT2[SliceNumber],Vecty,nbslices,128);  

  //Calcul Mat_reconst en VectImgF[]
  printf("\n       > Calcul Matrice Init.Reconst. > Vct");
  ConvertMatVct(mat_reconst,VectImgF,length,width);

  //Calcul Projection Error
  ComputeNewShortProjectionError();       //>e=p-Proj.f  Avec p=Vecty[i]=RealSinogram  
                                          //>Initialisation  VectProj & VectProjError

  //Calcul Likelihood 
  printf(" [Likelihhood = %.0f]",ComputeLikelihood()/MILLE);

  //Info
  printf("\n       Methode > %d",Method);
  fflush(stdout);

   //DCT-UDWT
   if ((SubMethod==10)||(SubMethod>=13)) 
      { dct=new DCT(length,width); (*dct).FlagSilent=1; }

   if (SubMethod==11) udwt=new Haar(16,16);
   if (SubMethod==12) udwt=new Haar(length,width);

  //---------------
  //Choix ---------
  //---------------
  if (Method==-13) PE_EM();
 
 
 //SNR_Stop = SNR
 Stop_SNR=SNR;

 //SNR [mat_reconst]
 printf("\n Resultat Reconstruction");
 printf("\n -----------------------");
 printf("\n MMSE = %.7f    SNR = %.2f dB  [%.2f][%d iters]",MILLION*MMSE,SNR,Best_SNR,Best_iter);
 printf("\n BEST MAP-SNR = [%.2f dB]  BEST MAP-MMSE = [%.6f]  [[%d iters]]",BestMAP_SNR,BestMAP_MMSE,BestMAP_iter);  
 //Parametre Resultat-Sauvegarde
 printf("\n\n Extension Sauvegarde");
 printf("\n --------------------");
 FillResReconstruction2();
 strcpy(Name_Sauve,Name_Img);
 strcat(Name_Sauve,Par_Recons);
 printf("\n  > %s \n\n",Name_Sauve);

 //Info
 printf("\n\n ");

 //Affiche Tableau ISNR
 if (flag_tab) 
    { printf("\n\n Fichier ISNR");
      printf("\n ------------");
      AfficheTabSnr(TabSnr); }

 //Matrice Radon
 ComputeNewShortRadonMatrix(mat_radonEsti,mat_reconst); 
 CopyNonSquareMatrix(mat_radonEsti,mat_radonEsti_visu,length_radon,width_radon);
 Recal(mat_radonEsti_visu,length_radon,width_radon);

 //Recalage
 Recal(mat_reconst,length,width);
 Recal(mat_reconstBestMAP,length,width);

 //Sauvegarde
 if (Method!=-1) if (flag_save) Save_picture_pgm("",Name_Sauve,"",mat_reconstBestMAP,width,length);
 if (Method==-1) if (flag_save) Save_picture_pgm("",Name_Sauve,"",mat_reconst,width,length);
 fflush(stdout);
 
 //Info
 printf("\n\n Statistiques");
 printf("\n ------------\n"); 
 printf("     [Error: %f %%]\n",ComputeError(mat_radonWithoutNoise,mat_radonProj,length_radon,width_radon));
 printf("     [Error: %f %%]\n",ComputeError2(mat_radonEsti,mat_radonProj,length_radon,width_radon));
}

//------------------------------------------------------------------------
//------------------------------------------------------------------------
// EM --------------------------------------------------------------------
//------------------------------------------------------------------------
//----------------------------------------------------------
// PE_EM_Init pour Init Segmentation
//----------------------------------------------------------
void ICD::PE_EM_Init()
{
 int i,j,k,l;
 float nrjmap;
 float snr;
 float old_map;
 float Best_MAP;
 float tmp,tmp2;
 int   np;
 int   nbpx;
 float pnrj;

  //Init 
  pnrj=0.0;
  nrjmap=0.0;

  //-----------------------------------
  //Presentation-----------------------
  //-----------------------------------
  printf("\n");
  printf("\n     ---------------------------");
  printf("\n      RECONSTRUCTION PE-EM-Init ");
  printf("\n     ---------------------------");
  printf("\n       > Nb.Slices : [%d]",nbslices); 
  printf("\n       > Init:       [%d] (0:FBP 1:DFT 2:CST)",init);
  printf("\n       > NbIters:    [%d]",NbIters); 
  printf("\n       --------------------");
  printf("\n       > VarNoise = [%.1f]",varnoise);
  printf("\n       > ScaleReduc = [%.1f]",ScaleReduc);
  printf("\n       > NbGreyLevels = [%d]",NbGreyLevels);
  printf("\n       --------------------");
  printf("\n       > CuttOff-Frequency = [%d]",CuttOff);
  printf("\n       --------------------");
  printf("\n       >>>> Gamma:    [%.3f]",Gamma);
  printf("\n       > QPrior:    [%.1f]",Qprior);
  printf("\n");
  fflush(stdout);

  //Init Reconst
  ConvertMatVct(mat_reconst,VectImgF,length,width);

  //------------------
  //Boucle Principale
  //------------------
  printf("\n\n Boucle PE-EM-Init");
  printf("\n -----------------\n");

  //Stats
  snr=ComputeSNR(mat_img,mat_reconst);
  printf("\n [0] >   MAP=%.3f    (L:%.5f    P:%.8f)", nrjmap,NrjLikelihood/MILLE,NrjPrior/MILLE);   
  printf("           <SNR=%.3f> <MMSE=%.4f>",snr,ComputeMMSE(mat_img,mat_reconst));
  if (snr>Best_SNR) { Best_SNR=snr; Best_iter=0; }
  Best_MAP=nrjmap;
  BestMAP_SNR=ComputeSNR(mat_img,mat_reconst);
  BestMAP_MMSE=MMSE=ComputeMMSE(mat_img,mat_reconst);
  BestMAP_iter=0;
  Best_SNR=ComputeSNR(mat_img,mat_reconst);
  Best_iter=0;
  printf("\n");

 
  //--------------------
  //Boucle
  //--------------------
  for(k=1;k<NbIters;k++)
     {
      printf("\n [%d]",k);
      if ((k>ITER_MINI)&&((convmap<1)||(convimg<0.01))) break;

      //Conservation AncienneReconstruction
      CopySquareMatrix(mat_reconst,mat_reconst_prec,size);
      
      //-------------------- PE-EM-Init ----------------------------
      
          //>>>>>>>>>>>>>>1<<<<<<<<<<<<<<<
          ConvertMatVct(mat_reconst,VectImgF,length,width);
          ComputeNewShortProjectionError(); 
    
          //>>>>>>>>>>>>>>2<<<<<<<<<<<<<<<
          for(i=0;i<length;i++) for(j=0;j<width;j++)
             { 
              for(tmp=0.0,tmp2=0.0,np=(i*width)+j,l=0;l<length_shortproj;l++) 
                 {
                  nbpx=(int)ShortProject2[0][l][np];
                  if (nbpx!=-1)
                  if (VectProj[nbpx]) tmp+=ShortProject2[1][l][np]*(Vecty[nbpx]/VectProj[nbpx]); 
                  if (VectProj[nbpx]) tmp2+=ShortProject2[1][l][np];
                 }
	       
               
               if (tmp2+pnrj) mat_reconst[i][j]=mat_reconst[i][j]*(tmp/(tmp2+Gamma*pnrj));

              //Verif
              if (mat_reconst[i][j]>(NbGreyLevels-1)) mat_reconst[i][j]=(NbGreyLevels-1);
              if (mat_reconst[i][j]<0)                mat_reconst[i][j]=0;
              }

      //--------------------------------------------------------
      

     //Un Balayage complet
     ConvertMatVct(mat_reconst,VectImgF,length,width);
     old_map=nrjmap;

     snr=ComputeSNR(mat_img,mat_reconst);
     TabSnr[k]=snr;
     MMSE=ComputeMMSE(mat_img,mat_reconst);
     SNR=snr;
     printf("  >   MAP=%.4f   (L:%.5f    P:%.4f)",nrjmap,NrjLikelihood/MILLE,NrjPrior/MILLE);    
     printf("<SNR=%.3f> <MMSE=%.6f>",snr,MMSE); 
     if (snr>Best_SNR)     { Best_SNR=snr; Best_iter=k; }
     if (nrjmap<Best_MAP)  { //BestMAP_SNR=snr; BestMAP_MMSE=MMSE; BestMAP_iter=k; Best_MAP=nrjmap; 
                             CopySquareMatrix(mat_reconst,mat_reconstBestMAP,size); 
                             printf("*"); }

     //Convergence
     convmap=MILLION*ComputeL2Error(old_map,nrjmap);
     convimg=MILLION*ComputeMMSE(mat_reconst,mat_reconst_prec);
     printf("  > [%.1f]-[%.0f]",convimg,convmap); 
     fflush(stdout);

     } 
 
 //MMSE
 MMSE=ComputeMMSE(mat_img,mat_reconst);
}

//----------------------------------------------------------
//----------------------------------------------------------
// PE_EM
//----------------------------------------------------------
//----------------------------------------------------------
void ICD::PE_EM()
{
 int i,j,k,l;
 float nrjmap;
 float snr;
 float old_map;
 float Best_MAP;
 float tmp,tmp2;
 int   np;
 int   nbpx;
 float pnrj;
 int   GreyLevelCenter;
 float TrueGamma;

  //Init
  if (NbGreyLevels<NBGREYLEVELS) ICD_Init(); 
  pnrj=0.0;
  nrjmap=0.0;
  GreyLevelCenter=0;
  TrueGamma=0.0;
  
  //==== Pretraitements ===== 
   switch(SubMethod)
        { case -3 :  ;                                                 break;
          case -2 :  ;                                                 break;
          case -1 :  ;                                                 break;
          case  0 :  ;                                                 break;
          case  1 :  ;                                                 break;
          case  2 : CopySquareMatrix(mat_reconst,Median,size);         break;
          case  3 : CopySquareMatrix(mat_reconst,Median,size);         break;
          case  4 : break;
	  case 10 :  break;
          case 11 :  break;
          case 12 :  break;
          case 13 :  break;
          case 14 :  break;
	  case 15 :  TrueGamma=Gamma; Gamma=Qprior; break;
 	  case 16 :  TrueGamma=Gamma; Gamma=Qprior*TrueGamma; break;
          case 17 :  break;
          case 18 :  break;
         }


  //-----------------------------------
  //Presentation-----------------------
  //-----------------------------------
  printf("\n");
  printf("\n     ---------------------------");
  printf("\n      RECONSTRUCTION PE-EM      ");
  printf("\n     ---------------------------");
  printf("\n       > Nb.Slices : [%d]",nbslices); 
  printf("\n       > Init:       [%d] (0:FBP 1:DFT 2:CST)",init);
  printf("\n       > NbIters:    [%d]",NbIters); 
  printf("\n       --------------------");
  printf("\n       > VarNoise = [%.1f]",varnoise);
  printf("\n       > ScaleReduc = [%.1f]",ScaleReduc);
  printf("\n       > NbGreyLevels = [%d]",NbGreyLevels);
  printf("\n       --------------------");
  printf("\n       > SubMethod: [%d]",SubMethod);
  printf("\n       > Gamma:     [%.3f]",Gamma);
  printf("\n       > QPrior:    [%.1f]",Qprior);
  printf("\n       --------------------");
  printf("\n       --------------------");
  printf("\n       > CuttOff-Frequency = [%d]",CuttOff);
  printf("\n       --------------------");
  printf("\n");
  fflush(stdout);

  //Init Reconst
  ConvertMatVct(mat_reconst,VectImgF,length,width);

  //------------------
  //Boucle Principale
  //------------------
  printf("\n\n Boucle PE-EM");
  printf("\n ------------\n");

  //==== Energie ===== 
  switch(SubMethod)  
        { case -3 : nrjmap=ComputeLikelihood()/MILLE;        break;
          case -2 : nrjmap=ComputeLikelihood()/MILLE;        break;
          case -1 : nrjmap=ComputeLikelihood()/MILLE;        break;
          case  0 : nrjmap=(ICD0_ComputeMAP2())/MILLE;       break;
          case  1 : nrjmap=(ICD1_ComputeMAP())/MILLE;        break;
          case  2 : nrjmap=(ICD2_ComputeMAP(Median))/MILLE;  break;
          case  3 : nrjmap=(ICD3_ComputeMAP(Median))/MILLE;  break;
          case  4 : nrjmap=(ICD4_ComputeMAP())/MILLE;        break;
          case  10: nrjmap=ComputeLikelihood()/MILLE;        break;
          case  11: nrjmap=ComputeLikelihood()/MILLE;        break; 
          case  12: nrjmap=ComputeLikelihood()/MILLE;        break; 
          case  13: nrjmap=ComputeLikelihood()/MILLE;        break; 
          case  14: nrjmap=ComputeLikelihood()/MILLE;        break; 
          case  15: nrjmap=(ICD0_ComputeMAP2())/MILLE;       break; 
          case  16: nrjmap=(ICD0_ComputeMAP2())/MILLE;       break; 
          case  17: nrjmap=(ICD0_ComputeMAP2())/MILLE;       break;  
	  case  18: nrjmap=(ICD0_ComputeMAP2())/MILLE;       break;  }

  //Stats
  snr=ComputeSNR(mat_img,mat_reconst);
  printf("\n [0] >   MAP=%.3f    (L:%.5f    P:%.8f)", nrjmap,NrjLikelihood/MILLE,NrjPrior/MILLE);   
  printf("           <SNR=%.3f> <MMSE=%.4f>",snr,ComputeMMSE(mat_img,mat_reconst));
  if (snr>Best_SNR) { Best_SNR=snr; Best_iter=0; }
  Best_MAP=nrjmap;
  BestMAP_SNR=ComputeSNR(mat_img,mat_reconst);
  BestMAP_MMSE=MMSE=ComputeMMSE(mat_img,mat_reconst);
  BestMAP_iter=0;
  Best_SNR=ComputeSNR(mat_img,mat_reconst);
  Best_iter=0;
  printf("\n");

 
  //--------------------
  //Boucle
  //--------------------
  for(k=1;k<NbIters;k++)
     {
      printf("\n [%d]",k);
      if ((k>ITER_MINI)&&((convmap<1)||(convimg<0.01))) break;

      //Conservation AncienneReconstruction
      CopySquareMatrix(mat_reconst,mat_reconst_prec,size);
      
      //-------------------- PE-EM ----------------------------
      
          //>>>>>>>>>>>>>>1<<<<<<<<<<<<<<<
          ConvertMatVct(mat_reconst,VectImgF,length,width);
          ComputeNewShortProjectionError(); 
    
          //>>>>>>>>>>>>>>2<<<<<<<<<<<<<<<
          for(i=0;i<length;i++) for(j=0;j<width;j++)
             { 
              for(tmp=0.0,tmp2=0.0,np=(i*width)+j,l=0;l<length_shortproj;l++) 
                 {
                  nbpx=(int)ShortProject2[0][l][np];
                  if (nbpx!=-1)
                  if (VectProj[nbpx]) tmp+=ShortProject2[1][l][np]*(Vecty[nbpx]/VectProj[nbpx]); 
                  if (VectProj[nbpx]) tmp2+=ShortProject2[1][l][np];
                 }

	      //==== Prior ======
               switch(SubMethod)
                     { case -3 :  pnrj=0.0;                                                            break; 
                       case -2 :  pnrj=0.0;                                                            break;
                       case -1 :  pnrj=0.0;                                                            break; 
                       case  0 :  pnrj=ICD0_ComputeGMderive(i,j);                                      break;
                       case  1 :  pnrj=ICD1_ComputeGGMRFderive(i,j,mat_reconst[i][j]) ;                break;
                       case  2 :  pnrj=ICD2_ComputeMRPderive(i,j,mat_reconst[i][j],Median);            break;
                       case  3 :  pnrj=ICD3_ComputeMPderive(i,j,mat_reconst[i][j],Median);             break;
                       case  4 :  pnrj=ICD4_ComputeARTURderive(i,i,mat_reconst[i][j]);                 break; 
		       case  10 : pnrj=0.0;  NrjPrior=0.0;                                             break; 
                       case  11 : pnrj=0.0;  NrjPrior=0.0;                                             break;
                       case  12 : pnrj=0.0;  NrjPrior=0.0;                                             break; 
                       case  13 : pnrj=0.0;  NrjPrior=0.0;                                             break;
                       case  14 : pnrj=0.0;  NrjPrior=0.0;                                             break;  
		       case  15 : pnrj=ICD0_ComputeGMderive(i,j);                                      break; 
                       case  16 : pnrj=ICD0_ComputeGMderive(i,j);                                      break;  
		       case  17 : pnrj=0.0; if (k%2) pnrj=ICD0_ComputeGMderive(i,j);                   break;  
                       case  18 : pnrj=0.0;  NrjPrior=0.0;                                             break;  }  
               
               if (tmp2+pnrj) mat_reconst[i][j]=mat_reconst[i][j]*(tmp/(tmp2+Gamma*pnrj));

              //Verif
              if (mat_reconst[i][j]>(NbGreyLevels-1)) mat_reconst[i][j]=(NbGreyLevels-1);
              if (mat_reconst[i][j]<0)                mat_reconst[i][j]=0;
              }

      //--------------------------------------------------------
      

     //Un Balayage complet
     ConvertMatVct(mat_reconst,VectImgF,length,width);
     old_map=nrjmap;

     //Verif
     if ((SubMethod==5)||(SubMethod==6))
        {
         for(i=0;i<length;i++) for(j=0;j<width;j++)
	    { if ((fabs(mat_reconst[i][j]-mat_initreconst[i][j])>150)&&(mat_reconst[i][j]<0.1))
		 { mat_reconst[i][j]=mat_initreconst[i][j];
                   printf("!"); }
            }
        }

     //==== Energie =====
     switch(SubMethod) 
           { case -3  : nrjmap=ComputeLikelihood()/MILLE;         break;
             case -2  : nrjmap=ComputeLikelihood()/MILLE;         break;
             case -1  : nrjmap=ComputeLikelihood()/MILLE;         break;
             case  0  : nrjmap=(ICD0_ComputeMAP2())/MILLE;        break;
             case  1  : nrjmap=(ICD1_ComputeMAP())/MILLE;         break;
             case  2  : nrjmap=(ICD2_ComputeMAP(Median))/MILLE;   break;
             case  3  : nrjmap=(ICD3_ComputeMAP(Median))/MILLE;   break;
             case  4  : nrjmap=(ICD4_ComputeMAP())/MILLE;         break;
             case  10 : nrjmap=ComputeLikelihood()/MILLE;         break; 
             case  11 : nrjmap=ComputeLikelihood()/MILLE;         break; 
             case  12 : nrjmap=ComputeLikelihood()/MILLE;         break;  
             case  13 : nrjmap=ComputeLikelihood()/MILLE;         break; 
             case  14 : nrjmap=ComputeLikelihood()/MILLE;         break; 
             case  15 : nrjmap=(ICD0_ComputeMAP2())/MILLE;        break; 
             case  16 : nrjmap=(ICD0_ComputeMAP2())/MILLE;        break; 
             case  17 : nrjmap=(ICD0_ComputeMAP2())/MILLE;        break; 
             case  18 : nrjmap=(ICD0_ComputeMAP2())/MILLE;        break; }

     snr=ComputeSNR(mat_img,mat_reconst);
     TabSnr[k]=snr;
     MMSE=ComputeMMSE(mat_img,mat_reconst);
     SNR=snr;
     printf("  >   MAP=%.2f  (L:%.1f  P:%.1f)",nrjmap,NrjLikelihood/MILLE,NrjPrior/MILLE);    
     printf(" <SNR=%.3f> <MMSE=%.4f>",snr,MMSE); 
     if (snr>Best_SNR)     { Best_SNR=snr; Best_iter=k; }
     if (nrjmap<Best_MAP)  { BestMAP_SNR=snr; BestMAP_MMSE=MMSE; BestMAP_iter=k; Best_MAP=nrjmap; 
                             CopySquareMatrix(mat_reconst,mat_reconstBestMAP,size); 
                             printf("*"); }
     //Convergence
     convmap=MILLION*ComputeL2Error(old_map,nrjmap);
     convimg=MILLION*ComputeMMSE(mat_reconst,mat_reconst_prec);
     //printf("  > [%.1f]-[%.0f]",convimg,convmap); 
     fflush(stdout);


     //==== Postraitements ===== 
     switch(SubMethod)
        { 
         case  -3 :   if ((length==width)&&(IsPowerOfTwo(width))) 
                         { printf("\n\n\n  >  Filtre Butterworth"); 
                           ButterworthFilter(mat_reconst,length,width,8,CuttOff2); }
      
                      if (!IsPowerOfTwo(width)) 
                         { printf("\n\n\n  >  Filtre ButterworthNS");
                           ButterworthFilterNS(mat_reconst,length,width,8,CuttOff2); }    break;

          case  -2 :  if ((length==width)&&(IsPowerOfTwo(width))) 
                         { printf("\n\n\n  >  Filtre Butterworth"); 
                           ButterworthFilter(mat_reconst,length,width,8,CuttOff2); }

                      if (!IsPowerOfTwo(width)) 
                         { printf("\n\n\n  >  Filtre ButterworthNS");
                           ButterworthFilterNS(mat_reconst,length,width,8,CuttOff2); }   
                           CopySquareMatrix(mat_reconst,mat_reconstBestMAP,size);         break;
          case -1  :                                                                      break;
          case  0  :                                                                      break;
          case  1  :                                                                      break;
          case  2  : CopySquareMatrix(mat_reconst,Median,size);
                     MedianFilter2(Median,size);                                          break;
          case  3  : CopySquareMatrix(mat_reconst,Median,size);
                     ICD3_MedianFilter(Median,size);                                      break;
	  case  4  : if (!(k%4)) 
		        { ICD4_computeBxByBd(mat_reconst,size);  printf("<>"); }
                                                                                          break; 
  	  case  10 : (*dct).FilteringDCT8x8_(mat_reconst,Gamma,1);                        break;
          case  11 : (*udwt).FilteringUDWT16x16_(mat_reconst,size,1.0,Gamma,2,1);         break;
          case  12 : (*udwt).FilteringUDWT(mat_reconst,1.0,Gamma,3);                      break;
          case  13 : (*dct).FilteringDCT8x8rs_(mat_reconst,Gamma,1);                      break;
          case  14 : (*dct).FilteringDCT8x8st_(mat_reconst,Gamma,1);                      break;
          case  15 : (*dct).FilteringDCT8x8rs_(mat_reconst,TrueGamma,1);                  break;
          case  16 : (*dct).FilteringDCT8x8rs_(mat_reconst,TrueGamma,1);                  break;
	  case  17 : if (!(k%2)) 
                     { (*dct).FilteringDCT8x8rs_(mat_reconst,Qprior,1);         
		        MaxMin(mat_reconst,size); }                                       break; 
	  case  18 : tmp=MAXIM(Gamma*pow(Qprior,(float)k),Gamma/value_hyperpar);
	             //printf("<%.2f::%d>",tmp,int(value_hyperpar));
                     (*dct).FilteringDCT8x8rs_(mat_reconst,tmp,1);                        break; 
       } 
    }
 
 //MMSE
 MMSE=ComputeMMSE(mat_img,mat_reconst);

 //BiasVariance
 ComputeBiasVariance(mat_img,mat_reconstBestMAP);
}

//----------------------------------//
//----------------------------------//
   


