//---------------------------------------------------
// module  : f_ICD1.cc                         
// auteur  : Max Mignotte                           
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------


//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "ICD.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define DEBUG 0


//------------------------------------------------
// METHODES DE LA CLASSE ICD ---------------------
//------------------------------------------------
//-------------//
//-- OPTIONS --//
//-------------//
//----------------------------------------------------------
// Options
//----------------------------------------------------------
void ICD::Options(int** mt)
{
 int i,j;

 //Load Image 
 printf("\n       > Chargement Image");
 for(i=0;i<length;i++)  for(j=0;j<width;j++)  mat_img[i][j]=mt[i][j];
}

//----------------------------------------------------------
// Options2
//----------------------------------------------------------
void ICD::Options2(int Dv,int nbit,int met,float Gam,float Qp,int fls,char* nim,int flgt,float vn,float hyp)
{
 //Chargement
 Dvariance=Dv;
 NbIters=nbit;
 Method=met;
 Gamma=Gam;
 Qprior=Qp;
 flag_save=fls;
 flag_tab=flgt;
 strcpy(Name_Img,nim); 
 varnoise=vn;
 value_hyperpar=hyp;

 //Info
 printf("\n       > D-Variance: %d",Dvariance);
 printf("\n       > Methode: %d",Method);
 printf("\n       > Image: %s",Name_Img);
 printf("\n       > Variance Noise: %.2f",varnoise);
 printf("\n       > Value Hyper: %.2f",value_hyperpar);
}

//----------------------------------------------------------
// Options3
//----------------------------------------------------------
void ICD::Options3(float scr,int flt,char* com)
{
 //Chargement
 ScaleReduc=scr;
 flag_tests=flt;
 strcpy(Comment,com);

 //Info
 printf("\n       > Scale Reduction: %.2f",ScaleReduc);
 if (flt==1)  printf("\n       > Avec Test");
 printf("   (Commentaire: [%s])",Comment);

}

//----------------------------------------------------------
// Options4
//----------------------------------------------------------
void ICD::Options4(int nbgr,int wdthb)
{
 //Chargement
 NbGreyLevels=nbgr;
 WidthBlur=wdthb;
 SigmaBlur=0.425*WidthBlur;

 //Info
 printf("\n       > NbGreyLevels: %d",NbGreyLevels);
 printf("\n       > WidthBlur: %d",WidthBlur);
 printf("\n       > SigmaBlur: %.3f",SigmaBlur);
}

//----------------------------------------------------------
// Options pour le Filtrage          
//----------------------------------------------------------                
void ICD::OptionFilter(int cof,int cof2)
{
 //Enregistrement
  CuttOff=cof;
  CuttOff2=cof2;
 if (DEBUG) printf("\n CutOff:  [%d]",CuttOff);
 if (DEBUG) printf("\n CutOff2: [%d]",CuttOff2);
}

//----------------------------------------------------------
// Options pour le Filtrage          
//----------------------------------------------------------                
void ICD::OptionOthers(int sbmet,float atten,int flgs)
{
 //Enregistrement
  FactAtten=atten;
  SubMethod=sbmet;
  flag_Spect= flgs;
 if (DEBUG) printf("\n SubMethod: %d",SubMethod);
 if (DEBUG) printf("\n FacteurAttenuation: %.3f",FactAtten);
}

//----------------------------------------------------------
// Options pour RealSPECT  <SOUCY>         
//----------------------------------------------------------                
void ICD::OptionRealSPECT(char* pathSPECT,char* pathSPECT2,int nb,float rcffact)
{
 int i,j,k; 
 int cpt;         

 //Enregistrement
 flag_RealSPECT=1;
 SliceNumber=nb;
 rcf_factor=rcffact;

 //Load SPECT Sinogramme Compton
 printf("\n\n       > Chargement Sinogramme SPECT <%s>",pathSPECT);
 printf(" [%d:%d:%d]",NBSLC_SPECT,LENGTH_SPECT,WIDTH_SPECT); 
 load_imageimg2(pathSPECT,SinoRealSPECT,ImgSinoRealSPECT,NBSLC_SPECT,LENGTH_SPECT,WIDTH_SPECT);
 
 //Attente
 for(k=0;k<10;k++) ; 

 //Load SPECT Sinogramme 140kev
 printf("\n\n       > Chargement Sinogramme SPECT2 <%s>",pathSPECT2);
 printf(" [%d:%d:%d]",NBSLC_SPECT,LENGTH_SPECT,WIDTH_SPECT);  
 load_imageimg2(pathSPECT2,SinoRealSPECT2,ImgSinoRealSPECT2,NBSLC_SPECT,LENGTH_SPECT,WIDTH_SPECT);
 printf("\n");

 //Operation>[140kev - 43% Compton]
 if (1)
 for(k=0;k<length;k++)
 for(i=0;i<nbslices;i++) for(j=0;j<width;j++)
    { 
     SinoRealSPECT2[k][i][j]=SinoRealSPECT2[k][i][j]-0.0*SinoRealSPECT[k][i][j];           // >METTRE >0.43
     ImgSinoRealSPECT2[k][i][j]=ImgSinoRealSPECT2[k][i][j]-0.0*ImgSinoRealSPECT[k][i][j];  // >METTRE >0.43
     if (SinoRealSPECT2[k][i][j]<0)    SinoRealSPECT2[k][i][j]=0.0;      // A TESTER SANS >>>
     if (ImgSinoRealSPECT2[k][i][j]<0) ImgSinoRealSPECT2[k][i][j]=0.0;   
    }

 //MODIF-------------------------------------------------------
 //      [Pour Addition sinogramme avant FPB]
 //------------------------------------------------------------
 if (1)
    {
     printf("\n       >>>> Addition Sinogram >>>>");
     for(j=0;j<length;j++)
        {
         for(cpt=0,k=(int)(nbslices/2.0);k<=(int)(nbslices-1);k++,cpt++)
         for(i=0;i<width;i++)
            { SinoRealSPECT2[j][cpt][i]+=SinoRealSPECT2[j][k][width-1-i];
              ImgSinoRealSPECT2[j][cpt][i]+=ImgSinoRealSPECT2[j][k][width-1-i]; }
	}
 
         RecalS(ImgSinoRealSPECT2,length,nbslices,width);
         nbslices=(int)((float)nbslices/2.0);
         printf("\n       >Nouveau Nombre de Projections >>>> [%d] ",nbslices);
         printf("\n");    
    }

 //------------------------------------------------------------

 //Sauvegarde
 save_image("SinoSpectBrute.pgm",ImgSinoRealSPECT2,NBSLC_SPECT,LENGTH_SPECT,WIDTH_SPECT);

 //-----------------------------------------------------
 //ButterWorth sur les coupes Projectifs [128x128]
 //-----------------------------------------------------
 //Transfert
  printf("\n       > Transfert     ");
  fflush(stdout);
  for(k=0;k<nbslices;k++)
     for(i=0;i<length;i++) for(j=0;j<width;j++) 
       { CoupeProjSPECT[k][i][j]=SinoRealSPECT2[i][k][j];
         ImgCoupeProjSPECT[k][i][j]=ImgSinoRealSPECT2[i][k][j]; 
        }

  //Sauvegarde
  save_image2("CoupeSpectBrute.pgm",ImgCoupeProjSPECT,nbslices,length,width);
  copy_matrix(SinoRealSPECT2Raw,SinoRealSPECT2[SliceNumber],nbslices,width);

  //-----------------------------------------------------------------
  //ButterWorth 2D --------------------------------------------------
  //-----------------------------------------------------------------
  if (0)
     { printf("\n       > ButterWorth 2D ... ");
       for(k=0;k<nbslices;k++)
          { if ((k%20)==0) printf("[%d]",k);
            fflush(stdout);
            ButterworthFilterNS(CoupeProjSPECT[k],length,width,8,CuttOff);  
            CopySquareMatrix(CoupeProjSPECT[k],ImgCoupeProjSPECT[k],length);
            RecalS(ImgCoupeProjSPECT[k],length,width); } }
  //------------------------------------------------------------------

  //-----------------------------------------------------------------
  //ButterWorth 3D --------------------------------------------------
  //-----------------------------------------------------------------
  if (1)
     {  ButterworthFilter3D(CoupeProjSPECT,128,length,width,8,CuttOff);

      for(k=0;k<nbslices;k++)  
         { CopySquareMatrix(CoupeProjSPECT[k],ImgCoupeProjSPECT[k],length);
           RecalS(CoupeProjSPECT[k],length,width);
           RecalS(ImgCoupeProjSPECT[k],length,width); }
     }
  //------------------------------------------------------------------ 

  //Transfert
  printf("\n       > Transfert     ");
  for(k=0;k<nbslices;k++)
     for(i=0;i<length;i++) for(j=0;j<width;j++) 
       { SinoRealSPECT2[i][k][j]=CoupeProjSPECT[k][i][j];
         ImgSinoRealSPECT2[i][k][j]=ImgCoupeProjSPECT[k][i][j]; }
  
 //Sauvegarde
 save_image("SinoSpectFiltre.pgm",ImgSinoRealSPECT2,nbslices,length,width);
 save_image2("CoupeSpectFiltre.pgm",ImgCoupeProjSPECT,nbslices,length,width);

 //Info
 printf("\n\n       > Tranche numero              [%d]",SliceNumber);
 //printf("\n       > Raised Cosine Filter Factor [%.2f]\n",rcf_factor);
 }

//----------------------------------------------------------
// Options pour RealSPECT  <SOUCY>  (224*90*224)    
//----------------------------------------------------------                
void ICD::OptionRealSPECT2(char* pathSPECT,char* pathSPECT2,int nb,float rcffact)
{
 int i,j,k; 
 int cpt;       

 //Enregistrement
 flag_RealSPECT=1;
 SliceNumber=nb;
 rcf_factor=rcffact;

 //Load SPECT Sinogramme Compton
 printf("\n\n       > Chargement Sinogramme SPECT-(224*90*224) <%s>",pathSPECT);
 printf(" [%d:%d:%d]",NBSLC_SPECT,LENGTH_SPECT,WIDTH_SPECT); 
 load_imageimg2b(pathSPECT,SinoRealSPECT,ImgSinoRealSPECT,NBSLC_SPECT,LENGTH_SPECT,WIDTH_SPECT);
 
 //Attente
 for(k=0;k<10;k++) ; 

 //Load SPECT Sinogramme 140kev
 printf("\n\n       > Chargement Sinogramme SPECT2--(224*90*224) <%s>",pathSPECT2);
 printf(" [%d:%d:%d]",NBSLC_SPECT,LENGTH_SPECT,WIDTH_SPECT);  
 load_imageimg2b(pathSPECT2,SinoRealSPECT2,ImgSinoRealSPECT2,NBSLC_SPECT,LENGTH_SPECT,WIDTH_SPECT);
 printf("\n");

 //Operation>[140kev - 43% Compton]
 if (1)
 for(k=0;k<length;k++)
 for(i=0;i<nbslices;i++) for(j=0;j<width;j++)
    { 
     SinoRealSPECT2[k][i][j]=SinoRealSPECT2[k][i][j]-0.0*SinoRealSPECT[k][i][j];           //Mettre 0.43    
     ImgSinoRealSPECT2[k][i][j]=ImgSinoRealSPECT2[k][i][j]-0.0*ImgSinoRealSPECT[k][i][j];  //Mettre 0.43 
     if (SinoRealSPECT2[k][i][j]<0)    SinoRealSPECT2[k][i][j]=0.0;      
     if (ImgSinoRealSPECT2[k][i][j]<0) ImgSinoRealSPECT2[k][i][j]=0.0;   
    }

 printf("   ->[45][%d][%d]",LENGTH_SPECT,WIDTH_SPECT);
 fflush(stdout);
 if (1) save_image("SinoSpectBrute.pgm",ImgSinoRealSPECT2,45,LENGTH_SPECT,WIDTH_SPECT);

 //MODIF-------------------------------------------------------
 //      [Pour Addition sinogramme avant FPB]
 //------------------------------------------------------------
 if (1)
    {
     printf("\n       >>>> Addition Sinogram >>>>");
     for(j=0;j<length;j++)
        {
	  for(cpt=0,k=(int)((nbslices/2.0)+1);k<(int)(nbslices-1);k++,cpt++)
         for(i=0;i<width;i++)
	   { SinoRealSPECT2[j][cpt][i]=(SinoRealSPECT2[j][cpt][i]+SinoRealSPECT2[j][k][width-1-i])/2.0;
             ImgSinoRealSPECT2[j][cpt][i]=(ImgSinoRealSPECT2[j][cpt][i]+ImgSinoRealSPECT2[j][k][width-1-i])/2.0; }
	}
 
         RecalS(ImgSinoRealSPECT2,length,nbslices,width);
         nbslices=(int)((float)nbslices/2.0);
         printf("\n       >Nouveau Nombre de Projections >>>> [%d] ",nbslices);
         printf("\n");    
    }

 //------------------------------------------------------------

 //Sauvegarde
 if (0) save_image("SinoSpectBruteM.pgm",ImgSinoRealSPECT2,nbslices,LENGTH_SPECT,WIDTH_SPECT);

 //-----------------------------------------------------
 //ButterWorth sur les coupes Projectifs [128x128]
 //-----------------------------------------------------
 //Transfert
  printf("\n       > Transfert     ");
  fflush(stdout);
  for(k=0;k<nbslices;k++)
     for(i=0;i<length;i++) for(j=0;j<width;j++) 
       { CoupeProjSPECT[k][i][j]=SinoRealSPECT2[i][k][j];
         ImgCoupeProjSPECT[k][i][j]=ImgSinoRealSPECT2[i][k][j]; 
        }

  //Sauvegarde
  save_image2("CoupeSpectBrute.pgm",ImgCoupeProjSPECT,nbslices,length,width);
  copy_matrix(SinoRealSPECT2Raw,SinoRealSPECT2[SliceNumber],nbslices,width);

  //-----------------------------------------------------------------
  //ButterWorth 3D --------------------------------------------------
  //-----------------------------------------------------------------
  if (1)
     {  ButterworthFilter3D(CoupeProjSPECT,64,length,width,8,CuttOff);

      for(k=0;k<nbslices;k++)  
         { CopySquareMatrix(CoupeProjSPECT[k],ImgCoupeProjSPECT[k],length);
           RecalS(CoupeProjSPECT[k],length,width);
           RecalS(ImgCoupeProjSPECT[k],length,width); }
     }
  //------------------------------------------------------------------ 

  //Transfert
  printf("\n       > Transfert     ");
  for(k=0;k<nbslices;k++)
     for(i=0;i<length;i++) for(j=0;j<width;j++) 
       { SinoRealSPECT2[i][k][j]=CoupeProjSPECT[k][i][j];
         ImgSinoRealSPECT2[i][k][j]=ImgCoupeProjSPECT[k][i][j]; }
  
 //Sauvegarde
 if (0) save_image("SinoSpectFiltre.pgm",ImgSinoRealSPECT2,nbslices,length,width);
 if (0) save_image2("CoupeSpectFiltre.pgm",ImgCoupeProjSPECT,nbslices,length,width);

 //Info
 printf("\n\n       > Tranche numero              [%d]",SliceNumber);
 }


//----------------------------------------------------------
// Options pour RealSINOG  <FESSLER>           
//----------------------------------------------------------                
void ICD::OptionRealSINOG(char* pathSPECT,char* pathSPECT2,float rcffact)
{   
  int i,j;
       
 //Enregistrement
 flag_RealSPECT=2;
 rcf_factor=rcffact;

 //Loading
 printf("\n       > Loading...      ");
 fflush(stdout);

 //Chargement&Sauvegarde Transmission Sinog
 //load_imageSUN(pathSPECT,SinoRealSPECT2[SLC_SPECT],nbslices,width);
 load_imageSUNS(pathSPECT,SinoRealSPECT2[SliceNumber],nbslices,width,(int)ScaleReduc);
 if (ScaleReduc==1) Save_picture_pgm("","SinoSpectBrute","",SinoRealSPECT2[SliceNumber],nbslices,width);

 //Chargement&Sauvegarde Blank
 //load_imageSUN2(pathSPECT2,SinoRealSPECT[SliceNumber],nbslices,width);
 load_imageSUNS2(pathSPECT2,SinoRealSPECT[SliceNumber],nbslices,width,(int)ScaleReduc);
 if (ScaleReduc==1) Save_picture_pgm("","BlankSpectBrute","",SinoRealSPECT[SliceNumber],nbslices,width);

 // >> Take the ratio of transmission [Transmission/blank]
 for(i=0;i<nbslices;i++) for(j=0;j<width;j++)
    { if (SinoRealSPECT[SliceNumber][i][j]==0) SinoRealSPECT[SliceNumber][i][j]=0.1;
      SinoRealSPECT2[SliceNumber][i][j]=SinoRealSPECT2[SliceNumber][i][j]/SinoRealSPECT[SliceNumber][i][j]; }

 //>> Smooth Sinogram 2D Gaussian Kernel (radially >> 1ere valeur petite)
 //>> 30-30 ou 60-60
 printf(" [smooth=%d]",CuttOff); 
 copy_matrix(SinoRealSPECT2Raw,SinoRealSPECT2[SliceNumber],nbslices,width);
 GaussianFilterImgNS(SinoRealSPECT2[SliceNumber],nbslices,width,CuttOff,CuttOff); 

 //>> Take the negative Log
 for(i=0;i<nbslices;i++) for(j=0;j<width;j++) 
 SinoRealSPECT2[SliceNumber][i][j]=-log(SinoRealSPECT2[SliceNumber][i][j]);

 //>>Recal? ou Positive ou Info
 //Recal3(SinoRealSPECT2[SliceNumberT],nbslices,width);
 //Positive(SinoRealSPECT2[SliceNumber],nbslices,width);
 Info(SinoRealSPECT2[SliceNumber],nbslices,width);

 //Verif
 if (ScaleReduc==1) RecalSave_picture_pgm("","SinoSpectCorrected","",SinoRealSPECT2[SliceNumber],nbslices,width);
}

//--------------------//
//------- ICD --------//
//--------------------//
//----------------------------------------------------------
// ICD_Init
//----------------------------------------------------------
void ICD::ICD_Init()
{
 int cpt;
 float rsbold;
 float mmseold;
 float rsb=0.0; 
 float mmse;
 float k=0.0;

  //Energie Initiale
   ConvertMatVct(mat_reconst,VectImgF,length,width);
   printf("\n\n           <SNR=%.3f> <MMSE=%.4f>",ComputeSNR(mat_img,mat_reconst),ComputeMMSE(mat_img,mat_reconst));
   printf("\n\n           NbGreyLevels: %d\n",NbGreyLevels); 

  //RSBmin
   printf("\n           RSB");
   printf("\n           ---");
   rsbold=-100000;
   cpt=0;
   for(k=0.001;k<1.2;k+=0.00005)
      { CopySquareMatrix(mat_reconst,mat_tmp4,size);
        Mult(mat_tmp4,k,length,width);
        rsb=ComputeSNR(mat_img,mat_tmp4);
        cpt++;
        if (rsb>rsbold) rsbold=rsb; 
        else break;  } 

  //Info-RSB
   ScalePhantom=k-0.00005;
   printf("\n           k=%.5f (%d) > <SNR=%.5f><SNR=%.5f> <MMSE=%.4f>",k,cpt,rsb,rsbold,ComputeMMSE(mat_img,mat_tmp4)); 
   printf("\n"); 

  //LS Radon
   printf("\n           LeastSquare-Reconstruction");
   printf("\n           --------------------------");
   mmseold=100000;
   cpt=0;
   for(k=0.001;k<1.2;k+=0.00005)
      { CopySquareMatrix(mat_reconst,mat_tmp4,size);
        Mult(mat_tmp4,k,length,width);
        mmse=ComputeMMSE(mat_img,mat_tmp4);
        cpt++;
        if (mmse<mmseold) mmseold=mmse; 
        else break;  } 

  //Info-RSB
   printf("\n           k=%.5f (%d) > <MMSE=%.5f><MMSE=%.5f>",k,cpt,mmse,mmseold); 
   printf("\n"); 

  //LS Radon
  printf("\n\n           LeastSquare-Radon");
  printf("\n           -----------------\n");
  
  LSCorrectionInitImg(ScalePhantom);
  printf("\n           Scale=%.5f >  <SNR=%.5f> <MMSE=%.4f>\n",ScalePhantom,ComputeSNR(mat_img,mat_reconst),ComputeMMSE(mat_img,mat_reconst)); 

  //Recalage 0-(NbGreyLevels-1)
  printf("\n           >>RECALAGE\n");
  MinMaxSquareMat(mat_reconst,size,0,(NbGreyLevels-1));

  //Copiage
  CopySquareMatrix(mat_reconst,mat_reconstBestMAP,size);
}

//--------------------//
//------- ICD --------//
//--------------------//
//----------------------------------------------------------
// ComputeProjectMatrix
//                       Resultat |>> Project
//----------------------------------------------------------
void ICD::ComputeProjectMatrix()
{
 int i,j;
 int theta;
 int col_inf,col_sup;
 int row_inf,row_sup;
 float row,col;
 float t,u;
 float rotat;

  //Presentation
  printf("\n\n       > Calcul Matrice P [%d x %d] ",width*nbslices,length*width);
  printf("\n            ");

  //Init
  for(i=0;i<length_proj;i++) for(j=0;j<width_proj;j++) Project[i][j]=0.0;

  //Calcul Matrice Projection
  for(theta=0;theta<nbslices;theta++)
     {
      //Information
      if ((theta%20)==0) printf("[%d]",theta); fflush(stdout);

      //Rotation Img
      rotat=-theta*PI/nbslices;
      
      for(i=0;i<length;i++) for(j=0;j<width;j++)
         {
          col=cos(rotat)*(j-width/2)-sin(rotat)*(i-length/2)+(width/2);
          row=sin(rotat)*(j-width/2)+cos(rotat)*(i-length/2)+(length/2);

          col_inf=(int)(col);       
          col_sup=(int)(col+1);
          row_inf=(int)(row);
          row_sup=(int)(row+1);

          t=(col-col_inf);  
          u=(row-row_inf);   

          if ((t<=1)&&(u<=1)&&(t>=0)&&(u>=0))  
          if ((col_inf>=0)&&(row_inf>=0)&&(col_sup<width)&&(row_sup<length))
	     { 
	      Project[(theta*width)+i][(row_inf*width)+col_inf]+=(1-t)*(1-u);   
	      Project[(theta*width)+i][(row_inf*width)+col_sup]+=u*(1-t);       
              Project[(theta*width)+i][(row_sup*width)+col_sup]+=t*u;          
              Project[(theta*width)+i][(row_sup*width)+col_inf]+=t*(1-u);        
             }
         }
    }      
}


//----------------------------------------------------------
// ComputeRadonMatrix
//   mat_radonProj a partir Image reelle
//                              Resultat  |>>  mat_radonProj 
//                                        |>>  Vecty
//----------------------------------------------------------
void ICD::ComputeRadonMatrix()  
{
 int i,j;
 float tmp;
 float nbcount;

 //Img
 for(i=0;i<length;i++) for(j=0;j<width;j++) 
     VectImg[(i*width)+j]=mat_img[i][j];

 //Radon=PxImg
 for(i=0;i<length_proj;i++) 
    { tmp=0.0;
      for(j=0;j<width_proj;j++)  tmp+=Project[i][j]*VectImg[j];

      Vecty[i]=tmp; 
      VectyWithoutNoise[i]=tmp; }

 //Visu
 for(i=0;i<length_radon;i++)  for(j=0;j<width_radon;j++) 
      mat_radonProj[i][j]=Vecty[(i*width_radon)+j];

 //Sauvegarde dans mat_radonProjWithoutNoise 
 nbcount=0;
 for(i=0;i<length_radon;i++)  for(j=0;j<width_radon;j++)
    { mat_radonProjWithoutNoise[i][j]=mat_radonProj[i][j]; 
      nbcount+=mat_radonProjWithoutNoise[i][j]; } 

 //Calcul du NbCount/NbCountMoyen
 printf("\n\n       > Nb Count [%.0f]",nbcount);
 nbcount/=(float)(length_radon);
 printf("\n       > Nb Count Moyens [%.0f] [%d tranches]",nbcount,length_radon);

 //Calcul du NbCount pour qq tranches
 for(i=0;i<length_radon;i++)
     {
      nbcount=0;
      if ((i%30)==0)
      for(j=0;j<width_radon;j++) nbcount+=mat_radonProjWithoutNoise[i][j]; 
      if ((i%30)==0) printf(" [%d>%.0f] ",i,nbcount);
      }
 
 //Recalage
 printf("\n\n           "); 
 CopyNonSquareMatrix(mat_radonProj,mat_radonProj_visu,length_radon,width_radon);
 Recal(mat_radonProj_visu,length_radon,width_radon);
}

//----------------------------------------------------------
// ComputeRadonMatrix de img
//----------------------------------------------------------
void ICD::ComputeNewShortRadonMatrix(float** mtrad,float** img)  
{
 int i,j;
 int nbpx;
 float tmp;

 //Img
 for(i=0;i<length;i++) for(j=0;j<width;j++) VectImgF[(i*width)+j]=img[i][j];

 //Radon=PxImg
 for(i=0;i<length_proj;i++) 
    { tmp=0.0;
      for(j=0;j<width_shortproj;j++)  
         { 
          nbpx=(int)ShortProject[0][i][j];
          if (nbpx==-1) break;
          tmp+=ShortProject[1][i][j]*VectImgF[nbpx]; 
         }

      Vecty[i]=tmp; }

 //Visu
 for(i=0;i<length_radon;i++)  for(j=0;j<width_radon;j++) 
      mtrad[i][j]=Vecty[(i*width_radon)+j];
}

//----------------------------------------------------------
// Compute Poisson Noise                                
//----------------------------------------------------------
void ICD::ComputePoissonNoise(float** mat,int lgth, int wdth)  
{
 int i,j;
 float rmoynoise,vnoise;

 //Calcul de la moyenne bruit
 rmoynoise=0.0;
 for(i=0;i<lgth;i++)  for(j=0;j<wdth;j++) rmoynoise+=mat[i][j];
 rmoynoise/=(lgth*wdth);
 printf("\n       > Real Mean=%.4f",rmoynoise); 

 //Calcul Variance Bruit
 vnoise=0.0;
 for(i=0;i<lgth;i++)  for(j=0;j<wdth;j++) vnoise+=CARRE(mat[i][j]-rmoynoise);
 vnoise/=(lgth*wdth);
 printf("  Real Variance=%.4f\n",vnoise); 
 fflush(stdout);
}

//----------------------------------------------------------
// Compute RSB Noise                                
//----------------------------------------------------------
void ICD::ComputeRSBNoise(float** matout,float** matin,int lgth,int wdth)  
{
 int i,j;
 float mnoise,vnoise;
 float msig,vsig;
 float rsb;

 //Calcul de la moyenne bruit / Variance Bruit
 mnoise=0.0;
 for(i=0;i<lgth;i++)  for(j=0;j<wdth;j++) mnoise+=matin[i][j];
 mnoise/=(lgth*wdth);
 
 vnoise=0.0;
 for(i=0;i<lgth;i++)  for(j=0;j<wdth;j++) vnoise+=CARRE(matin[i][j]-mnoise);
 vnoise/=(lgth*wdth);

 printf("         [MoyNoise=%.4f  VarNoise=%.4f]   ",mnoise,vnoise); 
 fflush(stdout);

 //Calcul de la moyenne sig / Variance sig
 msig=0.0;
 for(i=0;i<lgth;i++)  for(j=0;j<wdth;j++) msig+=matout[i][j];
 msig/=(lgth*wdth);
 
 vsig=0.0;
 for(i=0;i<lgth;i++)  for(j=0;j<wdth;j++) vsig+=CARRE(matout[i][j]-msig);
 vsig/=(lgth*wdth);

 printf("  [MoySig=%.0f  VarSig=%.0f]",msig,vsig); 
 fflush(stdout);

 //Calcul RSB
 rsb=10*log10(vsig/vnoise);
 printf("  > SNR : %.2f DB\n",rsb);
}

//----------------------------------------------------------
// Add Poisson Noise to Vecty From Tomo
//                              Resultat  |
//                                        |>>  SNR
//----------------------------------------------------------
void ICD::AddPoissonNoiseToVectyFromTomo()  
{
 int i,j;
 float mnoise,vnoise;
 float msignal,vsignal;
 float rmoynoise;
 float rsb;
 float min,max;

 //Sauvegarde
 for(i=0;i<length_proj;i++)  VectyWithoutNoise[i]=Vecty[i];

 //Info
 min=1000000000;
 max=0.0;
 if (SigmaBlur) printf("\n       > Ajout de Blur Sigma=%.3f",SigmaBlur);
 printf("\n       > Ajout de Bruit Poisson Mean/Variance=%.2f",varnoise);
 for(i=0;i<length_proj;i++)
    { if (Vecty[i]>max) max=Vecty[i];
      if (Vecty[i]<min) min=Vecty[i]; }
 printf("\n       >   [min=%.0f -- max=%.0f]",min,max);
 fflush(stdout);

 //Ajout de Blur+Bruit Poisson from tomo
 for(i=0;i<length_radon;i++)  for(j=0;j<width_radon;j++)  
   Vecty[(i*width_radon)+j]=mat_radon[i][j];
 
 //Matrice de Bruit
 for(i=0;i<length_proj;i++)  VectNoise[i]=(Vecty[i]-VectyWithoutNoise[i]);

 //Calcul de la moyenne/variance reelle
 rmoynoise=0.0;
 for(i=0;i<length_proj;i++)  rmoynoise+=VectNoise[i];
 rmoynoise/=(length_proj);

 //Calcul Variance Bruit
 mnoise=0.0;
 vnoise=0.0;
 for(i=0;i<length_proj;i++)  mnoise+=VectNoise[i];
 mnoise/=(length_proj);

 for(i=0;i<length_proj;i++)  vnoise+=CARRE(VectNoise[i]-mnoise);
 vnoise/=(length_proj);

 //Calcul Variance Signal
 msignal=0.0;
 vsignal=0.0;
 for(i=0;i<length_proj;i++)   msignal+=VectyWithoutNoise[i];
 msignal/=(length_proj);

 for(i=0;i<length_proj;i++)  vsignal+=CARRE(VectyWithoutNoise[i]-msignal);
 vsignal/=(length_proj);

 //Calcul RSB
 rsb=10*log10(vsignal/vnoise);
 
 //Affichage
 printf("\n       > SNR : %.2f DB",rsb);
 printf(" [MoyNoise:%.4f  VarNoise:%.0f] [MoySig:%.0f  VarSig:%.0f]",rmoynoise,vnoise,msignal,vsignal);
}


//----------------------------------------------------------
// Compute ProjectionError  e=p-Proj.f
//    a partir                   Vecteur  : p
//                               Matrice  : Proj
//                               Vecteur  : f    (VectImgF)   
//
//                               Resultat  |>>  VectProj
//                                         |>>  VectProjError
//----------------------------------------------------------
void ICD::ComputeProjectionError()
{
 int i,j;
 float tmp;


 //Erreur de Projection
 printf("\n       > Calcul Projection Error");
 for(i=0;i<length_proj;i++) 
    { tmp=0.0;
      for(j=0;j<width_proj;j++)  tmp+=Project[i][j]*VectImgF[j];

      VectProj[i]=tmp;
      VectProjError[i]=Vecty[i]-tmp; }
}

//----------------------------------------------------------
// ComputeVarianceProjection
//         Resultat dans DiagVariance
//----------------------------------------------------------
void ICD::ComputeVarianceProjection()
{
 int i,j,k;
 float tmp;
 float minvar;
 float maxvar;

 //Initialisation
 minvar=100000000;
 maxvar=0;

 //Calcul Variance Projection
 if (Dvariance==1) 
    { printf("\n       > Calcul Variance Projections"); 
      fflush(stdout);
         for(i=0;i<length_radon;i++)  for(j=0;j<width_radon;j++)
            {
	     if (mat_radonProj[i][j]>maxvar) maxvar=mat_radonProj[i][j];
             if (mat_radonProj[i][j]<minvar) minvar=mat_radonProj[i][j];
            }

      printf("  <%.0f - %.0f>",minvar,maxvar);    
 
         for(i=0;i<length_radon;i++)  for(j=0;j<width_radon;j++)
            {
	     tmp=exp(-mat_radonProj[i][j]/maxvar);
             DiagVariance[(i*width_radon)+j]=tmp;   
            }   
    }
 
 if (Dvariance==0)
    { printf("\n       > Variance Projections Identiques"); 
      for(k=0;k<length_proj;k++) DiagVariance[k]=1.0;
    }
}


//----------------------------------------------------------
// ComputeLikelihood
//----------------------------------------------------------
float ICD::ComputeLikelihood()
{
 int i,j,k;
 float tmp;
 float tmpL;
 int   nbpx;

 //Calcul de VectProjError
  for(i=0;i<length_proj;i++) 
    { tmp=0.0;
       for(j=0;j<width_shortproj;j++)  
         { 
          nbpx=(int)ShortProject[0][i][j];
          if (nbpx==-1) break;
          tmp+=ShortProject[1][i][j]*VectImgF[nbpx]; 
         }
      VectProjError[i]=Vecty[i]-tmp; }
 
 //Calcul Likelihood
 //-----------------
 tmpL=0.0;
 for(k=0;k<length_proj;k++)
   tmpL+=DiagVariance[k]*(CARRE(VectProjError[k]));
 
 //NrjMAP
 NrjLikelihood=tmpL;
 
 //Retour
 return NrjLikelihood;
}

//----------------------------------------//
//----------------------------------------//
//------- OPTIMISATION-PROJECTION --------//
//----------------------------------------//
//----------------------------------------//
//----------------------------------------------------------
// ComputeNewShortProjectMatrix
//            ShortProject  
//            ShortProject2
//
//----------------------------------------------------------
void ICD::ComputeNewShortProjectMatrix()
{
 int i,j,k;
 int tmp;
 int cpt;
 float gain;

 //Stat-Width
 width_shortproj=0;
 for(i=0;i<length_proj;i++) 
    { tmp=0;
      for(j=0;j<width_proj;j++) if (Project[i][j]) tmp++;
  
      //Largeur max
      if (tmp>width_shortproj) width_shortproj=tmp; }

 //Gain
 gain=(length_proj*width_proj)/(2.0*length_proj*width_shortproj);

 //Info
 printf("\n       > Optimisation ProjectionMatrix-1-");
 printf("\n           2 x Longeur=%d x LargeurMax=%d",length_proj,width_shortproj);
 printf("\n           Gain=%f",gain);
 fflush(stdout);

 //Stat-Length
 length_shortproj=0;
 for(j=0;j<width_proj;j++) 
    { tmp=0;
      for(i=0;i<length_proj;i++) if (Project[i][j]) tmp++;
  
      //Largeur max
      if (tmp>length_shortproj) length_shortproj=tmp; }

 //Gain
 gain=(length_proj*width_proj)/(2.0*length_shortproj*width_proj);

 //Info
 printf("\n       > Optimisation ProjectionMatrix-2-");
 printf("\n           2 x LongeurMax=%d x Largeur=%d",length_shortproj,width_proj);
 printf("\n           Gain=%f",gain);
 fflush(stdout);

 //Allocation Memoire
 printf("\n           Allocation Memoire .");
 ShortProject=fmatrix_allocate_3d(2,length_proj,width_shortproj);
 ShortProject2=fmatrix_allocate_3d(2,length_shortproj,width_proj); 

 //InitRemplissage
 for(i=0;i<length_proj;i++) for(j=0;j<width_shortproj;j++) 
    { ShortProject[0][i][j]=-1.0;
      ShortProject[1][i][j]=0.0; }
 printf(".");
 fflush(stdout);
 
 for(k=0;k<2;k++)
 for(i=0;i<length_shortproj;i++) for(j=0;j<width_proj;j++) 
    { ShortProject2[0][i][j]=-1.0;
      ShortProject2[1][i][j]=0.0; }
 printf(".\n\n");
 fflush(stdout);

 //RemplissageShortProject
 for(i=0;i<length_proj;i++) 
    {  
     cpt=0;
     for(j=0;j<width_proj;j++) if (Project[i][j]) 
        {
         ShortProject[0][i][cpt]=j;
         ShortProject[1][i][cpt]=Project[i][j];
         cpt++;
        }
    }

 //RemplissageShortProject2
 for(j=0;j<width_proj;j++) 
    {  
     cpt=0;
     for(i=0;i<length_proj;i++) if (Project[i][j]) 
        {
         ShortProject2[0][cpt][j]=i;
         ShortProject2[1][cpt][j]=Project[i][j];
         cpt++;
        }
    }

 //Elimination de Project
 flag_ShortProject=1;
 if (Project) free_fmatrix_2d(Project); 
}

//----------------------------------------------------------
// ComputeNewShortProjectionError  e=p-Proj.f
//
//                               e=VectProjError
//
//    a partir                   Vecteur  : p
//                               Matrice  : ShortProj
//                               Vecteur  : f    (VectImgF)   
//
//                               Resultat  |>>  VectProj
//                                         |>>  VectProjError
//----------------------------------------------------------
void ICD::ComputeNewShortProjectionError()
{
 int i,j;
 int nbpx;
 float tmp;

 //Erreur de Projection
 for(i=0;i<length_proj;i++) 
    { tmp=0.0;
      for(j=0;j<width_shortproj;j++)  
         { 
          nbpx=(int)ShortProject[0][i][j];
          if (nbpx==-1) break;
          tmp+=ShortProject[1][i][j]*VectImgF[nbpx]; 
         }

      VectProj[i]=tmp;
      VectProjError[i]=Vecty[i]-tmp; }
}

//--------------------------//
//-- PRIOR <GAUSS-MARKOV> --//
//--------------------------//
//----------------------------------------------------------
// ComputeGMderive
//----------------------------------------------------------
float ICD::ICD0_ComputeGMderive(int rw,int cl)
{
 float tmp;

 //Calcul Gamma.Proj.f
 tmp=mat_reconst[rw][cl];

 if ((rw+1)<length)   tmp-=0.25*mat_reconst[rw+1][cl];   
 if ((rw-1)>0)        tmp-=0.25*mat_reconst[rw-1][cl];   
 if ((cl+1)<width)    tmp-=0.25*mat_reconst[rw][cl+1];   
 if ((cl-1)>0)        tmp-=0.25*mat_reconst[rw][cl-1];   

 tmp=(2*Gamma)*tmp;
  
 //Retour
 return tmp;
}

//----------------------------------------------------------
// ICD0_ComputeMAP 
//      f > mat_reconst
//----------------------------------------------------------
float ICD::ICD0_ComputeMAP2()
{
 int i,j,k;
 float tmp;
 float tmpL;
 float tmpP;
 int   nbpx;

 //Calcul de VectProjError
  if (!flag_ShortProject)
  for(i=0;i<length_proj;i++) 
    { tmp=0.0;
      for(j=0;j<width_proj;j++)  tmp+=Project[i][j]*VectImgF[j];
      VectProjError[i]=Vecty[i]-tmp; }

  if (flag_ShortProject)
  for(i=0;i<length_proj;i++) 
    { tmp=0.0;
       for(j=0;j<width_shortproj;j++)  
         { 
          nbpx=(int)ShortProject[0][i][j];
          if (nbpx==-1) break;
          tmp+=ShortProject[1][i][j]*VectImgF[nbpx]; 
         }
      VectProjError[i]=Vecty[i]-tmp; }
 
 //Calcul Likelihood
 //-----------------
 tmpL=0.0;
 for(k=0;k<length_proj;k++)
     tmpL+=DiagVariance[k]*(CARRE(VectProjError[k]));

 //Calcul Prior
 //------------
 // >Convolution R.f > mat_tmp2
 tmpP=0.0;
 for(i=0;i<length;i++) for(j=0;j<width;j++)
    { 
     tmpP=mat_reconst[i][j];

     if (i>0)             tmpP-=(0.25*mat_reconst[i-1][j]);  
     if (i<(length-1))    tmpP-=(0.25*mat_reconst[i+1][j]); 
     if (j>0)             tmpP-=(0.25*mat_reconst[i][j-1]);  
     if (j<(width-1))     tmpP-=(0.25*mat_reconst[i][j+1]);  
 
     mat_tmp2[i][j]=tmpP; 
    }

 // >ft.(R.f)
 tmpP=0.0;
 for(i=0;i<length;i++) for(j=0;j<width;j++)  tmpP+=mat_tmp2[i][j]*mat_reconst[i][j];
 
 //NrjMAP
 NrjLikelihood=tmpL;
 NrjPrior=tmpP;
 NrjMAP=tmpL+Gamma*tmpP;
 
 //Retour
 return NrjMAP;
}

//------------------------------//
//------- PRIOR <GGMRF> --------//
//------------------------------//
//-----------------------------------------------------------------
// ComputeTheta1 
//     theta1 = Sum_length_proj  Proj (1- Vecty/[Proji mat_reconst])
//            = Sum_length_proj  Proj (1- Vecty/VectProj)
//-----------------------------------------------------------------
float ICD::ICD1_ComputeTheta1(int np)
{
 int k;
 float tmp;

 //Calcul theta1= Proj (1- Vecty/[Proji mat_reconst])
 tmp=0.0;
 for(k=0;k<length_proj;k++) if (VectProj[k]) tmp+=Project[k][np]*(1-(Vecty[k]/VectProj[k])); 

 //Retour
 return tmp;
}

//----------------------------------------------------------
// ComputeTheta1 theta2 = Sum_length_proj Vecty 
//                                   SQUARE(Proji/VectProj)
//                      
//----------------------------------------------------------
float ICD::ICD1_ComputeTheta2(int np)
{
 int k;
 float tmp;

 //Calcul theta2= Sum_ Proj Vecty (Proji/VectProj)
 tmp=0.0;
 for(k=0;k<length_proj;k++) if (VectProj[k]) tmp+=Vecty[k]*CARRE(Project[k][np]/VectProj[k]);       

 //Retour
 return tmp;
}

//----------------------------------------------------------
// UpdateProjection : p[n+1]=Proj*j (new-old) + p[n]
//                      
//----------------------------------------------------------
void ICD::ICD1_UpdateProjection(int np,float nw,float old)
{
 int k;

 //Calcul p[n+1]
 for(k=0;k<length_proj;k++)  
     VectProj[k]=VectProj[k]+Project[k][np]*(nw-old);
}

//----------------------------------------------------------
// ComputeGGMRFderive
//----------------------------------------------------------
float ICD::ICD1_ComputeGGMRFderive(int rw,int cl,float val)
{
  float tmp,tmp2;
 float signe;

 //Init
 tmp=0.0;

 //Cliques Horiz/Verticales
 if ((rw+1)<length)   
    { tmp2=CLIQUE_HVER*powf(fabs(val-mat_reconst[rw+1][cl]),Qprior-1);
      signe=(fabs(val-mat_reconst[rw+1][cl]))/(val-mat_reconst[rw+1][cl]);
      if (!isnan(signe)) tmp2*=signe;
      tmp+=tmp2; }
    
 if ((rw-1)>0)        
   { tmp2=CLIQUE_HVER*powf(fabs(val-mat_reconst[rw-1][cl]),Qprior-1);
     signe=(fabs(val-mat_reconst[rw-1][cl]))/(val-mat_reconst[rw-1][cl]);
     if (!isnan(signe)) tmp2*=signe;
     tmp+=tmp2; }

 if ((cl+1)<width)    
   { tmp2=CLIQUE_HVER*powf(fabs(val-mat_reconst[rw][cl+1]),Qprior-1);
     signe=(fabs(val-mat_reconst[rw][cl+1]))/(val-mat_reconst[rw][cl+1]);
     if (!isnan(signe)) tmp2*=signe;
     tmp+=tmp2; }

 if ((cl-1)>0)        
    { tmp2=CLIQUE_HVER*powf(fabs(val-mat_reconst[rw][cl-1]),Qprior-1);
      signe=(fabs(val-mat_reconst[rw][cl-1]))/(val-mat_reconst[rw][cl-1]);
      if (!isnan(signe)) tmp2*=signe;
      tmp+=tmp2; }

 //Cliques Diagonales
 if (((rw+1)<length)&&((cl+1)<width))
    { tmp2=CLIQUE_DIAG*powf(fabs(val-mat_reconst[rw+1][cl+1]),Qprior-1);
      signe=(fabs(val-mat_reconst[rw+1][cl+1]))/(val-mat_reconst[rw+1][cl+1]);
      if (!isnan(signe)) tmp2*=signe;
      tmp+=tmp2; }

 if (((rw-1)>0)&&((cl-1)>0))
    { tmp2=CLIQUE_DIAG*powf(fabs(val-mat_reconst[rw-1][cl-1]),Qprior-1);
      signe=(fabs(val-mat_reconst[rw-1][cl-1]))/(val-mat_reconst[rw-1][cl-1]);
      if (!isnan(signe)) tmp2*=signe;
      tmp+=tmp2; }

 if (((rw+1)<length)&&((cl-1)>0))
    { tmp2=CLIQUE_DIAG*powf(fabs(val-mat_reconst[rw+1][cl-1]),Qprior-1);
      signe=(fabs(val-mat_reconst[rw+1][cl-1]))/(val-mat_reconst[rw+1][cl-1]);
      if (!isnan(signe)) tmp2*=signe;
      tmp+=tmp2; }

 if (((rw-1)>0)&&((cl+1)<width))
    { tmp2=CLIQUE_DIAG*powf(fabs(val-mat_reconst[rw-1][cl+1]),Qprior-1);
      signe=(fabs(val-mat_reconst[rw-1][cl+1]))/(val-mat_reconst[rw-1][cl+1]);
      if (!isnan(signe)) tmp2*=signe;
      tmp+=tmp2; }

 //Cst
 tmp*=(Qprior)*powf(Gamma,Qprior); 
  
 //Retour
 return tmp;
}

//----------------------------------------------------------
// ICD1_ComputeMAP 
//      f > mat_reconst
//----------------------------------------------------------
float ICD::ICD1_ComputeMAP()
{
 int i,j,k;
 int rw,cl;
 float tmp;
 float tmpL;
 float tmpP;
 int   nbpx;

 //Calcul de VectProjError
  if (!flag_ShortProject)
  for(i=0;i<length_proj;i++) 
    { tmp=0.0;
      for(j=0;j<width_proj;j++)  tmp+=Project[i][j]*VectImgF[j];
      VectProjError[i]=Vecty[i]-tmp; }

  if (flag_ShortProject)
  for(i=0;i<length_proj;i++) 
    { tmp=0.0;
       for(j=0;j<width_shortproj;j++)  
         { 
          nbpx=(int)ShortProject[0][i][j];
          if (nbpx==-1) break;
          tmp+=ShortProject[1][i][j]*VectImgF[nbpx]; 
         }
      VectProjError[i]=Vecty[i]-tmp; }
 
 //Calcul Likelihood
 //-----------------
 tmpL=0.0;
 for(k=0;k<length_proj;k++)
   tmpL+=DiagVariance[k]*(CARRE(VectProjError[k]));

 //Calcul Prior
 //------------
 tmpP=0.0;
 for(rw=0;rw<length;rw++) for(cl=0;cl<width;cl++)
    { 
     //Cliques Horiz/Vertic
     if ((rw+1)<length)  
        tmpP+=CLIQUE_HVER*powf(fabs(mat_reconst[rw][cl]-mat_reconst[rw+1][cl]),Qprior);

     if ((rw-1)>0)        
         tmpP+=CLIQUE_HVER*powf(fabs(mat_reconst[rw][cl]-mat_reconst[rw-1][cl]),Qprior);

     if ((cl+1)<width)
        tmpP+=CLIQUE_HVER*powf(fabs(mat_reconst[rw][cl]-mat_reconst[rw][cl+1]),Qprior);

     if ((cl-1)>0)       
        tmpP+=CLIQUE_HVER*powf(fabs(mat_reconst[rw][cl]-mat_reconst[rw][cl-1]),Qprior);

    //Cliques Diagonales
    if (((rw+1)<length)&&((cl+1)<width))  
       tmpP+=CLIQUE_DIAG*powf(fabs(mat_reconst[rw][cl]-mat_reconst[rw+1][cl+1]),Qprior);

    if (((rw-1)>0)&&((cl-1)>0)) 
       tmpP+=CLIQUE_DIAG*powf(fabs(mat_reconst[rw][cl]-mat_reconst[rw-1][cl-1]),Qprior);

    if (((rw+1)<length)&&((cl-1)>0))
       tmpP+=CLIQUE_DIAG*powf(fabs(mat_reconst[rw][cl]-mat_reconst[rw+1][cl-1]),Qprior);

    if (((rw-1)>0)&&((cl+1)<width))  
       tmpP+=CLIQUE_DIAG*powf(fabs(mat_reconst[rw][cl]-mat_reconst[rw-1][cl+1]),Qprior);
    }

 //Facteur
 tmpP*=powf(Gamma,Qprior);
 
 //NrjMAP
 NrjLikelihood=tmpL;
 NrjPrior=tmpP;
 NrjMAP=tmpL+Gamma*tmpP;
 
 //Retour
 return NrjMAP;
}

//----------------------//
//----Prior <MRP>  -----//
//----------------------//
//----------------------------------------------------------
// ComputeMRPderive
//----------------------------------------------------------
float ICD::ICD2_ComputeMRPderive(int rw,int cl,float val,float** med)
{
 float tmp;

 //Init
 tmp=0.0;

 //Cliques Horiz/Verticales
 if ((rw+1)<length)   if (med[rw+1][cl]) tmp+=((val-med[rw+1][cl])/(med[rw+1][cl]));
 if ((rw-1)>0)        if (med[rw-1][cl]) tmp+=((val-med[rw-1][cl])/(med[rw-1][cl]));
 if ((cl+1)<width)    if (med[rw][cl+1]) tmp+=((val-med[rw][cl+1])/(med[rw][cl+1]));
 if ((cl-1)>0)        if (med[rw][cl-1]) tmp+=((val-med[rw][cl-1])/(med[rw][cl-1]));
  
 //Retour
 return tmp;
}

//----------------------------------------------------------
// ICD2_ComputeMAP 
//      f > mat_reconst
//----------------------------------------------------------
float ICD::ICD2_ComputeMAP(float** med)
{
 int i,j,k;
 int rw,cl;
 float tmp;
 float tmpL;
 float tmpP;
 int   nbpx;

 //Calcul de VectProjError
  if (!flag_ShortProject)
  for(i=0;i<length_proj;i++) 
    { tmp=0.0;
      for(j=0;j<width_proj;j++)  tmp+=Project[i][j]*VectImgF[j];
      VectProjError[i]=Vecty[i]-tmp; }

  if (flag_ShortProject)
  for(i=0;i<length_proj;i++) 
    { tmp=0.0;
       for(j=0;j<width_shortproj;j++)  
         { 
          nbpx=(int)ShortProject[0][i][j];
          if (nbpx==-1) break;
          tmp+=ShortProject[1][i][j]*VectImgF[nbpx]; 
         }
      VectProjError[i]=Vecty[i]-tmp; }
 
 //Calcul Likelihood
 //-----------------
 tmpL=0.0;
 for(k=0;k<length_proj;k++)  tmpL+=DiagVariance[k]*(CARRE(VectProjError[k]));

 //Calcul Prior
 //------------
 tmpP=0.0;
 for(rw=0;rw<length;rw++) for(cl=0;cl<width;cl++)
    { 
     //Cliques Horiz/Vertic
     if ((rw+1)<length)   if (med[rw+1][cl]) tmpP+=((CARRE(mat_reconst[rw][cl]-med[rw+1][cl]))/(2*med[rw+1][cl]));
     if ((rw-1)>0)        if (med[rw-1][cl]) tmpP+=((CARRE(mat_reconst[rw][cl]-med[rw-1][cl]))/(2*med[rw-1][cl]));
     if ((cl+1)<width)    if (med[rw][cl+1]) tmpP+=((CARRE(mat_reconst[rw][cl]-med[rw][cl+1]))/(2*med[rw][cl+1]));
     if ((cl-1)>0)        if (med[rw][cl-1]) tmpP+=((CARRE(mat_reconst[rw][cl]-med[rw][cl-1]))/(2*med[rw][cl-1]));
    }
 
 //NrjMAP
 NrjLikelihood=tmpL;
 NrjPrior=tmpP;
 NrjMAP=tmpL+(Gamma*tmpP);
 
 //Retour
 return NrjMAP;
}


//----------------------//
//--- Prior <MP> -------//
//----------------------//
//----------------------------------------------------------
// ICD3_MedianFilter3
//       Voisinage 1ere ordre + pixel central
//----------------------------------------------------------
void ICD::ICD3_MedianFilter(float** mt,int sz) 
{
 int i,j,k,l;
 float nrj;
 float min;
 float root;

 float** mat_tmp;
 float* vect;

 //reservation memoire
 mat_tmp=fmatrix_allocate_2d(sz,sz);
 vect=fmatrix_allocate_1d(5);

 //recopie matrice
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) mat_tmp[i][j]=mt[i][j];

 //Filtre median
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)
   {
    //5 voisins
    vect[0]=mat_tmp[i][j];
    if ((i+1)<length)  vect[1]=mat_tmp[i+1][j]; else vect[1]=mat_tmp[i][j];
    if ((j+1)<width)   vect[2]=mat_tmp[i][j+1]; else vect[2]=mat_tmp[i][j];
    if ((i-1)>0)       vect[3]=mat_tmp[i-1][j]; else vect[3]=mat_tmp[i][j];
    if ((j-1)>0)       vect[4]=mat_tmp[i][j-1]; else vect[4]=mat_tmp[i][j];

    min=1000000000;
    root=0;
    for(k=0;k<5;k++)
       {
        nrj=0.0;
	for(l=0;l<5;l++) nrj+=log(coshf(Qprior*(vect[k]-vect[l])));
	nrj/=Qprior;
        if (nrj<min) { min=nrj;  root=k; }
       }

    mt[i][j]=vect[(int)root]; 

    //Debug
    //for(k=0;k<5;k++) printf("[%.0f]",vect[k]);
    //printf(">>>[%.0f]\n",mt[i][j]);
   }

 //liberation memoire
 free_fmatrix_2d(mat_tmp);
 free(vect); 
}

//----------------------------------------------------------
// ComputeMPderive
//----------------------------------------------------------
float ICD::ICD3_ComputeMPderive(int rw,int cl,float val,float** med)
{
 float tmp;

 //Init
 tmp=0.0;

 //Cliques Horiz/Verticales
 if ((rw+1)<length)   if (med[rw+1][cl]) tmp+=tanh(Qprior*(val-med[rw+1][cl]));
 if ((rw-1)>0)        if (med[rw-1][cl]) tmp+=tanh(Qprior*(val-med[rw-1][cl]));
 if ((cl+1)<width)    if (med[rw][cl+1]) tmp+=tanh(Qprior*(val-med[rw][cl+1]));
 if ((cl-1)>0)        if (med[rw][cl-1]) tmp+=tanh(Qprior*(val-med[rw][cl-1]));
  
 //Retour
 return tmp;
}

//----------------------------------------------------------
// ICD3_ComputeMAP 
//      f > mat_reconst
//----------------------------------------------------------
float ICD::ICD3_ComputeMAP(float** med)
{
 int i,j,k;
 int rw,cl;
 float tmp;
 float tmpL;
 float tmpP;
 int   nbpx;

 //Calcul de VectProjError
  if (!flag_ShortProject)
  for(i=0;i<length_proj;i++) 
    { tmp=0.0;
      for(j=0;j<width_proj;j++)  tmp+=Project[i][j]*VectImgF[j];
      VectProjError[i]=Vecty[i]-tmp; }

 if (flag_ShortProject)
  for(i=0;i<length_proj;i++) 
    { tmp=0.0;
       for(j=0;j<width_shortproj;j++)  
         { 
          nbpx=(int)ShortProject[0][i][j];
          if (nbpx==-1) break;
          tmp+=ShortProject[1][i][j]*VectImgF[nbpx]; 
         }
      VectProjError[i]=Vecty[i]-tmp; }
 
 //Calcul Likelihood
 //-----------------
 tmpL=0.0;
 for(k=0;k<length_proj;k++)  tmpL+=DiagVariance[k]*(CARRE(VectProjError[k]));

 //Calcul Prior
 //------------
 tmpP=0.0;
 for(rw=0;rw<length;rw++) for(cl=0;cl<width;cl++)
    { 
     //Cliques Horiz/Vertic
     if ((rw+1)<length)   if (med[rw+1][cl]) tmpP+=log(cosh(Qprior*(mat_reconst[rw][cl]-med[rw+1][cl])));
     if ((rw-1)>0)        if (med[rw-1][cl]) tmpP+=log(cosh(Qprior*(mat_reconst[rw][cl]-med[rw-1][cl])));
     if ((cl+1)<width)    if (med[rw][cl+1]) tmpP+=log(cosh(Qprior*(mat_reconst[rw][cl]-med[rw][cl+1])));
     if ((cl-1)>0)        if (med[rw][cl-1]) tmpP+=log(cosh(Qprior*(mat_reconst[rw][cl]-med[rw][cl-1])));
    }
 
 //NrjMAP
 NrjLikelihood=tmpL;
 NrjPrior=tmpP;
 NrjMAP=tmpL+(Gamma*tmpP);
 
 //Retour
 return NrjMAP;
}

//----------------------//
//--- Prior <ARTUR> ----//
//----------------------//
//----------------------------------------------------------
// ICD4_ComputeMAP 
//      f > mat_reconst
//----------------------------------------------------------
float ICD::ICD4_ComputeMAP()
{
 int i,j,k;
 int rw,cl;
 float tmp;
 float tmpL;
 float tmpP;
 int   nbpx;

 //Calcul de VectProjError
  if (!flag_ShortProject)
  for(i=0;i<length_proj;i++) 
    { tmp=0.0;
      for(j=0;j<width_proj;j++)  tmp+=Project[i][j]*VectImgF[j];
      VectProjError[i]=Vecty[i]-tmp; }

  if (flag_ShortProject)
  for(i=0;i<length_proj;i++) 
    { tmp=0.0;
       for(j=0;j<width_shortproj;j++)  
         { 
          nbpx=(int)ShortProject[0][i][j];
          if (nbpx==-1) break;
          tmp+=ShortProject[1][i][j]*VectImgF[nbpx]; 
         }
      VectProjError[i]=Vecty[i]-tmp; }
 
 //Calcul Likelihood
 //-----------------
 tmpL=0.0;
 for(k=0;k<length_proj;k++)  tmpL+=DiagVariance[k]*(CARRE(VectProjError[k]));

 //Calcul Prior
 //------------
 tmpP=0.0;
 for(rw=0;rw<length;rw++) for(cl=0;cl<width;cl++)
    { 
     //Cliques Horiz/Vertic
     if ((rw+1)<length)   
        tmpP+=(By[rw][cl]*CARRE((mat_reconst[rw+1][cl]-mat_reconst[rw][cl])/Qprior))+PsiGM(By[rw][cl]);   

     if ((cl+1)<width)    
        tmpP+=(Bx[rw][cl]*CARRE((mat_reconst[rw][cl+1]-mat_reconst[rw][cl])/Qprior))+PsiGM(Bx[rw][cl]);
   
  
    //Cliques Diagonales
    if (((rw+1)<length)&&((cl+1)<width))  
       tmpP+=(Bd1[rw][cl]*CARRE((mat_reconst[rw+1][cl+1]-mat_reconst[rw][cl])/(Qprior*sqrt(2.0))))+PsiGM(Bd1[rw][cl]);

    if (((rw+1)<length)&&((cl-1)>0))      
       tmpP+=(Bd2[rw][cl]*CARRE((mat_reconst[rw+1][cl-1]-mat_reconst[rw][cl])/(Qprior*sqrt(2.0))))+PsiGM(Bd2[rw][cl]);

    //Debug
    //printf("[%.2f]",tmpP);
    }
 
 //NrjMAP
 NrjLikelihood=tmpL;
 NrjPrior=tmpP;
 NrjMAP=tmpL+(Gamma*tmpP);
 
 //Retour
 return NrjMAP;
}

//----------------------------------------------------------
// ICD4_computeBxBy <Good>
//----------------------------------------------------------
void ICD::ICD4_computeBxByBd(float** mt,int sz)
{
 int i,j;

 //Boucle
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)
    {
     if ((i+1)<length)                  By[i][j]=PhidGM((mt[i+1][j]-mt[i][j])/Qprior);
     if ((j+1)<width)                   Bx[i][j]=PhidGM((mt[i][j+1]-mt[i][j])/Qprior);      
     if (((i+1)<length)&&((j+1)<width)) Bd1[i][j]=0.5*(PhidGM((mt[i+1][j+1]-mt[i][j])/(Qprior*sqrt(2.0))));
     if (((i+1)<length)&&((j-1)>0))     Bd2[i][j]=0.5*(PhidGM((mt[i+1][j-1]-mt[i][j])/(Qprior*sqrt(2.0))));        
     }  
}

//----------------------------------------------------------
// ComputeARTURderive
//----------------------------------------------------------
float ICD::ICD4_ComputeARTURderive(int rw,int cl,float val)
{
 float tmp;

 //Init
 tmp=0.0;

 //Cliques Horiz/Verticales
 if ((rw+1)<length)  tmp+=(-(2/Qprior)*By[rw][cl]*((mat_reconst[rw+1][cl]-val)/Qprior));
 if ((cl+1)<width)   tmp+=(-(2/Qprior)*Bx[rw][cl]*((mat_reconst[rw][cl+1]-val)/Qprior));

 //Cliques Diagonales
 if (((rw+1)<length)&&((cl+1)<width)) 
     tmp+=(-(2/(Qprior*sqrt(2.0)))*Bd1[rw][cl]*((mat_reconst[rw+1][cl+1]-val)/(Qprior*sqrt(2.0))));
 if (((rw+1)<length)&&((cl-1)>0))     
     tmp+=(-(2/(Qprior*sqrt(2.0)))*Bd2[rw][cl]*((mat_reconst[rw+1][cl-1]-val)/(Qprior*sqrt(2.0))));
 
 //Retour
 return tmp;
}



//-------------//
//-------------//
//--- UTILE ---//
//-------------//
//----------------------------------------------------------
// ComputeBiasVariance
//----------------------------------------------------------
void ICD::ComputeBiasVariance(float** mttrue,float** mtest)
{
 int i,j,k;
 float histo[256];
 int   nbcl;
 int*   TabClasse;
 float* TabProp;
 float* TabBiais;
 float* TabVar;
 float nbpix;
 float moy;
 float bias;
 float var;
 float val;

 //Calcul Nb CLasse
 for(k=0;k<256;k++) histo[k]=0.0;

 for(i=0;i<length;i++) for(j=0;j<width;j++)
   histo[((int)mttrue[i][j])]++;

 for(k=0;k<256;k++) histo[k]/=(length*width);   

 printf("\n\n\n    ");
 nbcl=0;
 for(k=0;k<256;k++) if (histo[k]) { nbcl++; printf("[%d>%.3f]",k,histo[k]); }

 TabClasse=new int[nbcl];
 TabProp=new float[nbcl];
 TabVar=new float[nbcl];
 TabBiais=new float[nbcl];
 for(i=0,k=0;k<256;k++) if (histo[k])  { TabClasse[i]=k; TabProp[i]=histo[k];  i++; }

 if (nbcl<17)
 for(k=0;k<nbcl;k++) printf("-[%d]",TabClasse[k]);
  

 //---Boucle--------
 //-----------------
 if (nbcl<17)
 for(k=0;k<nbcl;k++)
    {
     val=TabClasse[k];

     nbpix=0.0;
     for(i=0;i<length;i++) for(j=0;j<width;j++) if (fabs(mttrue[i][j]-val)<0.01) nbpix++;  
 
     moy=0.0;
     for(i=0;i<length;i++) for(j=0;j<width;j++) if (fabs(mttrue[i][j]-val)<0.01)
       moy+=mtest[i][j];

     moy/=nbpix;
     bias=CARRE(moy-val);
     TabBiais[k]=bias;
     printf("\n  > Bias%d>%.4f:%.1f:",k,bias,(bias/moy)*100);

     var=0.0;
     for(i=0;i<length;i++) for(j=0;j<width;j++) if (fabs(mttrue[i][j]-val)<0.01)
       var+=CARRE(mtest[i][j]-moy);

     var/=nbpix;
     TabVar[k]=var;  

     printf("  Vari [%d]>%.4f",k,var);
     printf("   [%.4f-%.4f]",moy,val);
    }
  //-------------------------------------------

  //Biais-Variance pondere
  bias=0.0;
  var=0.0;
  for(k=0;k<nbcl;k++) 
     { bias+=TabBiais[k]*TabProp[k];
       var+=TabVar[k]*TabProp[k]; }

  printf("\n\n   Biais100>%.4f:: Vari>%.4f",bias,var);

 //Liberation
 delete(TabClasse);
 delete(TabProp);
}

//----------------------------------------------------------
// ComputeSNR
//----------------------------------------------------------
float ICD::ComputeSNR(float** mttrue,float** mtest)
{
 int i,j;
 float VarSignal;
 float MeanSignal;
 float VarNoise;
 float MeanNoise;

 //Bruit
 for(i=0;i<length;i++) for(j=0;j<width;j++) 
    mat_tmp3[i][j]=mttrue[i][j]-mtest[i][j];

 //Variance Signal
 MeanSignal=0.0;
 for(i=0;i<length;i++) for(j=0;j<width;j++)  MeanSignal+=mttrue[i][j];
 MeanSignal/=(length*width);

 VarSignal=0.0;
 for(i=0;i<length;i++) for(j=0;j<width;j++) VarSignal+=CARRE(mttrue[i][j]-MeanSignal);
 VarSignal/=(length*width);

 //Variance Bruit
 MeanNoise=0.0;
 for(i=0;i<length;i++) for(j=0;j<width;j++)  MeanNoise+=mat_tmp3[i][j];
 MeanNoise/=(length*width);

 VarNoise=0.0;
 for(i=0;i<length;i++) for(j=0;j<width;j++) VarNoise+=CARRE(mat_tmp3[i][j]-MeanNoise);
 VarNoise/=(length*width);

 //SNR
 SNR=10*log10(VarSignal/VarNoise);

 //Retour
 return SNR;
}

//----------------------------------------------------------
// MMSE               
//----------------------------------------------------------     
float ICD::ComputeMMSE(float** mat1,float** mat2)
{
 int i,j;
 float sum;
 float norm;

 //Boucle 
 sum=0.0;
 for(i=0;i<length;i++) for(j=0;j<width;j++) 
    sum+=CARRE(mat2[i][j]-mat1[i][j]);

 norm=0.0;
 for(i=0;i<length;i++) for(j=0;j<width;j++)
   norm+=CARRE(mat1[i][j]);

 //MMSE
 MMSE=(sum/norm);

 //retour
 return MMSE;
}

//----------------------------------------------------------
// ComputeError
//----------------------------------------------------------
float ICD::ComputeError(float** mt1,float** mt2,int lgth,int wdth)
{
 int i,j;
 float tmpn,tmpd;
 float error;

 //Boucle
 tmpn=0.0;
 tmpd=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) tmpn+=CARRE(mt1[i][j]-mt2[i][j]);   
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) tmpd+=CARRE(mt1[i][j]);
 error=tmpn/tmpd;

 //Return
 return 100*error;
}

//----------------------------------------------------------
// ComputeError
//----------------------------------------------------------
float ICD::ComputeError2(float** mt1,float** mt2,int lgth,int wdth)
{
 int i,j;
 float tmpn,tmpd;
 float moy1,moy2;
 float error;

 //Calcul Moyenne
 moy1=0.0; moy2=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) moy1+=mt1[i][j];
 moy1/=(lgth*wdth);

 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) moy2+=mt2[i][j];
 moy2/=(lgth*wdth);
 
 //Recalage Moyenne
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mt1[i][j]*=(moy2/moy1);

 //Info
 printf(" [%.3f]",(moy2/moy1));

 //Boucle
 tmpn=0.0; tmpd=0.0;
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) tmpn+=CARRE(mt1[i][j]-mt2[i][j]);   
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) tmpd+=CARRE(mt1[i][j]);
 error=tmpn/tmpd;

 //Return
 return 100*error;
}

//----------------------------------------------------------
// ConvertMatVct
//----------------------------------------------------------
void ICD::ConvertMatVct(float** mt,float* vct,int lgth,int wdth) 
{
 int i,j;

 //Transfert
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) vct[(i*wdth)+j]=mt[i][j];
}


//----------------------------------------------------------
// MedianFilter2
//       Voisinage 1ere ordre + pixel central
//----------------------------------------------------------
void ICD::MedianFilter2(float** mt,int sz) 
{
 int i,j,l,m;
 float tmp;

 float** mat_tmp;
 float* vect;

 //reservation memoire
 mat_tmp=fmatrix_allocate_2d(sz,sz);
 vect=fmatrix_allocate_1d(5);

 //recopie matrice
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) mat_tmp[i][j]=mt[i][j];

 //Filtre median
 for(i=0;i<sz;i++) for(j=0;j<sz;j++)
   {
    vect[0]=mat_tmp[i][j];
    if ((i+1)<length)  vect[1]=mat_tmp[i+1][j]; else vect[1]=mat_tmp[i][j];
    if ((j+1)<width)   vect[2]=mat_tmp[i][j+1]; else vect[2]=mat_tmp[i][j];
    if ((i-1)>0)       vect[3]=mat_tmp[i-1][j]; else vect[3]=mat_tmp[i][j];
    if ((j-1)>0)       vect[4]=mat_tmp[i][j-1]; else vect[4]=mat_tmp[i][j];

    for(l=0;l<4;l++) for(m=0;m<4;m++)
       if (vect[m]>vect[m+1]) 
          { tmp=vect[m];
            vect[m]=vect[m+1];
            vect[m+1]=tmp; } 

    mt[i][j]=vect[2]; 
   }

 //liberation memoire
 free_fmatrix_2d(mat_tmp);
 free(vect); 
}

//----------------------------------------------------------
// Phid GM (t)/2t
//----------------------------------------------------------
float ICD::PhidGM(float val) 
{
 return (1/(CARRE(1+CARRE(val))));
}

//----------------------------------------------------------
// Psi GM
//----------------------------------------------------------
float ICD::PsiGM(float val) 
{
 return (val-(2*sqrt(val))+1);
}

//-------------//
//--- UTILE ---//
//-------------//
//-------------------------------------------------------------
// Recal & Sauvegarde en PGM Path_outNameExt de mat (wdth*lgth)
//-------------------------------------------------------------
void ICD::RecalSave_picture_pgm(char* Path_out,char* Name,char* Ext,float** mat,int wdth,int lgth)
 {
  int i,j;
  char buff[NCHAR];
  FILE* fuser;
  time_t tm;
  float** mattmp;

  //Allocation
  mattmp=fmatrix_allocate_2d(lgth,wdth);
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=mat[i][j]; 

  //Recalage
  Recal3(mattmp,lgth,wdth);

  //extension
  strcpy(buff,Path_out);
  strcat(buff,Name);
  strcat(buff,Ext);
  strcat(buff,".pgm");

  //ouverture fichier
  fuser=fopen(buff,"w");
    if (fuser==NULL) 
        { printf(" probleme dans la sauvegarde de %s",buff); 
          exit(-1); }

  //affichage
  printf("\n         [sauvegarde dans -> %s au format .pgm]",buff);

  //sauvegarde de l'entete
  fprintf(fuser,"P5");
  fprintf(fuser,"\n# IMG Module, %s",ctime(&tm));
  fprintf(fuser,"%d %d",wdth,lgth);
  fprintf(fuser,"\n255\n");
  fflush(stdout);

  //enregistrement
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
  fprintf(fuser,"%c",(char)(mattmp[i][j]+0.49));	
 
  //Liberation
  free_fmatrix_2d(mattmp);
   
  //fermeture fichier
   fclose(fuser); 
 }

//----------------------------------------------------------
// sauvegarde en PGM Path_outNameExt de mat (wdth*lgth)
//----------------------------------------------------------
void ICD::Save_picture_pgm(char* Path_out,char* Name,char* Ext,float** mat,int wdth,int lgth)
 {
  int i,j;
  char buff[NCHAR];
  FILE* fuser;
  time_t tm;

  //extension
  strcpy(buff,Path_out);
  strcat(buff,Name);
  strcat(buff,Ext);
  strcat(buff,".pgm");

  //ouverture fichier
  fuser=fopen(buff,"w");
    if (fuser==NULL) 
        { printf(" probleme dans la sauvegarde de %s",buff); 
          exit(-1); }

  //affichage
  printf("\n         [sauvegarde dans -> %s au format .pgm]",buff);

  //sauvegarde de l'entete
  fprintf(fuser,"P5");
  fprintf(fuser,"\n# IMG Module, %s",ctime(&tm));
  fprintf(fuser,"%d %d",wdth,lgth);
  fprintf(fuser,"\n255\n");
  fflush(stdout);

  //enregistrement
  for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) 
  fprintf(fuser,"%c",(char)(mat[i][j]+0.49));	  
   
  //fermeture fichier
   fclose(fuser); 
 }

//----------------------------------------------------------
// FillResReconstruction  
//----------------------------------------------------------                
void ICD::FillDataReconstruction()
{
 char bufftmp[NCHAR];

 //Info
 strcpy(File_Test,"TESTS");
 sprintf(bufftmp,"-m%d",Method);
 strcat(File_Test,bufftmp);

 sprintf(bufftmp,"_n%d",nbslices);
 strcat(File_Test,bufftmp);
 
 sprintf(bufftmp,"_i%d",init);
 strcat(File_Test,bufftmp);

 sprintf(bufftmp,"_t%d",NbIters);
 strcat(File_Test,bufftmp);

 sprintf(bufftmp,"_r%.1f",Qprior);
 strcat(File_Test,bufftmp);

 sprintf(bufftmp,"_Q%d",NbGreyLevels);
 strcat(File_Test,bufftmp);

 sprintf(bufftmp,"_C%d",WidthBlur);
 strcat(File_Test,bufftmp);
}

//----------------------------------------------------------
// FillResReconstruction  
//----------------------------------------------------------                
void ICD::FillResReconstruction()
{
 char bufftmp[NCHAR];

 //Info
 strcpy(Par_Recons,"");
 sprintf(bufftmp,"-m%d",Method);
 strcat(Par_Recons,bufftmp);

 sprintf(bufftmp,"-M%d",SubMethod);
 strcat(Par_Recons,bufftmp);

 if ((SubMethod==1)||(SubMethod==3)||(SubMethod==4))
    { sprintf(bufftmp,"_Q%.1f",Qprior);
      strcat(Par_Recons,bufftmp); }

 if (Gamma)
    { sprintf(bufftmp,"_g%.3f",Gamma);
      strcat(Par_Recons,bufftmp); }

 sprintf(bufftmp,"_T%d",SliceNumber);
 strcat(Par_Recons,bufftmp);

 sprintf(bufftmp,"_U%d",CuttOff);
 strcat(Par_Recons,bufftmp);

 sprintf(bufftmp,"_t%d",NbIters);
 strcat(Par_Recons,bufftmp);
}

//----------------------------------------------------------
// FillResReconstruction2  
//----------------------------------------------------------                
void ICD::FillResReconstruction2()
{
 char bufftmp[NCHAR];

 if (Method==-15)                                       strcpy(Par_Recons,"PML-B");

 if (Method==-13) 
     { if (SubMethod==-1)                               strcpy(Par_Recons,"PML-EM"); 
       if (SubMethod==-2)                               strcpy(Par_Recons,"PML-EM");
       if (SubMethod==-3)                               strcpy(Par_Recons,"PML-EM");
       if (SubMethod==0)                                strcpy(Par_Recons,"PGM-EM"); 
       if ((SubMethod==1)&&(Qprior==2.0))               strcpy(Par_Recons,"PGGMRFQ2-EM"); 
       if ((SubMethod==1)&&(fabs(Qprior-1.1)<0.01))     strcpy(Par_Recons,"PGGMRFQ1.1-EM"); 
       if ((SubMethod==1)&&(fabs(Qprior-1.5)<0.01))     strcpy(Par_Recons,"PGGMRFQ1.5-EM"); 
       if (SubMethod==2)                                strcpy(Par_Recons,"PRMP-EM");
       if (SubMethod==3)                                strcpy(Par_Recons,"PMP-EM");
       if (SubMethod==4)                                strcpy(Par_Recons,"PARTUR-EM");
       if (SubMethod==5)                                strcpy(Par_Recons,"PMIG1-ALEAT-EM"); 
       if (SubMethod==6)                                strcpy(Par_Recons,"PMIG1-ALEAT2-EM"); 
       if (SubMethod==7)                                strcpy(Par_Recons,"PMIG1-ALEAT2-SUP-EM"); 
       if (SubMethod==8)                                strcpy(Par_Recons,"PMIG1-ALEAT2-FIL-EM"); 
       if (SubMethod==9)                                strcpy(Par_Recons,"PMIG1-FIX-FIL-EM"); 
       if (SubMethod==10)                               strcpy(Par_Recons,"PML-EM-DCT");
       if (SubMethod==11)                               strcpy(Par_Recons,"PML-EM-UDWT16x16");
       if (SubMethod==12)                               strcpy(Par_Recons,"PML-EM-UDWT"); 
       if (SubMethod==13)                               strcpy(Par_Recons,"PML-EM-DCTrs"); 
       if (SubMethod==14)                               strcpy(Par_Recons,"PML-EM-DCTst"); 
       if (SubMethod==15)                               strcpy(Par_Recons,"PML-EM-DCTrsGM"); 
       if (SubMethod==16)                               strcpy(Par_Recons,"PML-EM-DCTrsGM2"); 
       if (SubMethod==17)                               strcpy(Par_Recons,"PML-EM-DCTrs-Alt-GM");  
       if (SubMethod==18)                               strcpy(Par_Recons,"PML-EM-DCTrsDec"); }

       sprintf(bufftmp,"%s",Comment);
       strcat(Par_Recons,bufftmp);

       sprintf(bufftmp,"-g%.3f",Gamma);
       strcat(Par_Recons,bufftmp);

       sprintf(bufftmp,"-U%d",CuttOff);
       strcat(Par_Recons,bufftmp);

       sprintf(bufftmp,"-F%.2f",FactAtten);
       strcat(Par_Recons,bufftmp);

       sprintf(bufftmp,"-T%d",SliceNumber);
       strcat(Par_Recons,bufftmp);
   
       sprintf(bufftmp,"-tc%d",BestMAP_iter);
       strcat(Par_Recons,bufftmp);

       sprintf(bufftmp,"-t%d",NbIters);
       strcat(Par_Recons,bufftmp);

       if (SubMethod==-3)      
	  { sprintf(bufftmp,"-W%d",CuttOff2);
            strcat(Par_Recons,bufftmp); }

       if (value_hyperpar!=1.0)
	 { sprintf(bufftmp,"-div%d",(int)value_hyperpar);
           strcat(Par_Recons,bufftmp); }

       if (Method==-1)
          { 
           if (init==INIT_FBP)   strcpy(Par_Recons,"FBP");
           if (init==INIT_CST)   strcpy(Par_Recons,"CST"); 

           sprintf(bufftmp,"-U%d",CuttOff);
           strcat(Par_Recons,bufftmp);

           sprintf(bufftmp,"-T%d",SliceNumber);
            strcat(Par_Recons,bufftmp);
           }  
}

//----------------------------------------------------------
// AfficheTabIsnr   
//----------------------------------------------------------                
void ICD::AfficheTabSnr(float* vct)
{
 int k;

 //Boucle
 printf("\n");
 for(k=0;k<DIXMILLE;k++)
   if (vct[k]>0.001) printf("\n%d %.4f",k,vct[k]);

 printf("\n\n\n\n");
}

//----------------------------------------------------------
// ComputeL2Error  
//----------------------------------------------------------                
float ICD::ComputeL2Error(float mes1, float mes2)
{
 float tmp;

 tmp=fabs(mes2-mes1)/mes1;

 return tmp;
}


//----------------------------------------------------------
// InfoPhantom
//----------------------------------------------------------
void ICD::InfoPhantom(float** mt,int sz)
{
 int i,j,k;
 int beg,end;

 //Init 
 beg=1;
 end=0;
 
 //Boucle
 printf("\n       > Info Niveaux de Gris : ");
 for(i=0;i<sz;i++) for(j=0;j<sz;j++) VectHist[(int)mt[i][j]]++;

 for(k=0;k<NbGreyLevels;k++) 
    { if ((beg)&&(VectHist[k]))   { printf(" [%d-",k);  beg=0; end=1; }
      if ((end)&&(!VectHist[k]))  { printf("%d]",k-1);  beg=1; end=0; } }

 printf("\n\n");
}

//----------------------------------------------------------
// LSCorrectionInitImg avec Scale
//
//    LeastSquare de  e = p - Proj.f
//                      = [Vecty - VectProj]
//                         SinogBruite - Projection[k mat_reconst]
//                         SinogBruite - Proj.f
//
//          >> Resultat: mat_reconst ajusté au moindre carre
//
//----------------------------------------------------------
void ICD::LSCorrectionInitImg(float sc)
{
 int i,j,l,m;
 float k;
 float* vctt;
 float nrj;
 float min;
 int pos;
 float mult;

 //Init
 vctt=new float[1000];
 for(l=0;l<1000;l++) vctt[l]=100000000000.0;
 for(i=0;i<length;i++) for(j=0;j<width;j++) mat_initreconst[i][j]=mat_reconst[i][j];

 //Boucle
 for(m=0,k=(sc/3.0);k<(sc*2.0);k+=(sc/100.0),m++)
    {
     for(i=0;i<length;i++) for(j=0;j<width;j++) mat_reconst[i][j]=k*mat_initreconst[i][j];

     ConvertMatVct(mat_reconst,VectImgF,length,width);
     ComputeNewShortProjectionError();  

     nrj=0.0;
     for(l=0;l<length_proj;l++) nrj+=SQUARE(Vecty[l]-VectProj[l]);
     nrj/=length_proj;
     nrj/=100;
     vctt[m]=nrj;
    }
   
  //Recherche
  min=1000000000000000.0;
  pos=0;
  for(l=0;l<1000;l++) if (vctt[l]<min) { min=vctt[l]; pos=l; }
 
  //Multiplication
  mult=(pos*(sc/100.0))+(sc/3.0);
  printf("           [>Correction::%.5f] (pos:%d)",mult,pos);
  fflush(stdout);
 
  for(i=0;i<length;i++) for(j=0;j<width;j++) mat_reconst[i][j]=mult*mat_initreconst[i][j];
  ConvertMatVct(mat_reconst,VectImgF,length,width);
  ComputeNewShortProjectionError();

 //Free
 delete vctt;
}

//----------------------------------------------------------
// LSCorrectionInitImg avec Scale
//
//    LeastSquare de  e = p - Proj.f
//                      = [Vecty - VectProj]
//                         SinogBruite - Projection[k mat_reconst]
//                         SinogBruite - Proj.f
//
//          >> Resultat: mat_reconst ajusté au moindre carre
//
//----------------------------------------------------------
void ICD::LSCorrectionInitSPECTImg()
{
 int i,j,l,m,p;
 float k;
 float** vctt;
 float** matt;
 float nrj;
 float min;
 float pos;
 float mult;

 //Init
 vctt=fmatrix_allocate_2d(2,100);
 pos=0;
 matt=fmatrix_allocate_2d(nbslices,width);
 for(i=0;i<nbslices;i++) for(j=0;j<width;j++) matt[i][j]=SinoRealSPECT2[SliceNumber][i][j];

 //  -1- Boucle & Recherche
 for(l=0;l<100;l++) vctt[1][l]=100000000000000.0;
 for(m=0,k=0;k<9000;k+=1000,m++)
    { for(i=0;i<nbslices;i++) for(j=0;j<width;j++) SinoRealSPECT2[SliceNumber][i][j]=k*matt[i][j];
     
      ConvertMatVct(SinoRealSPECT2[SliceNumber],Vecty,nbslices,width);
      ComputeNewShortProjectionError();  

      nrj=0.0; for(l=0;l<length_proj;l++) nrj+=SQUARE(Vecty[l]-VectProj[l]); 
      vctt[0][m]=k; 
      vctt[1][m]=nrj/(100*length_proj); }

 //for(l=0;l<length_proj;l++) printf("[%f][%f] ",Vecty[l],VectProj[l]);
 //printf("\n");
 //for(l=0;l<100;l++) printf("[%f]",vctt[1][l]);

  min=vctt[1][0]; 
  for(l=0;l<100;l++) if (vctt[1][l]<=min) { min=vctt[1][l]; pos=l; }
  mult=vctt[0][(int)pos];
  printf("\n       >[%.3f](%.0f) ",mult,pos);
  fflush(stdout);
   
 //  -2- Boucle & Recherche
 for(p=1;p<6;p++)
    {
     for(l=0;l<100;l++) vctt[1][l]=100000000000000.0;
     for(m=0,k=mult-(1000/pow(10,p-1));k<mult+(1000/pow(10,p-1));k+=100/pow(10,p-1),m++)
        { for(i=0;i<nbslices;i++) for(j=0;j<width;j++) SinoRealSPECT2[SliceNumber][i][j]=k*matt[i][j];
     
          ConvertMatVct(SinoRealSPECT2[SliceNumber],Vecty,nbslices,width);
          ComputeNewShortProjectionError();  

          nrj=0.0; for(l=0;l<length_proj;l++) nrj+=SQUARE(Vecty[l]-VectProj[l]); 
          vctt[0][m]=k;
          vctt[1][m]=nrj/(100*length_proj); }

          min=vctt[1][0]; 
          for(l=0;l<100;l++) if (vctt[1][l]<=min) { min=vctt[1][l]; pos=l; }
          mult=vctt[0][(int)pos];
          printf("[%.3f](%.0f)",mult,pos);
          fflush(stdout);
    }
 

  //Multiplication
  printf("\n");
  for(i=0;i<nbslices;i++) for(j=0;j<width;j++)  SinoRealSPECT2[SliceNumber][i][j]=mult*matt[i][j];
  ConvertMatVct(SinoRealSPECT2[SliceNumber],Vecty,nbslices,width);
  ComputeNewShortProjectionError();

 //Free
 free_fmatrix_2d(vctt);
 free_fmatrix_2d(matt);
}

//----------------------------------------------------------
// Gauss
//----------------------------------------------------------
float ICD::Funcgauss(short pix,float var)
{
return (float)((1/(sqrt(2*PI*var)))*exp(-1*(CARRE((float)pix))/(2*var)));
}

//----------------------------------------------------------
// Ajoute Flou sur la matrice
//----------------------------------------------------------
void ICD::AddBlurOnMatrix(float** matrad,int lgth,int wdth,float sgb)
{
 int i,j,k;
 float** mattmp;
 int wdbl;
 float tmp;
 float sumcoefs;
 float* coef;

 //Calcul & Allocation
 wdbl=(int)(4*sgb);
 printf("\n\n       > Lissage Dim [2*%d]+1  >> ",wdbl);
 coef=new float[(2*wdbl)+1];
 
 //Remplissage Coefs
 for(k=-wdbl;k<=wdbl;k++) coef[k+wdbl]=Funcgauss(k,CARRE(sgb));
 if (wdbl<5) for(k=-wdbl;k<=wdbl;k++) printf("[%.4f]",coef[k+wdbl]);
 sumcoefs=0.0;
 for(k=-wdbl;k<=wdbl;k++) sumcoefs+=coef[k+wdbl];
 printf("\n            (Somme Coefs : %.3f)\n",sumcoefs);

 //Allocation
 mattmp=fmatrix_allocate_2d(length_radon,width_radon); 
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)  mattmp[i][j]=matrad[i][j];

 //Blur-Iteration
 for(i=0;i<lgth;i++)
    {
     for(j=0;j<wdth;j++)
        { 
	 tmp=0.0;  

         for(k=-wdbl;k<=wdbl;k++) if (((j+k)>0)&&((j+k)<width_radon)) 
             tmp+=coef[k+wdbl]*mattmp[i][j+k]; 

         tmp/=(float)sumcoefs;
         matrad[i][j]=(int)tmp;
	}
    }

 //Test
 if (0)
    { printf("\n");
      for(j=0;j<wdth;j++) printf(" [%.0f]",mattmp[6][j]);
      printf("\n\n");
      for(j=0;j<wdth;j++) printf(" [%.0f]",matrad[6][j]);
      printf("\n\n");
      fflush(stdout); }

 //Libere Memoire
 if (mattmp) free_fmatrix_2d(mattmp);
 if (coef)   free_fmatrix_1d(coef);
}

//----------------------------------------------------------
// Ajoute Flou sur le Vecteur
//----------------------------------------------------------
void ICD::AddBlurOnVector(float* vectrad,int lgth,int wdth,float sgb)
{
 int i,j;
 float** mattmp;

 //Allocation
 mattmp=fmatrix_allocate_2d(length_radon,width_radon); 
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mattmp[i][j]=vectrad[(i*wdth)+j];

 //Flou
 AddBlurOnMatrix(mattmp,lgth,wdth,sgb);

 //Visu
 if (0) { printf("\n\n"); for(j=0;j<wdth;j++) printf(" [%.0f]",vectrad[j]); }
 
 //Recup
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) vectrad[(i*wdth)+j]=mattmp[i][j];
 
 //Visu
 if (0) { printf("\n\n"); for(j=0;j<wdth;j++) printf(" [%.0f]",vectrad[j]); }
  
 //Libere Memoire
 if (mattmp) free_fmatrix_2d(mattmp);
}

//----------------------------------------------------------
// ButterworthFilter
//----------------------------------------------------------
void ICD::ButterworthFilter(float** mat,int lgth,int wdth,int ord,float fc)
{
 int i,j;
 float** matr;
 float** mati;
 float dist;

 //Affichage
 printf(" [Length/Width [%d/%d]]",lgth,wdth);

 //Allocation Memoire
 matr=fmatrix_allocate_2d(lgth,wdth);
 mati=fmatrix_allocate_2d(lgth,wdth);

 //Initialisation
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
    { matr[i][j]=mat[i][j];
      mati[i][j]=0.0; }

 //Transformee Fourier
 FFTDD(matr,mati,length,width);
 
 //FiltreButterWorth
 ReMkeImg(matr,length,width);
 ReMkeImg(mati,length,width);

 if (1)
 for(i=-(lgth/2);i<(lgth/2);i++) for(j=-(lgth/2);j<(wdth/2);j++)
    { dist=sqrt((i*i)+(j*j));
      matr[i+(lgth/2)][j+(wdth/2)]*=1.0/(1.0+pow((dist/(fc)),2*ord));
      mati[i+(lgth/2)][j+(wdth/2)]*=1.0/(1.0+pow((dist/(fc)),2*ord)); }

 //Filtre PasseBas ideal
 if (0)
 for(i=-(lgth/2);i<(lgth/2);i++) for(j=-(lgth/2);j<(wdth/2);j++)
    { dist=sqrt((i*i)+(j*j));
      if (dist>fc)
	{ matr[i+(lgth/2)][j+(wdth/2)]=0.0;
   	  mati[i+(lgth/2)][j+(wdth/2)]=0.0; } }


 ReMkeImg(matr,length,width);
 ReMkeImg(mati,length,width); 
 
 //Transformee Fourier Inverse
 IFFTDD(matr,mati,length,width);

 //Copiage
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++) mat[i][j]=matr[i][j];
 
 //Desallocation
 free_fmatrix_2d(matr);
 free_fmatrix_2d(mati);
}

//----------------------------------------------------------
// ButterworthFilterNS
//----------------------------------------------------------
void ICD::ButterworthFilterNS(float** mat,int lh,int wh,int ord,float fc)
{
 int i,j;
 float** matr;
 float** mati;
 float dist;
 int wdth;
 int lgth;
 
 float tmp,tmp2;

 //Init
 wdth=wh; lgth=lh;

 //Verif
 if (!IsPowerOfTwo(lgth))
    {
     tmp=((log(lgth)/log(2)));
     tmp2=(int)tmp;
     tmp=tmp-(int)tmp;
     if (tmp>0.0)
        { tmp2++;
          lgth=(int)pow(2,tmp2);
	  printf("\n       > lgth : [%d->%d]",lh,lgth); 
          fflush(stdout); }
    }

 if (!IsPowerOfTwo(wdth))
    {
     tmp=((log(wdth)/log(2)));
     tmp2=(int)tmp;
     tmp=tmp-(int)tmp;
     if (tmp>0.0)
        { tmp2++;
          wdth=(int)pow(2,tmp2);
	  printf("\n       > wdth : [%d->%d]",wh,wdth); 
          fflush(stdout); }
    }

 //Allocation Memoire
 matr=fmatrix_allocate_2d(lgth,wdth);
 mati=fmatrix_allocate_2d(lgth,wdth);

 //Initialisation
 for(i=0;i<lgth;i++) for(j=0;j<wdth;j++)
     { matr[i][j]=0.0; 
       mati[i][j]=0.0; }

 for(i=0;i<lh;i++) for(j=0;j<wh;j++) matr[i][j]=mat[i][j];

 //Transformee Fourier
 FFTDD(matr,mati,lgth,wdth);
 
 //FiltreButterWorth
 ReMkeImg(matr,lgth,wdth);
 ReMkeImg(mati,lgth,wdth);

 if (1)
 for(i=-(lgth/2);i<(lgth/2);i++) for(j=-(wdth/2);j<(wdth/2);j++)
    { dist=sqrt((i*i)+(j*j));
      matr[i+(lgth/2)][j+(wdth/2)]*=1.0/(1.0+pow((dist/(fc)),2*ord));
      mati[i+(lgth/2)][j+(wdth/2)]*=1.0/(1.0+pow((dist/(fc)),2*ord)); }

 //Filtre PasseBas ideal
 if (0)
 for(i=-(lgth/2);i<(lgth/2);i++) for(j=-(lgth/2);j<(wdth/2);j++)
    { dist=sqrt((i*i)+(j*j));
      if (dist>fc)
	{ matr[i+(lgth/2)][j+(wdth/2)]=0.0;
   	  mati[i+(lgth/2)][j+(wdth/2)]=0.0; } }


 ReMkeImg(matr,lgth,wdth);
 ReMkeImg(mati,lgth,wdth); 
 
 //Transformee Fourier Inverse
 IFFTDD(matr,mati,lgth,wdth);

 //Copiage
 for(i=0;i<lh;i++) for(j=0;j<wh;j++) mat[i][j]=matr[i][j];
 
 //Desallocation
 free_fmatrix_2d(matr);
 free_fmatrix_2d(mati);
}
 
//----------------------------------------------------------
// ButterworthFilter3D
//----------------------------------------------------------
void ICD::ButterworthFilter3D(float*** mat,int dp,int lg,int wd,int ord,int fc)
{
 int i,j,k;
 int nn[4];
 float*** Imag;
 float dist;

 //Initialisation Var
 nn[1]=dp;  nn[2]=lg;  nn[3]=wd;

 //Initialisation Mat
 Imag=fmatrix_allocate_3d(dp,lg,wd);
 for(k=0;k<dp;k++) for(i=0;i<lg;i++) for(j=0;j<wd;j++) Imag[k][i][j]=0.0; 

 printf("\n       > ButterWorth 3D [%d][%d][%d]...",dp,lg,wd);
 fflush(stdout);

 for(k=0;k<dp;k++) for(i=0;i<lg;i++) for(j=0;j<wd;j++) 
     mat[k][i][j]*=pow(-1,k+i+j);
 
 printf("[3D-FFT]");
 fflush(stdout);
 fourn2(mat,Imag,nn,3,+1); 

 printf("[Filtrage]");
 fflush(stdout);

 if (1)
 for(k=-(dp/2);k<(dp/2);k++) for(i=-(lg/2);i<(lg/2);i++) for(j=-(wd/2);j<(wd/2);j++)
    { dist=sqrt((k*k)+(i*i)+(j*j));
      mat[k+(dp/2)][i+(lg/2)][j+(wd/2)]*=1.0/(1.0+pow((dist/(fc)),2*ord));
      Imag[k+(dp/2)][i+(lg/2)][j+(wd/2)]*=1.0/(1.0+pow((dist/(fc)),2*ord)); }

 if (0)
 for(k=-(dp/2);k<(dp/2);k++) for(i=-(lg/2);i<(lg/2);i++) for(j=-(wd/2);j<(wd/2);j++)
    { dist=sqrt((k*k)+(i*i)+(j*j));
    if (dist>fc)
       { mat[k+(dp/2)][i+(lg/2)][j+(wd/2)]=0.0;
         Imag[k+(dp/2)][i+(lg/2)][j+(wd/2)]=0.0; } }

 printf("[Recentrage]");
 fflush(stdout);
 Center3D(mat,dp,lg,wd);
 Center3D(Imag,dp,lg,wd);
 
 printf("[3D-FFT-1]");
 fflush(stdout);
 fourn2(mat,Imag,nn,3,-1);


 //Liberattion
 if (Imag)  free_fmatrix_3d(Imag,dp);
}

//----------------------------------------------------------
// Center3D
//----------------------------------------------------------
void ICD::Center3D(float*** mat,int dp,int lg,int wd)
{
 int i,j,k;
 float*** tmp; 
 int nn[4];

 //Initialisation
  nn[1]=dp;  nn[2]=lg;  nn[3]=wd;
  tmp=fmatrix_allocate_3d(dp,lg,wd);
  
  for(k=0;k<dp;k++)  for(i=0;i<lg;i++) for(j=0;j<wd;j++) 
    tmp[k][i][j]=0.0;

  fourn2(mat,tmp,nn,3,-1);

  for(k=0;k<dp;k++) for(i=0;i<lg;i++) for(j=0;j<wd;j++) 
    { mat[k][i][j]*=pow(-1,i+j+k);
      tmp[k][i][j]*=pow(-1,i+j+k); }

  fourn2(mat,tmp,nn,3,+1);

  //Liberation
  free_fmatrix_3d(tmp,dp);
}
